// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.services' is found in services.js
// 'starter.controllers' is found in controllers.js
angular.module('starter', ['ionic',
  'starter.controllers',
  'starter.services',
  'starter.directive',
  'starter.config',
  'starter.filter',
  'ngIOS9UIWebViewPatch',
  'ngCordova',
  'btford.markdown',
  'ionic-audio',
  'ionic-native-transitions'
],['$httpProvider', function($httpProvider){
  // Use x-www-form-urlencoded Content-Type
  $httpProvider.defaults.headers.post['Content-Type'] = 'application/x-www-form-urlencoded;charset=utf-8';
  $httpProvider.defaults.headers.put['Content-Type'] = 'application/x-www-form-urlencoded;charset=utf-8';
  var param = function(obj) {
  var query = '', name, value, fullSubName, subName, subValue, innerObj, i;
  for(name in obj) {
  value = obj[name];
  if(value instanceof Array) {
  for(i=0; i<value.length; ++i) {
  subValue = value[i];
  fullSubName = name + '[' + i + ']';
  innerObj = {};
  innerObj[fullSubName] = subValue;
  query += param(innerObj) + '&';
  }
  }
  else if(value instanceof Object) {
  for(subName in value) {
  subValue = value[subName];
  fullSubName = name + '[' + subName + ']';
  innerObj = {};
  innerObj[fullSubName] = subValue;
  query += param(innerObj) + '&';
  }
  }
  else if(value !== undefined && value !== null)
  query += encodeURIComponent(name) + '=' + encodeURIComponent(value) + '&';
  }
  return query.length ? query.substr(0, query.length - 1) : query;
  };
  // Override $http service's default transformRequest
  $httpProvider.defaults.transformRequest = [function(data) {
  return angular.isObject(data) && String(data) !== '[object File]' ? param(data) : data;
  }];
}])


.run(['$rootScope', 'getHttp', 'defConfig','$ionicPlatform', '$state', 'Auth', 'defConfig', '$ionicPopup', '$location', 'jpushService', "$window", "$ionicHistory", '$interval', 'wxConfig', 'wxConfigInit', 
        function($rootScope, getHttp, defConfig, $ionicPlatform, $state, Auth, defConfig, $ionicPopup, $location, jpushService, $window, $ionicHistory, $interval, wxConfig, wxConfigInit) {
 $ionicPlatform.ready(function() {
   // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
   // for form inputs)
   if (!$rootScope.wxConfiglinkUrl) {
        $rootScope.wxConfiglinkUrl = location.href.split('#')[0];
      }
	 wxConfigInit($rootScope.wxConfiglinkUrl);
	 $rootScope.$on('$stateChangeSuccess', function (event, toState, toParams, fromState, fromParams) {
//		    if (window.cordova) { 
//		       $window.plugins.jPushPlugin.setApplicationIconBadgeNumber(0);
//		     };
		     
		   //路由页面切换asdsadsad
		     var locationPath = $location.path();
		     if (/lists/.test(locationPath)){
		       $rootScope.curNavAvtive = 1;
		     }else if (/resolved/.test(locationPath)){
		       $rootScope.curNavAvtive = 2;
		     }else if (/myMessage/.test(locationPath)){
		       $rootScope.curNavAvtive = 3;
		     }else if (/account/.test(locationPath)){
		       $rootScope.curNavAvtive = 4;
		     }else {
		       $rootScope.curNavAvtive = 0;
		     };
		     
		     var stateName = toState.name;
		     if (stateName !== 'question.questionDetail') {
		    	 var shareImgUrl = 'http://www.dazhili.com/img/wx-share-def.jpg',
               shareTitle = '大智力--人人有价值',
               shareDesc = '来大智力发挥你的才能，寻找你擅长的问题，解决它获得相应的报酬！';
		    	 switch (stateName) {
		    		 case 'question.lists':
		    			 shareTitle = '悬赏大厅-大智力';
		    			 shareDesc = '提出的你的难题，剩下的由大智力来帮你解决';
		    			 break;
		    		 case 'question.resolved':
		    			 shareTitle = '已解决广场-大智力';
		    			 shareDesc = '来大智力发挥你的才能，寻找你擅长的问题，解决它获得相应的报酬！';
		    			 break;
		    		 default:
		    			 shareTitle = '大智力--人人有价值';
		    	 };

		    	 var wxShare = {
    	            title: shareTitle,
    	            link: location.href.split('#')[0],
    	            imgUrl: shareImgUrl,
    	            desc: shareDesc,
    	            success: function() {},
    	            canel: function() {}
    	          }
		    	 wxConfig(wxShare);
		     }
		    if (defConfig.html5Path) {
		       if (_hmt) {
		         _hmt.push(['_trackPageview',$location.$$path]);
		       }
		     }
		    
		    
		    
		   });
   
   if (window.cordova && window.cordova.plugins.Keyboard) {
     cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
     cordova.plugins.Keyboard.disableScroll(true);
   }
   if (window.StatusBar) {
     // org.apache.cordova.statusbar required
     StatusBar.styleDefault();
   }
//    window.addEventListener('native.keyboardshow', keyboardShowHandler);
//
//    function keyboardShowHandler(e){
//        window.scrollTo(0,0)
//    }
   if (window.cordova) { 
     
//   //推送初始化  推送到详细地址
//     var setTagsWithAliasCallback=function(event){
//       //window.alert('result code:'+event.resultCode+' tags:'+event.tags+' alias:'+event.alias);
//     };
//     var openNotificationInAndroidCallback=function(data){
////        var json=data;
////        window.alert(json);
////        if(typeof data === 'string'){
////          json=JSON.parse(data);
////        }
////        var id=json.extras['cn.jpush.android.EXTRA'].id;
////        //window.alert(id);
////        $state.go('/question/account/main',{id:id});
//     };
//     var config={
//       stac:setTagsWithAliasCallback,
//       oniac:openNotificationInAndroidCallback
//     };
//     
//     jpushService.init(config);
     
     
   
   };
   
   
   //登录检测
   Auth.isLoggedIn();
   
   

 $ionicPlatform.registerBackButtonAction(function (e) {
       e.preventDefault();
       function showConfirm() {
         var confirmPopup = $ionicPopup.confirm({
           title: '<strong>退出应用?</strong>',
           template: '你确定要退出应用吗?',
           okText: '退出',
           cancelText: '取消'
         });

         confirmPopup.then(function (res) {
           if (res) {
             ionic.Platform.exitApp();
           } 
           else {
             // Don't close
           }
         });
       }

       // Is there a page to go back to?
       if ($location.path() == '/question/lists' ) {
         showConfirm();
       } else if ($ionicHistory.backView()) {
        $ionicHistory.goBack();
       } else {
         // This is the last page: Show confirmation popup
         showConfirm();
       }

       return false;
     }, 101);
 
 
   
   $rootScope.$on('$stateChangeStart', function (event, toState, toParams, fromState, fromParams) {
     
     //每次请求登录检测
     $interval.cancel($rootScope.reCommun)

     Auth.isLoggedIn().then(function (data) {
       getHttp({
         path:defConfig.path + '/auth/getNotifyCount',
         method: 'get'
       })
       .then(function (data) {
         $rootScope.hasNotify = data.result;
       });
//      
     },function (err) {
//        if (toState.authenticate) {
//          return $rootScope.inLogin();
//        }
     });
//     if (window.cordova) { 
//       $window.plugins.jPushPlugin.setApplicationIconBadgeNumber(0);
//     };
     
       //Then when this scope is destroyed, remove the function
       //$scope.$on('$destroy', deregister);
   });
   
   
   
   
   
   
 });
}])
.config(['$ionicNativeTransitionsProvider', function($ionicNativeTransitionsProvider){
    $ionicNativeTransitionsProvider.setDefaultOptions({
        duration: 400, // in milliseconds (ms), default 400,
        slowdownfactor: 4, // overlap views (higher number is more) or no overlap (1), default 4
        iosdelay: -1, // ms to wait for the iOS webview to update before animation kicks in, default -1
        androiddelay: -1, // same as above but for Android, default -1
        winphonedelay: -1, // same as above but for Windows Phone, default -1,
        fixedPixelsTop: 0, // the number of pixels of your fixed header, default 0 (iOS and Android)
        fixedPixelsBottom: 0, // the number of pixels of your fixed footer (f.i. a tab bar), default 0 (iOS and Android)
        triggerTransitionEvent: '$ionicView.afterEnter', // internal ionic-native-transitions option
        backInOppositeDirection: false // Takes over default back transition and state back transition to use the opposite direction transition to go back
    });
    $ionicNativeTransitionsProvider.setDefaultTransition({
        "type"          : "slide",
        "direction"     : "left", // 'left|right|up|down', default 'left' (which is like 'next')
        "duration"      :  300,
    });
}])
.config(['$stateProvider', '$urlRouterProvider','defConfig', '$locationProvider', '$ionicConfigProvider', function($stateProvider, $urlRouterProvider,defConfig, $locationProvider, $ionicConfigProvider) {
//.config(function($stateProvider, $urlRouterProvider,defConfig) {

  // $ionicConfigProvider.platform.android.tabs.position('bottom');
  // $ionicConfigProvider.platform.android.tabs.style('standard');

  $ionicConfigProvider.platform.ios.tabs.style('standard');
$ionicConfigProvider.platform.ios.tabs.position('bottom');
$ionicConfigProvider.platform.android.tabs.style('standard');
$ionicConfigProvider.platform.android.tabs.position('bottom');
$ionicConfigProvider.platform.ios.navBar.alignTitle('center');
$ionicConfigProvider.platform.android.navBar.alignTitle('center');
// $ionicConfigProvider.platform.ios.backButton.previousTitleText('').icon('ion-ios-arrow-thin-left');
$ionicConfigProvider.platform.android.backButton.previousTitleText('').icon('ion-android-arrow-back');
$ionicConfigProvider.platform.ios.views.transition('ios');
$ionicConfigProvider.platform.android.views.transition('android');


  $stateProvider

  // setup an abstract state for the tabs directive
  .state('question', {
    // cache: false,
    url: '/question',
    abstract: true,
    templateUrl: 'templates/nav/navBar.html'
  })

  // Each tab has its own nav history stack:

  // .state('question.lists', {
  //   url: '/lists',
  //   views: {
  //     'tab-dash': {
  //       templateUrl: 'templates/question/questions.html',
  //       controller: 'questionListCtrl'
  //     }
  //   }
  // })

  

  .state('question.sign', {
    url: "/sign",
    views: {
      'tab-question': {
        templateUrl: "templates/sign.html",
        controller: 'signCtrl'
      }
    }
  })
  .state('question.login', {
    url: "/login",
    views: {
      'tab-question': {
        controller: 'loginCtrl'
      }
    }
  })
  .state('question.home', {
    url: "/home",
    views: {
      'tab-question': {
        templateUrl: "templates/home.html",
        controller: 'homeCtrl'
      }
    }
  })
    .state('question.lists', {
      url: "/lists",
      views: {
        'tab-question': {
          templateUrl: "templates/questions.html",
          controller: 'questionListCtrl'
        }
      }
    })
    .state('question.search', {
      url: "/search",
      views: {
        'tab-question': {
          templateUrl: "templates/searchPage.html",
          controller: 'searchCtrl'
        }
      }
    })
    .state('question.about', {
      url: "/about",
      views: {
        'tab-question': {
          templateUrl: "templates/about.html",
          controller: 'aboutCtrl'
        }
      }
    })
    .state('question.site', {
      url: "/account/site",
      views: {
        'tab-question': {
          templateUrl: "templates/account/site.html",
          controller: 'aboutCtrl'
        }
      }
    })
    .state('question.pact', {
      url: "/pact",
      views: {
        'tab-question': {
          templateUrl: "templates/pact.html",
          controller: 'pactCtrl'
        }
      }
    })
    .state('question.aboutUs', {
      url: "/aboutUs",
      views: {
        'tab-question': {
          templateUrl: "templates/pact.html",
          controller: 'aboutUstCtrl'
        }
      }
    })
    .state('question.resolved', {
      url: "/resolved",
      views: {
        'tab-question': {
          templateUrl: "templates/resolvedList.html",
          controller: 'resolvedCtrl'
        }
      }
    })
    .state('question.my', {
      url: "/account/my",
      views: {
        'tab-question': {
          templateUrl: "templates/myQuestions.html",
          controller: 'myQuestionCtrl'
        }
      },
      authenticate: true
    })
    .state('question.myAnswers', {
      url: "/account/myAnswers",
      views: {
        'tab-question': {
          templateUrl: "templates/myAnswers.html",
          controller: 'myAnswersCtrl'
        }
      },
      authenticate: true
    })
    .state('question.myBuyAnswers', {
      url: "/account/myBuyAnswers",
      views: {
        'tab-question': {
          templateUrl: "templates/myBuyAnswers.html",
          controller: 'myBuyAnswersCtrl'
        }
      },
      authenticate: true
    })
   .state('question.suggest', {
    url: "/suggest",
    views: {
      'tab-question': {
        templateUrl: "templates/suggest.html",
        controller: 'suggestCtrl'
      }
    },
    cache: false,
      authenticate: true
    })
    .state('question.help', {
    url: "/help",
    views: {
      'tab-question': {
        templateUrl: "templates/help.html",
        controller: 'helpCtrl'
      }
    }
    })
    .state('question.helpList', {
      url: "/help/:id",
      views: {
        'tab-question': {
          templateUrl: "templates/helpList.html",
          controller: 'helpListCtrl'
        }
      }
    })
    
    // .state('account', {
    //   url: "/account",
    //   abstract: true,
    //   templateUrl: "templates/menu.html",
    //   controller: 'AppCtrl'
    // })
  
    .state('question.main', {
      url: "/account/main",
      views: {
        'tab-question': {
          templateUrl: "templates/account.html",
          controller: 'accountCtrl'
        }
      },
      authenticate: true
    })
    .state('question.vip', {
      url: "/account/vip",
      views: {
        'tab-question': {
          templateUrl: "templates/vipInfo.html",
          controller: 'vipCtrl'
        }
      },
      authenticate: true
    })
    .state('question.safeInfo', {
      url: "/account/safeInfo",
      views: {
        'tab-question': {
          templateUrl: "templates/safeInfo.html",
          controller: 'safeInfoCtrl'
        }
      },
      authenticate: true
    })
    .state('question.rePassword', {
      url: "/account/rePassword",
      views: {
        'tab-question': {
          templateUrl: "templates/rePassword.html",
          controller: 'rePasswordCtrl'
        }
      },
      authenticate: true
    })
    .state('question.forgetPassword', {
      url: "/account/forgetPassword",
      views: {
        'tab-question': {
          templateUrl: "templates/forgetPassword.html",
          controller: 'forgetPasswordCtrl'
        }
      }
    })
    .state('question.checkEmail', {
      url: "/account/checkEmail",
      views: {
        'tab-question': {
          templateUrl: "templates/checkEmail.html",
          controller: 'checkEmailCtrl'
        }
      },
      authenticate: true
    })
    
    .state('question.payResult', {
      url: "/account/wallet/payResult/:id",
      views: {
        'tab-question': {
          templateUrl: "templates/payResult.html",
          controller: 'payResultCtrl'
        }
      },
      authenticate: true
    })
    .state('question.rechargeRecord', {
      url: "/account/wallet/rechargeRecord",
      views: {
        'tab-question': {
          templateUrl: "templates/wallet-rechargeRecord.html",
          controller: 'rechargeRecordCtrl'
        }
      },
      authenticate: true
    })
    .state('question.withdrawalsRecord', {
      url: "/account/wallet/withdrawalsRecord",
      views: {
        'tab-question': {
          templateUrl: "templates/wallet-withdrawalsRecord.html",
          controller: 'withdrawalsRecordCtrl'
        }
      },
      authenticate: true
    })
    .state('question.rechargeOutlayDetails', {
      url: "/account/wallet/rechargeOutlayDetails",
      views: {
        'tab-question': {
          templateUrl: "templates/wallet-rechargeOutlayDetails.html",
          controller: 'rechargeOutlayDetailsCtrl'
        }
      },
      authenticate: true
    })
    .state('question.wallet', {
      url: "/account/wallet",
      views: {
        'tab-question': {
          templateUrl: "templates/wallet.html",
          controller: 'walletCtrl'
        }
      },
      authenticate: true
    })
    .state('question.myMessage', {
      url: "/myMessage",
      views: {
        'tab-question': {
          templateUrl: "templates/myMessage.html",
          controller: 'myMessageCtrl'
        }
      },
      authenticate: true
    })
    .state('question.argues', {
      url: "/account/argues",
      views: {
        'tab-question': {
          templateUrl: "templates/myArgues.html",
          controller: 'myArguesCtrl'
        }
      },
      authenticate: true
    })
    .state('question.arguesToMe', {
      url: "/account/arguesToMe",
      views: {
        'tab-question': {
          templateUrl: "templates/arguesToMe.html",
          controller: 'arguesToMeCtrl'
        }
      },
      authenticate: true
    })
    .state('question.payBacks', {
      url: "/account/payBacks",
      views: {
        'tab-question': {
          templateUrl: "templates/payBacks.html",
          controller: 'payBacksCtrl'
        }
      },
      authenticate: true
    })
    .state('question.verified', {
      url: "/account/verified",
      views: {
        'tab-question': {
          templateUrl: "templates/verified.html",
          controller: 'verifiedCtrl'
        }
      },
      authenticate: true
    })
    .state('question.account', {
      url: "/account",
      views: {
        'tab-question': {
          templateUrl: "templates/account/menu.html",
          controller: 'accountCtrl'
        }
      },
      authenticate: true
    })
//    .state('account.payBacksToMe', {
//      url: "/payBacksToMe",
//      views: {
//        'tab-question': {
//          templateUrl: "templates/payBacks.html",
//          controller: 'payBacksCtrl'
//        }
//      },
//      authenticate: true
//    })
//    .state('account.businessCard', {
//      url: "/businessCard/:id",
//      views: {
//        'tab-question': {
//          templateUrl: "templates/businessCard.html",
//          controller: 'businessCardCtrl'
//        }
//      }
//    })
    .state('question.businessCard', {
      url: "/businessCard/:id",
      views: {
        'tab-question': {
          templateUrl: "templates/businessCard.html",
          controller: 'businessCardCtrl'
        }
      }
    })
    .state('question.followby', {
      url: "/followby/:id",
      views: {
        'tab-question': {
          templateUrl: "templates/followby.html",
          controller: 'followbyCtrl'
        }
      }
    })
    .state('question.userQuestion', {
      url: "/userQuestion/:id",
      views: {
        'tab-question': {
          templateUrl: "templates/userQuestion.html",
          controller: 'userQuestionCtrl'
        }
      }
    })
    
    .state('question.userAnswer', {
      url: "/userQuestion/:id/:state",
      views: {
        'tab-question': {
          templateUrl: "templates/userAnswer.html",
          controller: 'userAnswerCtrl'
        }
      }
    })
    
    
    .state('question.labels', {
      url: "/labels/:id",
      views: {
        'tab-question': {
          templateUrl: "templates/questionsLabels.html",
          controller: 'questionLabelsCtrl'
        }
      }
    })
    .state('question.assess', {
      url: "/assess/:id",
      views: {
        'tab-question': {
          templateUrl: "templates/assess.html",
          controller: 'assessCtrl'
        }
      }
    })
    .state('question.assessLists', {
      url: "/assessLists/:id",
      views: {
        'tab-question': {
          templateUrl: "templates/moreAssess.html",
          controller: 'assessListsCtrl'
        }
      }
    })
    .state('question.downloadApp', {
      url: "/downloadApp",
      views: {
        'tab-question': {
          templateUrl: "templates/downloadApp.html",
          controller: 'downloadAppCtrl'
        }
      }
    })
    
    
    
    // .state('question.answerDetail', {
    //   url: "/answerDetail",
    //   abstract: true,
    //   templateUrl: "templates/menu.html",
    //   controller: 'AppCtrl'
    // })
  .state('question.im', {
      url: "/answerDetail/im/:id",
      views: {
        'tab-question': {
          templateUrl: "templates/chat.html",
          controller: 'chatCtrl'
        }
      }
    })
    .state('question.imIqid', {
      url: "/answerDetail/im/:id/:iqid",
      views: {
        'tab-question': {
          templateUrl: "templates/chat.html",
          controller: 'chatCtrl'
        }
      }
    })
    .state('question.applyRefund', {
      url: "/answerDetail/applyRefund/:id",
      views: {
        'tab-question': {
          templateUrl: "templates/applyRefund.html",
          controller: 'applyRefundCtrl'
        }
      }
    })
    .state('question.answerDetailId', {
      cache: false,
      url: "/answerDetail/:id",
      views: {
        'tab-question': {
          templateUrl: "templates/answerDetail.html",
          controller: 'answerDetailCtrl'
        }
      }
    })
    

  .state('question.single', {
    url: "/playlists/:playlistId",
    views: {
      'tab-question': {
        templateUrl: "templates/playlist.html",
        controller: 'PlaylistCtrl'
      }
    }
  })
  .state('question.questionDetail', {
	  cache: false,
      url: "/:id",
      views: {
        'tab-question': {
          templateUrl: "templates/questionDetail.html",
          controller: 'questionCtrl'
        }
      }
    });
  
  if (defConfig.html5Path) {
    $locationProvider.html5Mode(true);
  }
  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/question/home');

}]);