angular.module('starter.controllers', [])

.controller('AppCtrl', ['$scope', '$ionicModal', '$timeout', 'getHttp', 'showCode', 'resultTips', 'Auth', '$ionicPopover', 'defConfig', '$rootScope', '$ionicPopup', '$ionicPlatform', '$$localstorage', '$cordovaAppVersion', '$location', 'wxConfigInit',
  function($scope, $ionicModal, $timeout, getHttp, showCode, resultTips, Auth, $ionicPopover, defConfig, $rootScope, $ionicPopup, $ionicPlatform, $$localstorage, $cordovaAppVersion, $location, wxConfigInit) {

    ionic.Platform.ready(function() {
      $scope.isIOS = ionic.Platform.isIOS();
      $scope.isAndroid = ionic.Platform.isAndroid();
      $rootScope.curNavAvtive = 1;
      
      
    //路由页面切换
      var locationPath = $location.path();
      if (/lists/.test(locationPath)){
        $rootScope.curNavAvtive = 1;
      }else if (/resolved/.test(locationPath)){
        $rootScope.curNavAvtive = 2;
      }else if (/myMessage/.test(locationPath)){
        $rootScope.curNavAvtive = 3;
      }else if (/account/.test(locationPath)){
        $rootScope.curNavAvtive = 4;
      }else {
        $rootScope.curNavAvtive = 0;
      };
      
      // wxConfigInit();
      
      // will execute when device is ready, or immediately if the device is already ready.
      if (window.cordova) {
        $scope.isPlatform = true;
        $cordovaAppVersion.getVersionNumber().then(function(version) {
          //如果本地与服务端的APP版本不符合

          getHttp({
              path: '/appUpdate/app/version?time' + new Date().getTime(),
              method: 'get'
            })
            .then(function(data) {
              var iosVersion = data.result.ios.version;
              var androidVersion = data.result.android.version,
                androidVersionFile = data.result.android.fileName;

              $scope.appVersion = data.result;


              //安卓版本
              if ($scope.isAndroid) {
                if (androidVersion > version) {
                  var upApp = $ionicPopup.confirm({
                    title: '提示',
                    template: '有新版本需要更新，建议您使用新版本！',
                    cancelText: '取消',
                    okText: '立即更新'
                  });
                  upApp.then(function(res) {
                    if (res) {
                      window.open(encodeURI($scope.domain + '/appUpdate/app/' + androidVersionFile), '_system');
                    }
                  })
                }
              }

            });



        });
      }
    
    ////android 返回

    //      var deviceInformation = ionic.Platform.device();
    //
    //      var isWebView = ionic.Platform.isWebView();
    //      var isIPad = ionic.Platform.isIPad();
    //      var isIOS = ionic.Platform.isIOS();
    //      var isAndroid = ionic.Platform.isAndroid();
    //      var isWindowsPhone = ionic.Platform.isWindowsPhone();
    //
    //      var currentPlatform = ionic.Platform.platform();
    //      var currentPlatformVersion = ionic.Platform.version();
    //
    //      ionic.Platform.exitApp(); // stops the app

    function is_weixin() {
      var ua = navigator.userAgent.toLowerCase();
      if (ua.match(/MicroMessenger/i) == "micromessenger") {
        $rootScope.isWeixin = true;

        return true;
      } else {
        $rootScope.isWeixin = false;
        return false;
      }
    }


    is_weixin();



    $scope.loginData = {};
    $scope.domain = defConfig.url;

    if (!defConfig.html5Path) {
      $scope.html5Path = '#';
    }



    Auth.isLoggedIn()
      .then(function() {
        getHttp({
            path: defConfig.path + '/auth/getNotifyCount',
            method: 'get'
          })
          .then(function(data) {
            $rootScope.hasNotify = data.result;
            //          if(data.result.nCount > 0) {
            //            $scope.isHaveNews = true;
            //          }
          });
      });




    $scope.login = function(cb) {
      // 登录层


      $ionicModal.fromTemplateUrl('templates/login.html', {
        scope: $scope
      }).then(function(loginModal) {
        $scope.loginModal = loginModal;
        $scope.loginModal.show();
        $scope.closeLogin = function() {
          $scope.loginModal.hide();
        };
      });

      showCode('isShowCodeByLogin', $scope);
      $scope.pageName = "登录";
      $scope.loginNormal = true;
      $scope.loginShow = true;
      $scope.doLogin = function() {
        Auth.login($scope.loginData, $scope, cb);
      };
      $scope.$broadcast('scroll.refreshComplete');
    };

    $rootScope.inLogin = function(cb) {
      $scope.login(cb);
    };



    $scope.openSearch = function($event,toId, toName) {

      if (toId) {
        $scope.quesToId = toId;
        $scope.quesToName = toName;
      }else {
        $scope.quesToId = null;
        $scope.quesToName = null;
      }

      //搜索层
      $ionicModal.fromTemplateUrl('templates/search.html', {
        scope: $scope
      }).then(function(modal) {
        $scope.searchModal = modal;
        $scope.searchModal.show();
      });
      $scope.closeSearchModal = function() {
        $scope.searchModal.hide();
      };
    };


    if ($location.search().search) {
      $scope.openSearch();
    }

    $scope.openGuidePage = function($event) {



      //缓存引导界面
      //        $$localstorage.remove('showGuide');
      //        if ($$localstorage.get('showGuide')) {
      //          return;
      //        }

      $scope.showGuide = $$localstorage.get('showGuide');
      $scope.timerVer = new Date().getTime();
      getHttp({
          path: '/dist/config/config.json?time=' + $scope.timerVer,
          method: 'get'
        })
        .then(function(data) {
          $scope.galleryImages = data.result.list;
//          $scope.promotionConfig = data.result;

          if (!$scope.showGuide || $scope.showGuide != data.result.isShow) {
            $$localstorage.set('showGuide', data.result.isShow)
          } else {
            return;
          }

          
        	  
          
          //引导界面
	          $ionicModal.fromTemplateUrl('templates/guide-page.html', {
	            scope: $scope
	          }).then(function(modal) {
	            $scope.guidePageModal = modal;
	            $scope.guidePageModal.show();
	
	
	            //            $scope.galleryImages = [
	            //                 {
	            //                   url:'/img/guide/guide_1.jpg'
	            //                 },
	            //                 {
	            //                   url:'/img/guide/guide_2.jpg'
	            //                 },
	            //                 {
	            //                   url:'/img/guide/guide_3.jpg'
	            //                 }
	            //            ]
	          });
        })



      $scope.closeGuidePage = function(i, length) {
        if (i == length) {
          $scope.guidePageModal.hide();
          //$$localstorage.set('showGuide', "true");
        }

      };
    };

    if (window.cordova) {
      $scope.openGuidePage();
    }
      
    $$localstorage.remove('showDownAppTips');
    if (!window.cordova && !$$localstorage.get('showDownAppTips')) {

      $scope.showDownAppTips = true;
      $scope.closeDownAppTips = function() {
        $scope.showDownAppTips = false;
        $$localstorage.set('showDownAppTips', true);
      };

    }

  });

  }
])
.controller('homeCtrl',['$scope', '$http', 'defConfig', 'errorInfo', 'Auth', '$interval', 'wxConfig', function ($scope, $http, defConfig, errorInfo, Auth, $interval, wxConfig) {
	//初始数据
  ionic.Platform.ready(function() {
	 $scope.pageName = "大智力";
	var url = defConfig.url + defConfig.path;
	$scope.progressPer = 'progress-'+0;
	var wxShare = {
              title: '悬赏大厅-大智力',
              link: location.href.split('#')[0],
              imgUrl: 'http://www.dazhili.com/img/wx-share-def.jpg',
              desc: '提出的你的难题，剩下的由大智力来帮你解决',
              success: function() {},
              canel: function() {}
            }
    wxConfig(wxShare);
	$scope.homePage = function (cb) {
		
		$http.get(url+'/firstPage')
		.success(function (data){
			
			//异常处理
			
			if (data.error) {
				errorInfo.errMsg(data);
				return;
			}
			 if (typeof cb === "function") cb();
			//数据渲染
			$scope.statistical = data.result;
			if(data.result.beSolve >0){
				var beSolve = data.result.beSolve,
					resolved = data.result.resolved,
					per = (typeof data.result.ratio === 'string') ? Number(data.result.ratio) : data.result.ratio;
				//$scope.progressPer = 'progress-'+per;
				
				var i = 0;
				
				var progressPromise = $interval(function(){
					
					$scope.progressPer = 'progress-'+i;
					if(i == per) {
						return cancelprogressPromise();
					}
					i ++;
				},20);
				function cancelprogressPromise () {
					$interval.cancel(progressPromise);
				};
				
			}
			
		});
	}
	$scope.homePage();
	$scope.doRefresh = function() {
		$scope.homePage(function() {
	        $scope.$broadcast('scroll.refreshComplete');
	      });

	    };
	});
	
}])


.controller('homeListCtrl', ['$scope', '$stateParams', 'loadMore', '$timeout', '$ionicTabsDelegate', '$ionicPopup',
  function($scope, $stateParams, loadMore, $timeout, $ionicTabsDelegate, $ionicPopup) {

    $scope.pageName = "首页";

    $scope.sortFieldParams = {
      sortType: 'hot',
      sequence: 0,
      state: -1,
      path: '/rewardsList'
    };

    function getQuestions(cb) {

      loadMore($scope, 'questionItems', $scope.sortFieldParams, cb);
    };

    getQuestions();
    $scope.doRefresh = function() {
      getQuestions(function() {
        $scope.$broadcast('scroll.refreshComplete');
      });

    };

    $scope.ionDropdown = "ion-android-arrow-dropdown";
    $scope.ionDropdownSec = "ion-android-arrow-dropdown";
    $scope.ionDropdownThr = "ion-android-arrow-dropdown";
    $scope.setSortFieldParams = function(par, index) {
      if ($scope.sortFieldParams.sequence === 1) {
        $scope.sortFieldParams.sequence = 0;
        $scope.ionDropdown = "ion-android-arrow-dropup";
        $scope.ionDropdownSec = "ion-android-arrow-dropup";
        $scope.ionDropdownThr = "ion-android-arrow-dropup";
      } else {
        $scope.sortFieldParams.sequence = 1;
        $scope.ionDropdown = "ion-android-arrow-dropdown";
        $scope.ionDropdownSec = "ion-android-arrow-dropdown";
        $scope.ionDropdownThr = "ion-android-arrow-dropdown";
      }
      $scope.sortFieldParams.sortType = par;
      //$ionicTabsDelegate.select(index);
      loadMore($scope, 'questionItems', $scope.sortFieldParams);
    };
  }
])


.controller('questionListCtrl', ['$scope', '$stateParams', 'loadMore', '$timeout', '$ionicTabsDelegate', '$ionicPopup', 'wxConfig',
    function($scope, $stateParams, loadMore, $timeout, $ionicTabsDelegate, $ionicPopup, wxConfig) {

      $scope.pageName = "悬赏大厅";

      $scope.sortFieldParams = {
        sortType: 'hot',
        sequence: 0,
        path: '/rewardsList'
      };

      function getQuestions(cb) {

        loadMore($scope, 'questionItems', $scope.sortFieldParams, cb);
      };

      getQuestions();
      $scope.doRefresh = function() {
        getQuestions(function() {
          $scope.$broadcast('scroll.refreshComplete');
        });

      };
      var wxShare = {
	            title: '悬赏大厅-大智力',
	            link: location.href.split('#')[0],
	            imgUrl: 'http://www.dazhili.com/img/wx-share-def.jpg',
	            desc: '提出的你的难题，剩下的由大智力来帮你解决',
	            success: function() {},
	            canel: function() {}
	          }
	  wxConfig(wxShare);
      
      $scope.ionDropdown = "ion-android-arrow-dropdown";
      $scope.ionDropdownSec = "ion-android-arrow-dropdown";
      $scope.ionDropdownThr = "ion-android-arrow-dropdown";
      $scope.setSortFieldParams = function(par, index) {
        if ($scope.sortFieldParams.sequence === 1) {
          $scope.sortFieldParams.sequence = 0;
          $scope.ionDropdown = "ion-android-arrow-dropup";
          $scope.ionDropdownSec = "ion-android-arrow-dropup";
          $scope.ionDropdownThr = "ion-android-arrow-dropup";
        } else {
          $scope.sortFieldParams.sequence = 1;
          $scope.ionDropdown = "ion-android-arrow-dropdown";
          $scope.ionDropdownSec = "ion-android-arrow-dropdown";
          $scope.ionDropdownThr = "ion-android-arrow-dropdown";
        }
        $scope.sortFieldParams.sortType = par;
        //$ionicTabsDelegate.select(index);
        loadMore($scope, 'questionItems', $scope.sortFieldParams);
      };
    }
  ])
  .controller('questionLabelsCtrl', ['$scope', '$stateParams', 'loadMore', '$timeout', '$ionicPopup',
    function($scope, $stateParams, loadMore, $timeout, $ionicPopup) {

      $scope.pageName = $stateParams.id;



      //  $scope.settings = {
      //      path:'/auth/findQuesByLabels',
      //      item:'questionItems',
      //      params: {
      //        tag: $stateParams.id
      //      }
      //    };
      $scope.sortFieldParams = {
        path: '/findQuesByLabels',
        tag: $stateParams.id
      };

      function getQuestionLabels(cb) {

        loadMore($scope, 'questionItems', $scope.sortFieldParams, cb);
      };

      getQuestionLabels();
      $scope.doRefresh = function() {
        getQuestionLabels(function() {
          $scope.$broadcast('scroll.refreshComplete');
        });

      };


    }
  ])
  .controller('resolvedCtrl', ['$scope', '$stateParams', 'loadMore', '$timeout', '$ionicPopup',
    function($scope, $stateParams, loadMore, $timeout, $ionicPopup) {

      $scope.pageName = "已解决广场";

      $scope.sortFieldParams = {
        state: 11,
        path: '/rewardsList',
        sortType: 'hot',
        sequence: 1
      };

      function getQuestions(cb) {

        loadMore($scope, 'questionItems', $scope.sortFieldParams, cb);
      };

      getQuestions();
      $scope.doRefresh = function() {
        getQuestions(function() {
          $scope.$broadcast('scroll.refreshComplete');
        });

      };


      $scope.setSortFieldParams = function(par) {
        if ($scope.sortFieldParams.sequence === 1) {
          $scope.sortFieldParams.sequence = 0;
        } else {
          $scope.sortFieldParams.sequence = 1;
        }
        $scope.sortFieldParams.sortType = par;

        loadMore($scope, 'questionItems', $scope.sortFieldParams);
      };

    }
  ])

//我的问题列表
.controller('myQuestionCtrl', ['$scope', '$stateParams', 'loadMore', '$timeout', '$ionicTabsDelegate', 'getHttp', 'defConfig', '$ionicPopup', '$location',
  function($scope, $stateParams, loadMore, $timeout, $ionicTabsDelegate, getHttp, defConfig, $ionicPopup, $location) {
	$scope.listCanSwipe = true;
    $scope.pageName = "我的问题";

    $scope.pageId = 'myQuestion';
    $scope.sortFieldParams = {
      path: '/auth/questionList',
      state: 0
    };

    $scope.active = 0;
    var tabIndex = Number($location.search().tab);

    if (tabIndex == 3) {
      $scope.sortFieldParams.state = 10;
      $scope.active = 3;
      // $timeout(function() {
      //   //$ionicTabsDelegate.select(3);
      // });
    };

    function getQuestions(cb) {

      loadMore($scope, 'questionItems', $scope.sortFieldParams, function(data) {
        if (data.result) {
          $scope.badgeCount = data.result.count;
        }

        if (typeof cb === "function") cb();
      });
    };

    getQuestions();


    $scope.doRefresh = function() {
      getQuestions(function() {
        $scope.$broadcast('scroll.refreshComplete');
      });

    };


    $scope.setSortFieldParams = function(par, index) {


      $scope.sortFieldParams.state = par;

      loadMore($scope, 'questionItems', $scope.sortFieldParams);
      // $ionicTabsDelegate.select(index);
    };

    //删除
    $scope.deleteMyQs = function(q, e) {



      var deleMyds = $ionicPopup.confirm({
        title: '提示',
        template: '确认删除所选问题？',
        cancelText: '取消',
        okText: '确定'
      });
      deleMyds.then(function(res) {
        if (res) {
          getHttp({
              path: defConfig.path + '/auth/removeQuestion',
              method: 'post',
              params: {
                delQIds: q.id
              }
            })
            .then(function(data) {
              if (data.result) {
                angular.element(e.target).parent().addClass('fade-out');
                var index = $scope.questionItems.datas.indexOf(q);
                $scope.badgeCount -= 1;
                if (index > -1) {
                  $scope.$$childHead.questionItems.datas.splice(index, 1);
                }
              };
            });
          //console.log('You are sure');
        } else {
          //console.log('You are not sure');
        }
      });


    };

  }
])


//我的回答列表
.controller('myAnswersCtrl', ['$scope', '$stateParams', 'loadMore', '$timeout', '$ionicTabsDelegate', 'getHttp', 'defConfig', '$ionicPopup',
  function($scope, $stateParams, loadMore, $timeout, $ionicTabsDelegate, getHttp, defConfig, $ionicPopup) {

    $scope.pageName = "我的回答";

    $scope.pageId = 'myQuestion';

    $scope.sortFieldParams = {
      state: 0,
      path: '/auth/myOwnAnswers'
    };

    function getQuestions(cb) {

      loadMore($scope, 'questionItems', $scope.sortFieldParams, cb);
    };

    getQuestions();
    $scope.doRefresh = function() {
      getQuestions(function() {
        $scope.$broadcast('scroll.refreshComplete');
      });

    };


    $scope.setSortFieldParams = function(par, index) {


      $scope.sortFieldParams.state = par;

      loadMore($scope, 'questionItems', $scope.sortFieldParams);
      //$ionicTabsDelegate.select(index);
    };



  }
])



//我购买的答案列表
.controller('myBuyAnswersCtrl', ['$scope', '$stateParams', 'loadMore', '$timeout', '$ionicTabsDelegate', 'getHttp', 'defConfig', '$ionicPopup',
  function($scope, $stateParams, loadMore, $timeout, $ionicTabsDelegate, getHttp, defConfig, $ionicPopup) {

    $scope.pageName = "我购买的答案";


    $scope.sortFieldParams = {
      state: 0,
      path: '/auth/mybuylist'
    };

    function getQuestions(cb) {

      loadMore($scope, 'questionItems', $scope.sortFieldParams, cb);
    };

    getQuestions();
    $scope.doRefresh = function() {
      getQuestions(function() {
        $scope.$broadcast('scroll.refreshComplete');
      });
    };



  }
])

.controller('searchCtrl', ['$scope', '$stateParams', 'defConfig', 'getHttp', '$timeout', 'Auth', '$ionicModal', '$ionicPopup', '$ionicHistory', '$location', '$window',
    function($scope, $stateParams, defConfig, getHttp, $timeout, Auth, $ionicModal, $ionicPopup, $ionicHistory, $location, $window) {
      //搜索

      $scope.searchQs = {};
      $scope.searchQsdocs = [];
      var timePe = [];
      var searchPromise;



      $scope.searchQsTilte = function() {
        var curTime = new Date().getTime(),
          clearTime = 200;

        function timeOutSearch() {
          if ($scope.searchQs.title) {
            var ketWord = $scope.searchQs.title.replace(/(\s*)/g, "").replace(/\?/g, "");
            if (!ketWord) return;
            getHttp({
                path: '/search/qSearch/select',
                method: "post",
                params: {
                  q: 'title:' + ketWord + ' OR detail:' + ketWord + ' OR lableName:' + ketWord,
                  fl: 'title id state',
                  fq: '-state:10',
                  wt: 'json',
                  hl: true,
                  //                  sort:"hot DESC",
                  'hl.fl': 'title detail lableName',
                  'hl.simple.post': '</b>',
                  'hl.simple.pre': '<b>'
                }
              })
              .then(function(data) {
                if (data.response) {



                  $scope.responseDocs = data.response.docs;

                  $scope.searchQsdocs = data.highlighting;
                };
              });
          } else {
            $scope.responseDocs = [];
          }
        };

        $timeout.cancel(searchPromise);
        searchPromise = $timeout(function() {
          timeOutSearch();
        }, clearTime);

      };


      $scope.searchBackNoHistory = function() {
        $location.path('/');
        $timeout(function() {
          $window.location.reload(true);
        });
      };

      $scope.showQsForm = function(title) {
        if ($scope.closeSearchModal) {
          $scope.closeSearchModal();
        }


        //        //提问层
        //        $ionicModal.fromTemplateUrl('templates/addQuestion.html', {
        //          scope: $scope
        //        }).then(function(questionModal) {
        //          $scope.addQuestionModal = questionModal;
        //          Auth.isLoggedIn()
        //            .then(function() {
        //              $scope.addQuestionModal.show();
        //            }, function() {
        //              
        //              $scope.login(function() {
        //                $scope.addQuestionModal.show();
        //              });
        //            });
        //        });
        //提问层

        Auth.isLoggedIn()
          .then(function() {
            $scope.openQuestionModal();
          }, function() {

            $scope.login(function() {
              $scope.openQuestionModal();
            });
          });


        $scope.openQuestionModal = function(title) {

          $ionicModal.fromTemplateUrl('templates/addQuestion.html', {
            scope: $scope
          }).then(function(questionModal) {
            $scope.addQuestionModal = questionModal;
            $scope.addQuestionModal.show();
          });

          $scope.closeQuestionModal = function() {
            $scope.addQuestionModal.hide();
          };
        };
      };


      // if ($scope.quesToName) {
      //   console.log($scope.quesToName)
      //   // if ($scope.closeSearchModal) {
      //   //   $scope.closeSearchModal();
      //   // }
      //   $scope.showQsForm();
      // }
      

      //  $scope.toLoginLayer = function () {
      //    $scope.modal.show();
      //  }
    }
  ])
  .controller('addQusCtrl', ['$scope', '$stateParams', 'Auth', '$ionicActionSheet', '$timeout', 'getHttp', 'defConfig', '$ionicModal', 'formDataHttp', '$location', '$cordovaFile', '$state', '$ionicPopup', '$cordovaCapture', '$cordovaMedia', '$cordovaFileTransfer',
    function($scope, $stateParams, Auth, $ionicActionSheet, $timeout, getHttp, defConfig, $ionicModal, formDataHttp, $location, $cordovaFile, $state, $ionicPopup, $cordovaCapture, $cordovaMedia, $cordovaFileTransfer) {

      // console.log($scope.quesToName)
      Auth.isLoggedIn().then(function() {
        getHttp({
            path: defConfig.path + '/auth/virAccount',
            method: 'get'
          })
          .then(function(data) {
            if (data.result) {
              $scope.myMoney = {
                balance: data.result.balance,
                allBalance: data.result.allBalance
              };
            };
          });
      });

      $scope.questionItme = {};


      if ($scope.searchQs.title) {
        $scope.questionItme.title = $scope.searchQs.title;
      }
      $scope.bonusConfig = [10, 20, 50, 100];

      $scope.showBonusList = function() {
        var hideSheet = $ionicActionSheet.show({
          buttons: [{
            text: '10'
          }, {
            text: '20'
          }, {
            text: '50'
          }, {
            text: '100'
          }],
          //destructiveText: 'Delete',
          //destructiveButtonClicked: function
          titleText: '选择金额',
          cancelText: '取消',
          cancel: function() {
            // add cancel code..
          },
          buttonClicked: function(index) {

            switch (index) {
              case 0:
                $scope.questionItme.bonus = 10;
                break;
              case 1:
                $scope.questionItme.bonus = 20;
                break;
              case 2:
                $scope.questionItme.bonus = 50;
                break;
              case 3:
                $scope.questionItme.bonus = 100;
                break;
              default:
                $scope.questionItme.bonus = 10;
                break;
            }
            return true;
          }
        });

        // For example's sake, hide the sheet after two seconds
        //       $timeout(function() {
        //         hideSheet();
        //       }, 2000);

      };

      //添加标签
      $scope.mytags = [];
      $scope.inputTags = {};
      $scope.showTags = function(e) {

        $scope.inputTags.name = $scope.inputTags.name.replace(/(\s\s\s*)/g, " ");
        $scope.mytags = $scope.inputTags.name.split(" ");
        if ($scope.mytags.length >= 5) {
          $scope.mytags = $scope.mytags.slice(0, 5);
          $scope.inputTags.name = $scope.mytags.join(' ');
        }

      };

      //删除标签
      $scope.removeTag = function(i) {
        $scope.mytags.splice(i, 1);
        $scope.inputTags.name = $scope.mytags.join(' ');
      };



      $scope.next = function() {

        if ($scope.questionItme.bonus < 10) {
          return $ionicPopup.alert({
            title: '提示',
            template: '悬赏金额最低10元',
            okText: '确定'
          }).then(function() {});
        };

        //提问继续层
        if (!$scope.addNextQuestionModal) {
          $ionicModal.fromTemplateUrl('templates/addNextQuestion.html', {
            scope: $scope
          }).then(function(modal) {
            $scope.addNextQuestionModal = modal;
            $scope.addNextQuestionModal.show();
          });
        } else {
          $scope.addNextQuestionModal.show();
        }


        $scope.closeAddNextQuestionModal = function() {
          $scope.addNextQuestionModal.hide();
        };

        $scope.openAddNextQuestionModal = function(title) {
          $scope.addNextQuestionModal.show();
        };
      };


      $scope.closeAllModal = function() {
        $scope.closeAddNextQuestionModal();
        $scope.closeQuestionModal();
        $scope.closeSearchModal();
      };

//      $scope.sound = {};
//      $scope.isPlaying = false;
//      //语音提问
//      $scope.creatAudio = function () {
//    	  var options = { limit: 3, duration: 300 };
//
//    	    $cordovaCapture.captureAudio(options).then(function(audioData) {
//    	      // Success! Audio data is here
//    	    	console.log(audioData)
//    	    	$scope.sound.file = audioData[0].localURL;
//    			$scope.sound.filePath = audioData[0].fullPath;
//    	    }, function(err) {
//    	    	console.log(err)
//    	      // An error occurred. Show a message to the user
//    	    });
//      }
//  	$scope.play = function() {
//		if(!$scope.sound.file) {
//			navigator.notification.alert("Record a sound first.", null, "Error");
//			return;
//		}
////		var src = "/src/audio.mp3";
//		var media = $cordovaMedia.newMedia($scope.sound.file);
//		var iOSPlayOptions = {
//			    numberOfLoops: 2,
//			    playAudioWhenScreenIsLocked : false
//			  }
//
//		if (ionic.Platform.isIOS()) {
//			media.play(iOSPlayOptions)
//			$scope.isPlaying = true;
//		}
//		if (ionic.Platform.isAndroid()) {
//			media.play();
//			$scope.isPlaying = true;
//		}
//		
//		$scope.stop = function () {
//			media.stop();
//			$scope.isPlaying = false;
//		}
//		
//	}
      
      //提交语音
//      $scope.audioFiles = function () {
//    	  
//    	  
//            
//            
//    	  var server =  defConfig.url + defConfig.path + '/auth/uploadAudio',
//    	  audioFile = $scope.questionItme.audios[0],
//    	  filePath = audioFile.localURL;
////    	  options = $scope.questionItme;
//    	  var options = {
//    		        fileKey: "audios",
//    		        fileName: audioFile.name,
//    		        chunkedMode: false,
//    		        mimeType: "audio/*",
//    		        httpMethod: "post"
//    		    };
//    	  
//    	  console.log(filePath,$scope.questionItme.audios)
//    	  $cordovaFileTransfer.upload(server, filePath, options)
//          .then(function(result) {
//            // Success!
//        	  console.log(result)
//          }, function(err) {
//            // Error
//        	  console.log(err)
//          }, function (progress) {
//        	  console.log(progress)
//            // constant progress updates
//          });
//      }
//      
//      
      //发送@
      $scope.shareFriend = function(queId) {

        if (!$scope.quesToId) {
          return;
        }

        getHttp({
            method: 'post',
            path: defConfig.path + '/auth/queShare',
            params: {
              toIq: $scope.quesToId,
              queId: queId
            }
          })
          .then(function(data) {
            if (data.result) {
              
            }
          }, function() {

          });
      };
      
      //提交
      $scope.creatQuestion = function(e) {

        //      if (!$scope.questionItme.cateid) {
        //        
        //        if($scope.cates.length > 0) {
        //          $scope.questionItme.cateid = $scope.cates[0].id;
        //        } else {
        //          $scope.questionItme.cateid = "1wJ4dXG6";
        //        };
        //        
        //      }
        //      if($scope.questionItme.bonus > $scope.myMoney.balance) {
        //        alert("余额不足，请充值！");
        //      }
        if (!$scope.questionItme.bonus) {
          $scope.questionItme.bonus = 10;
        }
        
//        if ($scope.questionItme.audios) {
//        	$scope.questionItme.audioNos[0] = $scope.questionItme.audios;
//        }
        
        $scope.questionItme.tags = $scope.inputTags.name || "";
        //      if(!$scope.questionItme.detail){
        //        $scope.questionItme.detail = ' ';
        //      };
        //verification.isEmpty($scope.questionItme);
        //创建问题


        var fileData = [];
//        var audios = $scope.questionItme.audios;


        if ($scope.$$childTail && $scope.$$childTail.$$childTail && $scope.$$childTail.$$childTail.upLoadFile.files.length > 0) {
          fileData = $scope.$$childTail.$$childTail.upLoadFile.files;
        }
        
//        audios.push($scope.questionItme.audios,fileData)
        
        $scope.disableding = true;
        var formData = new FormData();

        if (fileData.length > 0) {
          angular.forEach(fileData, function(file) {
            formData.append('files', file);
          });
        	
          angular.forEach($scope.questionItme, function(key, value) {
            formData.append(value, key);
          });
          formDataHttp({
              path: defConfig.path + '/auth/addQuestion',
              method: 'post',
              formData: formData,
              loading: true
            })
            .then(function(data) {
              if (data.result) {
                $scope.shareFriend (data.result.qId);
                if (data.result.type) {
                  $scope.closeAllModal();
                  $location.path('/question/' + data.result.qId).search("share=1");
                } else {
                  $scope.closeAllModal();
                  $ionicPopup.alert({
                    title: '提示',
                    template: '账户余额不足，问题已存入草稿，充值后可继续发布。',
                    okText: '确定'
                  }).then(function() {});
                  $location.path('/question/' + data.result.qId);

                }

                

              };
            }, function(err) {});
        } else {
          getHttp({
              path: defConfig.path + '/auth/addQuestion',
              method: 'post',
              params: $scope.questionItme,
              loading: true
            })
            .then(function(data) {
              if (data.result) {
                $scope.shareFriend (data.result.qId);

                if (data.result.type) {
                  $scope.closeAllModal();
                  $location.path('/question/' + data.result.qId).search("share=1");
                } else {
                  $ionicPopup.alert({
                    title: '提示',
                    template: '账户余额不足，问题已存入草稿，充值后可继续发布。',
                    okText: '确定'
                  }).then(function() {});
                  $scope.closeAllModal();
                  $location.path('/question/' + data.result.qId);
                }

              };
            }, function() {});
        };

      };

    }
  ])
  .controller('questionCtrl', ['$scope', '$stateParams', 'getHttp', 'defConfig', 'loadMore', '$ionicModal', 'Auth', '$state', '$ionicActionSheet', '$timeout', '$ionicPopup', 'formDataHttp', '$ionicActionCustomSheet', '$location', '$window', '$ionicSlideBoxDelegate', '$ionicScrollDelegate', '$rootScope', 'wxConfig', '$$localstorage', '$sce',
    function($scope, $stateParams, getHttp, defConfig, loadMore, $ionicModal, Auth, $state, $ionicActionSheet, $timeout, $ionicPopup, formDataHttp, $ionicActionCustomSheet, $location, $window, $ionicSlideBoxDelegate, $ionicScrollDelegate, $rootScope, wxConfig, $$localstorage, $sce) {


	  
      
      var ua = navigator.userAgent.toLowerCase();
      if (ua.match(/MicroMessenger/i) == "micromessenger") {

//        if (!$$localstorage.get('isWx')) {
//          $$localstorage.set('isWx', "true");
//          $window.location.reload(true);
//        }
//
//
//        $timeout(function() {
//          $$localstorage.remove('isWx');
//        }, 1000)
      }

      function isWeixinBrowser() {

        if (ua.match(/MicroMessenger/i) == "micromessenger") {

          var shareTitle = $scope.questionItems.state === 11 ? "难题:" + $scope.questionItems.title + "解决了，大智力V5，感谢党，感谢人民，感谢……" : "悬赏" + $scope.questionItems.bonus + "人民币，请人帮解决难题：" + $scope.questionItems.title + "非常着急，快来帮忙解决啊！";
          
//          var shareUrl = defConfig.url + '' + $location.path(),
          var shareUrl = location.href.split('#')[0],
            shareDesc = $scope.questionItems.title,
            shareImgUrl = 'http://www.dazhili.com/img/wx-share-def.jpg';
          if ($scope.promotionConfig && $scope.promotionConfig.isShare) {
          	shareTitle = "#" + $scope.promotionConfig.shareDesc.common + "# "+ "悬赏" + $scope.questionItems.bonus + "元：" + $scope.questionItems.title  + shareUrl;
          	shareDescription = shareTitle;
          }
          if ($scope.questionItems.affixs && $scope.questionItems.affixs.length) {
            shareImgUrl = defConfig.url + $scope.questionItems.affixs[0].filePath.replace($scope.questionItems.affixs[0].suffix, "_256" + $scope.questionItems.affixs[0].suffix);
          }
          var wxShare = {
            title: shareTitle,
            link: shareUrl,
            imgUrl: shareImgUrl,
            desc: shareDesc,
            success: function(res) {
            	
            	if($scope.promotionConfig.isShare){
//            		$scope.shareResultSuccessCbUrl = $sce.trustAsResourceUrl('http://www.dazhili.com/dzlStage/getShareMoney?queId='+$scope.questionItems.id);
//            		
////            		$timeout(function() {
////            			$scope.shareResultSuccessCbUr = false;
////            		})
            		
            		getHttp({
                        path: '/dzlStage/getShareMoney',
                        method: 'get'
                      })
                      .then(function(data) {
                    	  if(data.result) {
                    		  $ionicPopup.alert({
                                title: '提示',
                                template: '分享成功, 已打入<a ng-href="'+defConfig.url +'/question/account/wallet">钱包</a><p>超过上限请忽略</p>',
                                okText: '确定'
                              }).then(function() {});
                    	  }
                      },function(err){
//                    	  $ionicPopup.alert({
//                              title: '提示',
//                              template: '错误！'+JSON.stringify(err),
//                              okText: '确定'
//                            }).then(function() {});
                      })
            	}
            	
            },
            canel: function() {}
          }
          wxConfig(wxShare);


          $rootScope.isWeixin = true;
          return true;
        } else {
          $rootScope.isWeixin = false;
          return false;
        }

      }



      //获取问题信息
      $scope.getQuestion = function(cb) {
    	  
    	  $scope.isShare = false;
    	  
    	  if ($location.search().share == 1) {
    		  $scope.isShare = true;
    	  }else {
    		  $scope.isShare = false;
    	  }
    	  
        getHttp({
            method: 'post',
            path: defConfig.path + '/getQuestionDetail',
            params: {
              qid: $stateParams.id
            }
          })
          .then(function(data) {
            if (data.result) {
        	if ($rootScope.currentUser) {
          	  $location.search('share',$rootScope.currentUser.showId);
            }
              $scope.questionItems = data.result;
              $scope.sortFieldParams = {
                path: '/getAnsweresOfQuestion',
                qid: data.result.id
              };
              
              loadMore($scope, 'answerItems', $scope.sortFieldParams);
              
        	  getHttp({
                  path: '/dzlStage/getShareMoneyInfo?time=' + new Date().getTime(),
                  method: 'get'
                })
                .then(function(data) {
                	
                	if(data.result){
                		var shareContent = data.result;
                		$scope.promotionConfig = {
                				isShare: true,
                				"shareDesc":{
                			        "title":"<h3 class='balanced'>微信分享有奖</h3><p>仅限微信内分享，需登录！</p>",
                			        "common": '分享立即获得' + shareContent.shareMoney + '元，每日最高上限' + shareContent.shareMax + '元。'
                			    },
                		}
                	}
//                	$scope.promotionConfig = data.result;
                	if ($scope.isShare) {
                		$scope.showMoreActionSheet();
                	}
                	 isWeixinBrowser();
                },function () {
                	 isWeixinBrowser();
                });
            	  
              
              
             
              if (typeof cb === "function") cb();
            };
          }, function() {
            if (typeof cb === "function") cb();
          });
      };

      //初始化
      $scope.getQuestion();


      //图片预览
      $scope.showImage = function(index) {
        $scope.activeSlide = index;
        $scope.showModal('templates/gallery-zoomview.html');
      };

      $scope.showModal = function(templateUrl) {
        $ionicModal.fromTemplateUrl(templateUrl, {
          scope: $scope
        }).then(function(modal) {
          $scope.imageZoomModal = modal;
          $scope.imageZoomModal.show();
        });
      };

      $scope.closeImageZoomModal = function() {
        $scope.imageZoomModal.hide();
        $scope.imageZoomModal.remove();
      };

      $scope.updateSlideStatus = function(slide) {
        $scope.$on('$ionicView.loaded', function() {
          $timeout(function() {
            var zoomFactor = $ionicScrollDelegate.$getByHandle('scroll' + slide).getScrollPosition().zoom;
            if (zoomFactor == $scope.zoomMin) {
              $ionicSlideBoxDelegate.enableSlide(true);
            } else {
              $ionicSlideBoxDelegate.enableSlide(false);
            };
          });
        });

      };

      //下拉刷新
      $scope.doRefresh = function() {
        $scope.getQuestion(function() {
          $scope.$broadcast('scroll.refreshComplete');
        });
      };

      //回答
      $scope.toAnswerModal = function() {

        //回答
        $ionicModal.fromTemplateUrl('templates/answerModal.html', {
          scope: $scope
        }).then(function(modal) {
          $scope.answerModal = modal;
          Auth.isLoggedIn()
            .then(function() {
              $scope.answerModal.show();
            }, function() {
              $scope.login(function() {
                $scope.getQuestion(function() {

                  if ($scope.questionItems.curUserType != 2 && $scope.questionItems.curUserType != 3) {
                    $scope.answerModal.show();
                  }
                });
              });
            });
        });

        $scope.closeAnswerModal = function() {
          $scope.answerModal.hide();
        };

        $scope.openAnswerModal = function($event) {
          $scope.answerModal.show();
        };
      };



      Auth.isLoggedIn()
        .then(function() {

          //余额
          getHttp({
              path: defConfig.path + '/auth/virAccount',
              method: 'get'
            })
            .then(function(data) {
              if (data.result) {
                $scope.myMoneybalance = data.result.balance;
              }
            });
        }, function() {});



      //问题补充
      $scope.toAddMoreQuestionModal = function() {

        //回答
        $ionicModal.fromTemplateUrl('templates/addMoreQuestion.html', {
          scope: $scope
        }).then(function(modal) {
          $scope.addMoreQuestion = modal;
          $scope.addQsDetail = {};
          Auth.isLoggedIn()
            .then(function() {
              $scope.addMoreQuestion.show();
            }, function() {
              $scope.login(function() {
                $scope.getQuestion(function() {

                  if ($scope.questionItems.curUserType == 2) {
                    $scope.addMoreQuestion.show();
                  }
                });
              });
            });
        });

        $scope.closeAddMoreQuestion = function() {
          $scope.addMoreQuestion.hide();
          $scope.formDataFiles = null;
        };

        $scope.openAddMoreQuestion = function($event) {
          $scope.addMoreQuestion.show();
        };



        $scope.submitQsDetail = function() {
          if ($scope.$$childTail && $scope.$$childTail.$$childTail && $scope.$$childTail.$$childTail.upLoadFile.files.length > 0) {
            $scope.formDataFiles = $scope.$$childTail.$$childTail.upLoadFile.files;
          }

          if (!$scope.addQsDetail.detail && (!$scope.formDataFiles || $scope.formDataFiles.length <= 0)) {
            return $ionicPopup.alert({
              title: '提示',
              template: '请填写问题补充内容！',
              okText: '确定'
            }).then(function() {});
          }
          $scope.submiting = true;

          var formData = new FormData();
          if ($scope.formDataFiles) {
            angular.forEach($scope.formDataFiles, function(file) {
              formData.append('files', file);
            });

            formData.append('qId', $scope.questionItems.id);
            if ($scope.addQsDetail.detail) {
              formData.append('detail', $scope.addQsDetail.detail);
            }

            formDataHttp({
                path: defConfig.path + '/auth/appendQuestion',
                method: 'post',
                formData: formData,
                loading: true
              })
              .then(function(data) {
                if (data.result) {

                  if (data.result == "success") {
                    $scope.closeAddMoreQuestion();
                    $scope.formDataFiles = null;
                    $scope.getQuestion();

                  };

                };
              }, function() {});
          } else {
            getHttp({
                method: 'POST',
                path: defConfig.path + '/auth/appendQuestion',
                params: {
                  qId: $scope.questionItems.id,
                  detail: $scope.addQsDetail.detail
                },
                loading: true
              })
              .then(function(data) {
                if (data.result == "success") {
                  $scope.closeAddMoreQuestion();
                  $scope.formDataFiles = null;
                  $scope.getQuestion();

                };
              });
          };
        };
      };

      //追加悬赏
      $scope.showAddBonuSheet = function() {


        //余额
        getHttp({
            path: defConfig.path + '/auth/virAccount',
            method: 'get'
          })
          .then(function(data) {
            if (data.result) {
              $scope.myMoneybalance = data.result.balance;
              var hideSheet = $ionicActionSheet.show({
                buttons: [{
                  text: '5'
                }, {
                  text: '10'
                }, {
                  text: '20'
                }, {
                  text: '50'
                }, {
                  text: '100'
                }],
                //destructiveText: 'Delete',
                //destructiveButtonClicked: function
                titleText: '可用金额 <small class="assertive">￥' + $scope.myMoneybalance + '</small>',
                cancelText: '取消',
                cancel: function() {
                  // add cancel code..
                },
                buttonClicked: function(index) {

                  switch (index) {
                    case 0:
                      $scope.submitAddBonu(5);
                      break;
                    case 1:
                      $scope.submitAddBonu(10);
                      break;
                    case 2:
                      $scope.submitAddBonu(20);
                      break;
                    case 3:
                      $scope.submitAddBonu(50);
                      break;
                    case 4:
                      $scope.submitAddBonu(100);
                      break;
                    default:
                      $scope.submitAddBonu(10);
                      break;
                  }
                  return true;
                }
              });
              $scope.hideSheet = function() {
                hideSheet();
              };
            };
          });


        //     // For example's sake, hide the sheet after two seconds
        //     $timeout(function() {
        //       hideSheet();
        //     }, 2000);

      };

      //分享浮动层
//      $$localstorage.remove('showShareTips');
      
      if (!$$localstorage.get('showShareTips')) {
    	  $scope.showShareTips = true;
      }else {
    	  var timer = new Date().getTime();
    	  
    	  if ((timer - $$localstorage.get('showShareTips')) > 600000 ) {
    		  $scope.showShareTips = true;
    	  }
      }
     
      $scope.closeShareTips = function() {
        $scope.showShareTips = false;
        $$localstorage.set('showShareTips', new Date().getTime());
      };


      //微信内分享直接提示右上角更多
      $scope.inwxBrowMore = function () {
    	  $ionicModal.fromTemplateUrl('templates/wxShareModal.html', {
              scope: $scope
            }).then(function(modal) {
              $scope.wxShareModal = modal;
              $scope.wxShareModal.show();
            });

            $scope.closeWxShareModal = function() {
              $scope.wxShareModal.hide();
            };

            $scope.openWxShareModal = function($event) {
              $scope.wxShareModal.show();
            };
      }
      
      //分享及更多
      $scope.showMoreActionSheet = function() {

        var showDeleteQsBtn = 'hide';

        if ($scope.questionItems.answerCount === 0 && $scope.questionItems.state != 10 && $scope.questionItems.curUserType == 2) {
          showDeleteQsBtn = 'show';
        }

        var rebateProgram = false;
        if ($scope.promotionConfig && $scope.promotionConfig.isShare){
        	rebateProgram = $scope.promotionConfig.shareDesc.title+$scope.promotionConfig.shareDesc.common;
//            if ($scope.questionItems.curUserType == 2) {
//            	rebateProgram += $scope.promotionConfig.shareDesc.q;
//            }else if ($scope.questionItems.curUserType == 3) {
//            	rebateProgram += $scope.promotionConfig.shareDesc.a;
//            }else {
//            	rebateProgram += $scope.promotionConfig.shareDesc.common;
//            }
        }
        

        var hideSheet = $ionicActionCustomSheet.show({
          buttons: [{
            text: '微信好友',
            class: 'iconfont icon-weixin  balanced'
          }, {
            text: '朋友圈',
            class: 'iconfont icon-pengyouquan  balanced'
          }, {
            text: 'QQ好友',
            class: 'iconfont icon-qq calm'
          }, {
            text: '微博好友',
            class: 'iconfont icon-weibo assertive'
          }, {
            text: '指定好友',
            class: 'iconfont ion-at energized'
          }],
          buttonsGroup: [{
            text: '举报',
            class: 'iconfont icon-laheijubao assertive'
          }],
          //destructiveText: 'Delete',
          //destructiveButtonClicked: function
          titleText: '分享',
          customDescSheet: rebateProgram,
          customStyle:{'margin-bottom':'-8px'},
          cancelText: '取消',
          cancel: function() {
            // add cancel code..
          },
          buttonClicked: function(index) {

            switch (index) {
              case 0:
                //                $scope.shareViaWechat(WeChat.Scene.timeline);
                $scope.shareViaWechat(0);
                break;
              case 1:
                $scope.shareViaWechat(1);
                break;
              case 2:
                //                $scope.shareViaWechat(WeChat.Scene.session, title, desc, url, thumb);
                $scope.shareWebQQ();
                break;
              case 3:
                $scope.shareWeibo();
                break;
              case 4:
                $scope.atFriend();
                break;
              default:
                $scope.shareViaWechat(WeChat.Scene.session, title, desc, url, thumb);
                break;
            }
            return true;
          },
          buttonGroupClicked: function(index) {

            switch (index) {
              //              case 0:
              //                $scope.deleQs();
              //                break;
              case 0:
                $scope.hideSheet();
                $scope.showReportSheet($scope.questionItems.id, 1);
                break;
              default:
                '';
                break;
            }
            return true;
          }
        });



        $scope.hideSheet = function() {
          hideSheet();
        };
        //     // For example's sake, hide the sheet after two seconds
        //     $timeout(function() {
        //       hideSheet();
        //     }, 2000);

        
        var shareCommonUrl = defConfig.url + '' + $location.path() +( $rootScope.currentUser ? '?share='+ $rootScope.currentUser.showId : '');
        var shareTitle = 
      	  $scope.questionItems.state === 11 ? 
      			  "难题:" + $scope.questionItems.title + "解决了，大智力V5，感谢党，感谢人民，感谢……" 
      			  :
      			"悬赏" + $scope.questionItems.bonus + "人民币，请人帮解决难题：" + $scope.questionItems.title + "非常着急，快来帮忙解决啊！，地址：" + shareCommonUrl;
        var shareDescription = shareTitle;
        
        if ($scope.promotionConfig && $scope.promotionConfig.isShare) {
        	shareTitle = "#" + $scope.promotionConfig.shareDesc.common + "# " + "悬赏" + $scope.questionItems.bonus + "元：" + $scope.questionItems.title +  shareCommonUrl;
        	shareDescription = shareTitle;
        }
        //微博web分享
        $scope.shareWeibo = function() {
          
          var url = "http://v.t.sina.com.cn/share/share.php?title=" + encodeURIComponent(shareTitle) + "&url=" + shareCommonUrl;

          if (ionic.Platform.platforms[0] === 'browser') {
            window.location.href = url;
          } else {
            window.open(url, '_blank', 'location=yes');
          }
        };

        //QQweb分享
        $scope.shareWebQQ = function() {
//          var shareTitle = $scope.questionItems.state === 11 ? "难题:" + $scope.questionItems.title + "解决了，大智力V5，感谢党，感谢人民，感谢……" : "悬赏" + $scope.questionItems.bonus + "人民币，请人帮解决难题：" + $scope.questionItems.title + "非常着急，快来帮忙解决啊！，地址：" + shareCommonUrl;
          var url = "http://connect.qq.com/widget/shareqq/index.html?title=" + encodeURIComponent(shareTitle) + "?url=" + shareCommonUrl + "&desc=&summary=&site=大智力";

          if (ionic.Platform.platforms[0] === 'browser') {
            window.location.href = url;
          } else {
            window.open(url, '_blank', 'location=yes');
          }
        };



        //微信分享
        $scope.shareViaWechat = function(scene, title, desc, url, thumb) {
          // Wechat.isInstalled(function (installed) {
          //     alert("Wechat installed: " + (installed ? "Yes" : "No"));
          // }, function (reason) {
          //     alert("Failed: " + reason);
          // });
//          var shareTitle = $scope.questionItems.state === 11 ? "难题:" + $scope.questionItems.title + "解决了，大智力V5，感谢党，感谢人民，感谢……" : "悬赏" + $scope.questionItems.bonus + "人民币，请人帮解决难题：" + $scope.questionItems.title + "非常着急，快来帮忙解决啊！";

          var shareUrl = shareCommonUrl,
            shareImgUrl = 'www/img/wx-share-def.jpg';


          if ($scope.questionItems.affixs && $scope.questionItems.affixs.length) {
            shareImgUrl = defConfig.url + $scope.questionItems.affixs[0].filePath.replace($scope.questionItems.affixs[0].suffix, "_256" + $scope.questionItems.affixs[0].suffix);
          }

          if (typeof Wechat === "undefined") {
            if ($rootScope.isWeixin) {
            	
            	$scope.inwxBrowMore();
            	return;
//              return $ionicPopup.confirm({
//                title: '提示',
//                template: '请点击右上角“更多”按钮分享',
//                okText: '确定',
//                cancelText: '取消',
//              }).then(function(res) {}, function() {
//
//              });

              //              var wxShare = {
              //                  title: shareTitle,
              //                  link: shareUrl,
              //                  imgUrl: shareImgUrl,
              //                  desc: shareDesc,
              //                  success: function (){},
              //                  canel: function (){}
              //              }
              //              $timeout(function () {
              //                wxConfig(wxShare);
              //              },1000);
            } else {
              return $ionicPopup.confirm({
                title: '提示',
                template: '微信暂不支持非APP分享，建议使用大智力客户端',
                okText: '下载APP',
                cancelText: '取消',
              }).then(function(res) {
                if (res) {
                  $location.path('/question/downloadApp');
                }
              }, function() {


              });
            }
          };



          var message = {
            title: shareTitle,
            description: shareTitle,
            thumb: shareImgUrl,
            //                  mediaTagName: "TEST-TAG-001",
            //                  messageExt: "这是第三方带的测试字段",
            //                  messageAction: "<action>dotalist</action>",
            media: {
              type: Wechat.Type.LINK,
              webpageUrl: shareUrl
            }
          };
          if (scene == 0) {
            Wechat.share({
              message: message,
              scene: Wechat.Scene.SESSION // share to Timeline
            }, function() {
              // alert("Success");
            }, function(reason) {
              // alert("Failed: " + reason);
            });
          } else {
            Wechat.share({
              message: message,
              scene: Wechat.Scene.TIMELINE //Wechat.Scene.TIMELINE   // share to Timeline
            }, function() {
              // alert("Success");
            }, function(reason) {
              // alert("Failed: " + reason);
            });
          }



        };

      };


      
      //@站内好友
      $scope.atFriend = function() {
        $scope.hideSheet();

        $ionicModal.fromTemplateUrl('templates/atFriendModal.html', {
          scope: $scope
        }).then(function(modal) {
          $scope.atFriendModal = modal;
          $scope.atFriendModal.show();
          $scope.shareFor = {};
        });

        $scope.closeAtFriendModal = function() {
          $scope.atFriendModal.hide();
        };

        $scope.openAtFriendModal = function($event) {
          $scope.atFriendModal.show();
        };


        var searchPromise,
          clearTime = 200;
        $scope.getFriend = function() {

          function friendSearch() {
            getHttp({
                method: 'get',
                path: defConfig.path + '/auth/commonShareMain'
              })
              .then(function(data) {
                if (data.result) {
                  $scope.FriendList = data.result;
                  if (data.result.length > 0) {
                    $scope.openShareFriend = true;
                  }
                }
              });
          };


          $timeout.cancel(searchPromise);
          searchPromise = $timeout(function() {
            friendSearch();
          }, clearTime);
        };

        //发送@
        $scope.shareFriend = function() {
          getHttp({
              method: 'post',
              path: defConfig.path + '/auth/queShare',
              params: {
                toIq: $scope.shareFor.Friend,
                queId: $stateParams.id
              }
            })
            .then(function(data) {
              if (data.result) {
                $ionicPopup.alert({
                  title: '提示',
                  template: "成功邀请！",
                  okText: '确定'
                }).then(function() {});
                $scope.atFriendModal.hide();
              }
            }, function() {

            });
        };
      };



      //      内容举报
      //      http://127.0.0.1:8080/dzlStage/auth/report?tgtId=问题或者答案ID&tgtTpye=举报类型[1:问题,2:答案]&reportText=举报内容[可为null]&
      //      reportType=举报内容类型[1：涉及政治
      //                  2：涉黄
      //                  3：涉及暴力
      //                            4：涉及虚假内容
      //                            5:其他]
      //举报
      $scope.showReportSheet = function(tgtId, tgtTpye) {



        var hideSheet = $ionicActionSheet.show({
          buttons: [{
            text: '不宜公开讨论的政治内容'
          }, {
            text: '少儿不宜内容'
          }, {
            text: '暴力、不友善内容'
          }, {
            text: '虚假内容'
          }, {
            text: '其他'
          }],
          //destructiveText: 'Delete',
          //destructiveButtonClicked: function
          titleText: '举报',
          cancelText: '取消',
          cancel: function() {
            // add cancel code..
          },
          buttonClicked: function(index) {

            switch (index) {
              case 0:
                $scope.showReport(1);
                break;
              case 1:
                $scope.showReport(2);
                break;
              case 2:
                $scope.showReport(3);
                break;
              case 3:
                $scope.showReport(4);
                break;
              case 4:
                $scope.showReport(5);
                break;
              default:
                $scope.showReport(5);
                break;
            }
            return true;
          }
        });
        $scope.hideSheet = function() {
          hideSheet();
        };



        $scope.showReport = function(i) {
          $scope.hideSheet();
          //          Auth.isLoggedIn()
          //          .then(function() {
          //            toPostReport();
          //          }, function() {
          //            $scope.login(function() {
          //
          //              $scope.getQuestion(function() {
          //                toPostReport();
          //              });
          //            });
          //          });

          function toPostReport() {
            getHttp({
                path: defConfig.path + '/report',
                method: 'post',
                params: {
                  tgtId: tgtId,
                  tgtTpye: tgtTpye,
                  reportType: i
                }
              })
              .then(function(data) {
                if (data.result) {
                  $ionicPopup.alert({
                    title: '提示',
                    template: "举报成功，谢谢您的支持！",
                    okText: '确定'
                  }).then(function() {});
                }
              });
          };
          toPostReport();

        };
        //     // For example's sake, hide the sheet after two seconds
        //     $timeout(function() {
        //       hideSheet();
        //     }, 2000);

      };

      //去充值
      $scope.goWallet = function() {
        $location.path('/question/account/wallet');
      };

      //撤销问题
      $scope.deleQs = function() {


        Auth.isLoggedIn()
          .then(function() {
            todoDeleQs();
          }, function() {
            $scope.login(function() {
              $scope.getQuestion(function() {

                if ($scope.questionItems.answerCount === 0 && $scope.questionItems.state != 10 && $scope.questionItems.curUserType == 2) {
                  todoDeleQs();
                }
              });
            });
          });


        function todoDeleQs() {
          var deleQs = $ionicPopup.confirm({
            title: '提示',
            template: '确认撤销问题？',
            cancelText: '取消',
            okText: '确定'
          });
          deleQs.then(function(res) {
            if (res) {
              getHttp({
                  path: defConfig.path + '/auth/repeal',
                  method: 'post',
                  params: {
                    qId: $scope.questionItems.id
                  }
                })
                .then(function(data) {
                  //$scope.getQuestion();
                  $location.path('/question/account/my').search('tab', 3);
                });
            } else {}
          });
          //          if (!deleQs) {
          //            return;
          //          };

        }


      };

      //重新发布过期的问题
      //http://127.0.0.1:8080/dzlStage/auth/republishQues?qid=

      $scope.rePublishQs = function() {
        var userRe = $ionicPopup.confirm({
          title: '提示',
          template: '确认再次发布此问题？',
          cancelText: '取消',
          okText: '确定'
        });
        userRe.then(function(res) {
          if (res) {
            Auth.isLoggedIn()
              .then(function() {
                toRePublishQs();
              }, function() {
                $scope.login(function() {

                  $scope.getQuestion(function() {
                    toRePublishQs();
                  });
                });
              });

            function toRePublishQs() {
              getHttp({
                  path: defConfig.path + '/auth/republishQues',
                  method: 'post',
                  params: {
                    qid: $scope.questionItems.id
                  }
                })
                .then(function(data) {

                  if (data.result.type) {
                    $location.path('/question/' + data.result.qId)
                  } else {
                    $ionicPopup.alert({
                      title: '提示',
                      template: "账户余额不足，充值后可继续发布。",
                      okText: '确定'
                    }).then(function() {});
                  }

                });
            };
          } else {}
        });
      };

      //发布
      $scope.publishQs = function() {
        var userRe = $ionicPopup.confirm({
          title: '提示',
          template: '确认发布此问题？',
          cancelText: '取消',
          okText: '确定'
        });
        userRe.then(function(res) {
          if (res) {
            Auth.isLoggedIn()
              .then(function() {
                toPublishQs();
              }, function() {
                $scope.login(function() {

                  $scope.getQuestion(function() {
                    toPublishQs();
                  });
                });
              });

            function toPublishQs() {
              getHttp({
                  path: defConfig.path + '/auth/changeState',
                  method: 'post',
                  params: {
                    qId: $scope.questionItems.id
                  }
                })
                .then(function(data) {

                  if (data.result.type) {
                    $scope.getQuestion(function() {});
                  } else {
                    $ionicPopup.alert({
                      title: '提示',
                      template: "账户余额不足，充值后可继续发布。",
                      okText: '确定'
                    }).then(function() {});
                  }

                });
            };
          } else {
            //console.log('You are not sure');
          }
        });



      };

      //提交悬赏金额
      $scope.submitAddBonu = function(value) {


        Auth.isLoggedIn()
          .then(function() {
            toPostBonu();
          }, function() {
            $scope.login(function() {

              $scope.getQuestion(function() {
                toPostBonu();
              });
            });
          });

        function toPostBonu() {
          $scope.hideSheet();

          if (value > $scope.myMoneybalance) {
            return $ionicPopup.alert({
              title: '提示',
              template: "余额不足，请充值后再追加悬赏！",
              okText: '确定'
            }).then(function() {});
          }
          $scope.addBonusVal = value;
          getHttp({
            method: 'post',
            path: defConfig.path + '/auth/additionalBonus',
            params: {
              qid: $scope.questionItems.id,
              bonus: value
            }
          }).then(function(data) {

            if (typeof data.result == 'number') {
              $scope.questionItems.bonus = data.result;
            }
            if (!$scope.questionItems.addBonus) {
              $scope.questionItems.addBonus = [];
            }
            $scope.questionItems.addBonus.push({
              addTime: new Date(),
              addValue: value
            });


            var tpl = '<div class="add-price-end bounce">\
            <i class="icon ion-plus-round balanced"> </i> {{addBonusVal | currency:"￥"}}\
            </div>';

            $scope.showAddBonusPopup(tpl);

          });
        }


      };



      $scope.showAddBonusPopup = function(tpl) {
        // popup
        var myPopup = $ionicPopup.show({
          template: tpl,
          cssClass: 'specSuccess',
          scope: $scope
        });
        $timeout(function() {
          myPopup.close();
        }, 1500);

      };



      //关注
      $scope.followQs = function(e) {


        Auth.isLoggedIn()
          .then(function() {
            toPost();
          }, function() {
            $scope.login(function() {

              $scope.getQuestion(function() {
                toPost();
              });
            });
          });


        function toPost() {
          getHttp({
              method: 'post',
              path: defConfig.path + '/auth/addConcernQuesiton',
              params: {
                qid: $stateParams.id
              }
            })
            .then(function(data) {
              if (data.result) {
                $scope.questionItems.concern = data.result.concern;
                var className = 'ion-minus-round';
                if (data.result.concern) {
                  className = 'ion-plus-round';
                }


                var tpl = '<div class="add-price-end bounce">\
              <i class="icon ' + className + ' balanced"> </i> 1\
              </div>';

                $scope.showAddBonusPopup(tpl);
              }

              //changeState(e);
            }, function() {
              //changeState(e);
            }, function() {
              //changeState(e);
            });
        };

      };

      //查看答案
      $scope.showAnswer = function(qid, aid) {
        $location.path("/question/answerDetail/" + aid);
      };

      //购买答案
      $scope.checkAnswer = function(qid, aid) {


        var userRe = $ionicPopup.confirm({
          title: '提示',
          template: '购买此答案，需花费￥' + $scope.questionItems.bonus + '，请确认？',
          cancelText: '取消',
          okText: '确定'
        });
        userRe.then(function(res) {
          if (res) {
            Auth.isLoggedIn()
              .then(function() {
                toBuyQus();
              }, function() {
                $scope.login(function() {

                  $scope.getQuestion(function() {
                    toBuyQus();
                  });
                });
              });

            function toBuyQus() {
              getHttp({
                  path: defConfig.path + '/auth/thirdCheckAnswer',
                  method: 'post',
                  params: {
                    aid: aid
                  }
                })
                .then(function(data) {
                  if (data.result) {
                    $location.path("/question/answerDetail/" + aid);
                  };
                }, function(err) {
                  //alert('账户余额不足，请充值!');
                });
            };
            //console.log('You are sure');
          } else {
            //console.log('You are not sure');
          }
        });



      };



      //确认答案
      $scope.confirmationAnswerModal = function() {

        $ionicModal.fromTemplateUrl('templates/confirmationAnswerModal.html', {
          scope: $scope
        }).then(function(modal) {
          $scope.confirmationAnswer = modal;
          $scope.confirmationAnswer.show();
        });

        $scope.closeConfirmationAnswer = function() {
          $scope.confirmationAnswer.hide();
        };

        $scope.openConfirmationAnswer = function($event) {
          $scope.confirmationAnswer.show();
        };
      };


      $scope.forBusinessCard = function(id) {
        $location.path('/question/businessCard/' + id);
      };

      //确认答案
      $scope.submitConfirmationAnswer = function(id) {


        $scope.closeConfirmationAnswer();


        var userRe = $ionicPopup.confirm({
          title: '提示',
          template: '确认答案，会支付悬赏给回答者，请确认？',
          cancelText: '取消',
          okText: '确定'
        });
        userRe.then(function(res) {
          if (res) {
            getHttp({
                path: defConfig.path + '/auth/verifyAnswer',
                method: 'post',
                params: {
                  aid: id
                }
              })
              .then(function(data) {
                if (data.result === 'success') {
                  $scope.getQuestion();
                };
              });
            //console.log('You are sure');
          } else {
            //console.log('You are not sure');
          }
        });

      };



      //未解决层
      $scope.toUnAllresolved = function() {

        $ionicModal.fromTemplateUrl('templates/unAllresolvedModal.html', {
          scope: $scope
        }).then(function(modal) {
          $scope.unAllresolved = modal;
          $scope.unAllresolved.show();
          $scope.unresolved = {};
        });

        $scope.closeUnAllresolved = function() {
          $scope.unAllresolved.hide();
        };

        $scope.openUnAllresolved = function($event) {
          $scope.unAllresolved.show();
        };
      };



      //提交未解决原因 

      $scope.submitAllResolve = function() {
        for (v in $scope.unresolved) {
          getHttp({
              path: defConfig.path + '/auth/applyArgue',
              method: "post",
              params: {
                queId: $scope.questionItems.id,
                ansId: v,
                argueText: $scope.unresolved[v],
                argueName: $scope.questionItems.title
              },
              loading: true
            })
            .then(function(data) {
              $ionicPopup.alert({
                title: '提示',
                template: "提交成功，请等待对方回复！",
                okText: '确定'
              }).then(function() {});
              $scope.closeUnAllresolved();
              $scope.getQuestion();
            });
        }
      };


    }
  ])



//回答
.controller('answerCtrl', ['$scope', '$stateParams', 'getHttp', 'defConfig', 'loadMore', '$ionicModal', 'Auth', '$state', 'formDataHttp', '$ionicPopup',
  function($scope, $stateParams, getHttp, defConfig, loadMore, $ionicModal, Auth, $state, formDataHttp, $ionicPopup) {

    $scope.answer = {};


    //回答


    $scope.toNextAnswerModal = function() {

      if (!$scope.answer.ca) {
        return $ionicPopup.alert({
          title: '提示',
          template: "请填写公开答案!",
          okText: '确定'
        }).then(function() {});
      };

      //$scope.closeAnswerModal();


      $ionicModal.fromTemplateUrl('templates/answerNextModal.html', {
        scope: $scope
      }).then(function(modal) {
        $scope.answerNextModal = modal;
        $scope.answerNextModal.show();
      });

      $scope.closeAnswerNextModal = function() {
        $scope.answerNextModal.hide();
      };

      $scope.openAnswerNextModal = function($event) {
        $scope.answerNextModal.show();
      };
    };

    $scope.closeAllanswerModal = function() {
      $scope.closeAnswerNextModal();
      $scope.closeAnswerModal();
    };

    $scope.submitAnswer = function() {
      $scope.answer.qid = $stateParams.id;

      if (!$scope.answer.cb) {
        return $ionicPopup.alert({
          title: '提示',
          template: "请填写保密答案!",
          okText: '确定'
        }).then(function() {});
      }

      var formData = new FormData();
      if ($scope.$$childTail && $scope.$$childTail.$$childTail && $scope.$$childTail.$$childTail.upLoadFile.files.length > 0) {
        angular.forEach($scope.$$childTail.$$childTail.upLoadFile.files, function(file) {
          formData.append('files', file);
        });
        angular.forEach($scope.answer, function(key, value) {
          formData.append(value, key);
        });
        formDataHttp({
            path: defConfig.path + '/auth/submitAnswer',
            method: 'post',
            formData: formData,
            loading: true
          })
          .then(function(data) {
            if (data.result) {
              $scope.closeAllanswerModal();
              $scope.getQuestion();
            };
          }, function() {});
      } else {
        getHttp({
            method: 'post',
            path: defConfig.path + '/auth/submitAnswer',
            params: $scope.answer,
            loading: true
          })
          .then(function(data) {
            $scope.closeAllanswerModal();
            $scope.getQuestion();
          });
      }

    };

  }
])

//答案详情
.controller('answerDetailCtrl', ['$scope', '$stateParams', 'Auth', 'getHttp', 'defConfig', '$ionicModal', 'formDataHttp', '$ionicPopup', '$location', 'loadMore', 'replyAssessFac',
  function($scope, $stateParams, Auth, getHttp, defConfig, $ionicModal, formDataHttp, $ionicPopup, $location, loadMore, replyAssessFac) {
    var aid = $stateParams.id;



    $scope.getAnswerContent = function(cb) {
      $scope.answerDetail = {};
      getHttp({
          method: 'post',
          path: defConfig.path + '/auth/checkAnswer',
          params: {
            aid: aid
          }
        })
        .then(function(data) {
          $scope.answerDetail = data.result;
          $scope.answerDetail.state = data.result.quesState;

          //$scope.hasFooter = ($scope.answerDetail.curUserType == 2 ) ? true : false



          //        $scope.sortFieldParams = {
          //            path:'/ansAssess',
          //            ansId: aid
          //          };
          //        loadMore($scope,'ansAssess',$scope.sortFieldParams, function (data) {
          //          if (!!data.result.datas.length) {
          //            $scope.isAssess = true;
          //            $scope.ansAssess.totalCount = data.result.totalCount;
          //            $scope.ansAssess.averageScore = data.result.averageScore;
          //          }
          //        });



          if (typeof cb === "function") cb();
        }, function(err) {
          if (typeof cb === "function") cb();
        });
    };

    $scope.getAnswerContent();


    
    $scope.doAnswerRefresh = function() {
      $scope.getAnswerContent(function() {
        $scope.$broadcast('scroll.refreshComplete');
      });
    };

    //确认答案
    $scope.sureAnswer = function() {


      var userRe = $ionicPopup.confirm({
        title: '提示',
        template: '确认答案，会支付悬赏给回答者，请确认？',
        cancelText: '取消',
        okText: '确定'
      });
      userRe.then(function(res) {
        if (res) {
          getHttp({
              path: defConfig.path + '/auth/verifyAnswer',
              method: 'post',
              params: {
                aid: aid
              }
            })
            .then(function(data) {
              if (data.result === 'success') {
                //$location.path('/myQuestion');
                $location.path('/question/assess/' + aid);
              };
            });
          //console.log('You are sure');
        } else {
          //console.log('You are not sure');
        }
      });

    };



    $scope.toAddMoreAnswer = function() {


      $ionicModal.fromTemplateUrl('templates/addMoreAnswer.html', {
        scope: $scope
      }).then(function(modal) {
        $scope.addMoreAnswer = modal;
        $scope.addMoreAnswer.show();
        //$scope.answerDetail = {};
      });

      $scope.closeAddMoreAnswer = function() {
        $scope.addMoreAnswer.hide();
      };

      $scope.openAddMoreAnswer = function($event) {
        $scope.addMoreAnswer.show();
      };
    };

    //追加答案
    $scope.addAnswer = function() {

      if ($scope.$$childTail && $scope.$$childTail.$$childTail && $scope.$$childTail.$$childTail.upLoadFile.files.length > 0) {
        $scope.formAnDataUpLoadFile = $scope.$$childTail.$$childTail.upLoadFile.files;
      }

      if (!$scope.answerDetail.addAnswerContent && (!$scope.formAnDataUpLoadFile || $scope.formAnDataUpLoadFile.length <= 0)) {
        return $ionicPopup.alert({
          title: '提示',
          template: "请填写追加答案内容!",
          okText: '确定'
        }).then(function() {});
      }


      var formData = new FormData();
      if ($scope.formAnDataUpLoadFile) {
        angular.forEach($scope.formAnDataUpLoadFile, function(file) {
          formData.append('files', file);
        });

        formData.append('aid', aid);

        formData.append('content', $scope.answerDetail.addAnswerContent || " ");


        formDataHttp({
            path: defConfig.path + '/auth/extraAnswer',
            method: 'post',
            formData: formData,
            loading: true
          })
          .then(function(data) {
            if (data.result) {
              $scope.closeAddMoreAnswer();
              $scope.formAnDataUpLoadFile = null;
              $scope.getAnswerContent();
            };
          }, function() {});
      } else {
        getHttp({
            path: defConfig.path + '/auth/extraAnswer',
            method: 'post',
            params: {
              aid: aid,
              content: $scope.answerDetail.addAnswerContent
            },
            loading: true
          })
          .then(function(data) {
            $scope.closeAddMoreAnswer();
            $scope.formAnDataUpLoadFile = null;
            $scope.getAnswerContent();
          });
      }

    };


    //未解决层
    $scope.toUnresolved = function() {

      $ionicModal.fromTemplateUrl('templates/unresolvedModal.html', {
        scope: $scope
      }).then(function(modal) {
        $scope.unresolved = modal;
        $scope.unresolved.show();
        $scope.unresolvedContent = {};
      });

      $scope.closeUnresolved = function() {
        $scope.unresolved.hide();
      };

      $scope.openUnresolved = function($event) {
        $scope.unresolved.show();
      };
    };


    //争议
    $scope.submitResolve = function() {
      //$scope.unresolved.queId = $scope.questionItems.id;
      getHttp({
          path: defConfig.path + '/auth/applyArgue',
          method: "post",
          params: {
            queId: $scope.answerDetail.questionId,
            ansId: $scope.answerDetail.id,
            argueText: $scope.unresolvedContent.text,
            argueName: $scope.answerDetail.questionId
          }
        })
        .then(function(data) {
          $scope.closeUnresolved();
        });
    };


    //购买答案
    $scope.checkAnswer = function(qid, aid) {


      var userRe = $ionicPopup.confirm({
        title: '提示',
        template: '确认购买此答案？',
        cancelText: '取消',
        okText: '确定'
      });
      userRe.then(function(res) {
        if (res) {
          Auth.isLoggedIn()
            .then(function() {
              toBuyQus();
            }, function() {
              $scope.login(function() {

                $scope.getAnswerContent(function() {
                  toBuyQus();
                });
              });
            });

          function toBuyQus() {
            getHttp({
                path: defConfig.path + '/auth/thirdCheckAnswer',
                method: 'post',
                params: {
                  aid: aid
                }
              })
              .then(function(data) {
                if (data.result) {
                  $scope.getAnswerContent();
                };
              }, function(err) {
                //alert('账户余额不足，请充值!');
              });
          };
        } else {}
      });

    };

  }
])

//im 即时通讯
.controller('imCtrl', ['$scope', '$stateParams', 'Auth', 'getHttp', 'defConfig', '$ionicModal', 'formDataHttp', '$ionicPopup', '$location', 'loadMore', '$ionicScrollDelegate', '$interval', '$rootScope',
  function($scope, $stateParams, Auth, getHttp, defConfig, $ionicModal, formDataHttp, $ionicPopup, $location, loadMore, $ionicScrollDelegate, $interval, $rootScope) {

    var aid = $stateParams.id,
      iqid = $stateParams.iqid;
    $scope.communicate = {};

    $scope.curType = $location.search().curType;

    if ($scope.curType == 3 || $scope.curType == 2 || $scope.curType == 0) {
      $scope.isMeInfo = true;
    } else {
      $scope.isMeInfo = false;
    }

    function getCommunicateList(cb) {
      getHttp({
          path: defConfig.path + '/auth/getOwnCommunicate',
          method: 'post',
          params: {
            'aid': aid,
            'iqid': iqid
          }
        })
        .then(function(data) {
          $scope.communicateList = [];
          $scope.canRe = 100;
          angular.forEach(data.result, function(item, index) {
            communicateListPush(item, index);
          });


          if (typeof cb === 'function') {
            cb();
          }
        }, function(err) {
          if (typeof cb === 'function') {
            cb();
          }
        });
    };


    function communicateListPush(item, index) {
      item.derection = 1;

      if (item.type == 1) {
        item.derection = 1;
      }

      //      if (item.type == 1  && $scope.curType == 2 ) {
      //        item.derection = 2;
      //        $scope.canRe -= 1;
      //      }else if (item.type == 3 &&  $scope.curType == 0) {
      //        item.derection = 2;
      //        $scope.canRe -= 1;
      //      }else if (item.type == 2 && $scope.curType == 3) {
      //        item.derection = 3;
      //        $scope.canRe -= 1;
      //      }else if (item.type == 2 && ($scope.curType != 2 || $scope.curType == 3)) {
      //        item.derection = 4;
      //      }else if (item.type == 2 && $scope.curType == 0) {
      //        item.derection = 1;
      //      }


      if (item.type == 1) {
        if ($scope.curType == 2) {
          item.derection = 2;
          $scope.canRe -= 1;
        }
      } else if (item.type == 2) {
        if ($scope.curType == 3) {
          item.derection = 3;
          $scope.canRe -= 1;
        }
        if ($scope.curType != 3 && $scope.curType != 0 && $scope.curType != 2) {
          item.derection = 4;
        }
      } else if (item.type == 3) {
        if ($scope.curType == 0) {
          item.derection = 2;
          $scope.canRe -= 1;
        }
      }
      $scope.canReMsg = "您可以交流" + $scope.canRe + "次";
      if ($scope.canRe <= 0) {
        $scope.canReMsg = "剩余0次，您的交流次数已经用完。"
      }

      $scope.communicateList.push(item);
    };

    getCommunicateList(function() {
      $ionicScrollDelegate.scrollBottom();
    });

    $scope.doRefresh = function() {
      getCommunicateList(function() {
        $ionicScrollDelegate.scrollBottom();
        $scope.$broadcast('scroll.refreshComplete');
      });
    }

    Auth.isLoggedIn()
      .then(function() {
        $rootScope.reCommun = $interval(function() {
          getCommunicateList();
        }, 2000)
      }, function() {
        //      $scope.login(function() {
        //        toSuggest ();
        //      });
      });


    $scope.submitCommunicate = function() {

      var needIqid = iqid;
      if ($scope.curType == 2 || $scope.curType == 0) {
        needIqid = null;
      }


      $scope.submiting = true;
      var formData = new FormData();
      if ($scope.$$childTail && $scope.$$childTail.$$childTail && $scope.$$childTail.$$childTail.upLoadFile.files.length > 0) {
        angular.forEach($scope.$$childTail.$$childTail.upLoadFile.files, function(file) {
          formData.append('files', file);
        });

        formData.append('aid', aid);
        formData.append('content', $scope.communicate.content);
        formData.append('iqid', needIqid);
        formDataHttp({
            path: defConfig.path + '/auth/sumbitCommunicate',
            method: 'post',
            formData: formData,
            loading: true
          })
          .then(function(data) {
            if (data.result) {
              communicateListPush(data.result);
              $ionicScrollDelegate.scrollBottom();
              //getCommunicateList ();
              $scope.communicate = {};

            };
          }, function() {});
      } else {
        getHttp({
            path: defConfig.path + '/auth/sumbitCommunicate',
            method: 'post',
            params: {
              'aid': aid,
              content: $scope.communicate.content,
              iqid: needIqid
            }
          })
          .then(function(data) {
            if (data.result) {
              //getCommunicateList ();
              communicateListPush(data.result);
              $ionicScrollDelegate.scrollBottom();
            }
            $scope.communicate = {};
          });
      }



    };
  }
])


//im 对象列表
.controller('imListCtrl', ['$scope', '$stateParams', 'Auth', 'getHttp', 'defConfig', '$ionicModal', 'formDataHttp', '$ionicPopup', '$location', 'loadMore', '$ionicScrollDelegate',
  function($scope, $stateParams, Auth, getHttp, defConfig, $ionicModal, formDataHttp, $ionicPopup, $location, loadMore, $ionicScrollDelegate) {

    $scope.aid = $stateParams.id;

    $scope.curType = $location.search().curType;

    if ($scope.curType == 3 || $scope.curType == 2) {
      $scope.isMeInfo = true;
    } else {
      $scope.isMeInfo = false;
    }


    function getCommunicateList(cb) {
      getHttp({
          path: defConfig.path + '/auth/getCommunicateList',
          method: 'post',
          params: {
            'aid': $scope.aid
          },
          loading: true
        })
        .then(function(data) {
          if (data.result) {
            $scope.communicateList = data.result;
          }


          //$ionicScrollDelegate.scrollBottom();
          if (typeof cb === 'function') {
            cb();
          }
        }, function() {
          //$ionicScrollDelegate.scrollBottom();
          if (typeof cb === 'function') {
            cb();
          }
        });
    };


    getCommunicateList();

    $scope.doRefresh = function() {
      getCommunicateList(function() {
        $scope.$broadcast('scroll.refreshComplete');
      });
    }
  }
])
//im 对象列表
.controller('chatCtrl', ['$scope', '$stateParams', 'Auth', 'getHttp', 'defConfig', '$ionicModal', 'formDataHttp', '$ionicPopup', '$location', 'loadMore', '$ionicScrollDelegate', '$sce',
  function($scope, $stateParams, Auth, getHttp, defConfig, $ionicModal, formDataHttp, $ionicPopup, $location, loadMore, $ionicScrollDelegate, $sce) {

    $scope.aid = $stateParams.id;
    var aid = $stateParams.id,
      iqid = $stateParams.iqid;



    $scope.chatUrl = "http://chat.dazhili.com/public/chat.html";
    if (iqid) {
      $scope.chatUrl = $scope.chatUrl + '?to=' + iqid;
      console.log($scope.chatUrl)
    }

    $scope.chatUrl = $sce.trustAsResourceUrl($scope.chatUrl)


    function getCommunicateList(cb) {
      
    };


    getCommunicateList();

    $scope.doRefresh = function() {
      getCommunicateList(function() {
        $scope.$broadcast('scroll.refreshComplete');
      });
    }
  }
])

//登录--暂未使用
.controller('loginCtrl', ['$scope', '$stateParams', 'Auth', 'showCode', '$rootScope', function($scope, $stateParams, Auth, showCode, $rootScope) {
  //$scope.login ();
  //    showCode('isShowCodeByLogin', $scope);
  //    console.log(1)
  //    $scope.pageName = "登录";
  //    $scope.loginNormal = true;
  //    $scope.loginShow = true;
  //    $scope.doLogin = function() {
  //      Auth.login($scope.loginData, $scope, $rootScope.loginCall);
  //    };
}])

//建议与意见
.controller('suggestCtrl', ['$scope', '$stateParams', 'Auth', 'defConfig', 'getHttp', '$timeout', '$location', '$ionicPopup', '$ionicHistory',
  function($scope, $stateParams, Auth, defConfig, getHttp, $timeout, $location, $ionicPopup, $ionicHistory) {
    //    $ionicHistory.clearCache();
    //    console.log(1)
    $scope.suggest = {};
    //    getHttp({
    //      path:defConfig.path + '/auth/getOAP',
    //      method:'get',
    //      params:{
    //        'opinion':$scope.suggest.content
    //      }
    //    })
    //    .then(function (data) {
    //      if (data.result) {
    //        $scope.suggest.lists = data.result;
    //      }
    //    });
    $scope.submitSuggest = function() {
      Auth.isLoggedIn()
        .then(function() {
          toSuggest();
        }, function() {
          $scope.login(function() {
            toSuggest();
          });
        });
    };



    function toSuggest() {
      getHttp({
          path: defConfig.path + '/auth/addOAP',
          method: 'post',
          params: {
            'opinion': $scope.suggest.content
          }
        })
        .then(function(data) {
          if (data.result) {

            $scope.suggest = {};
            var alertPopup = $ionicPopup.alert({
              title: '提示',
              template: '感谢您对大智力的支持！<br/>稍后返回首页'
            });

            alertPopup.then(function(res) {
              $location.path('/');
            });



            //alert('谢谢！：非常感谢您对大智力的支持！稍后返回首页。');

          };
        });
    };


  }
])


//会员中心
.controller('accountCtrl', ['$scope', '$stateParams', 'Auth', 'defConfig', 'getHttp', '$timeout', '$location', '$ionicPopup', 'formDataHttp', '$window', '$ionicModal', '$rootScope',
  function($scope, $stateParams, Auth, defConfig, getHttp, $timeout, $location, $ionicPopup, formDataHttp, $window, $ionicModal, $rootScope) {
	ionic.Platform.ready(function() {

    $scope.getAccountInfo = function(cb) {
      Auth.isLoggedIn()
        .then(function() {
          toAccountInfo(cb);

        }, function() {
          $scope.login(function() {
            toAccountInfo(cb);
          });
        });
    };



    $scope.getAccountInfo();

    $scope.doRefresh = function() {
      $scope.getAccountInfo(function() {
        $scope.$broadcast('scroll.refreshComplete');
      });
    };

    $scope.submitUserShow = function() {


      var formData = new FormData();

      var myPhotoFile = $rootScope.upLoadImages.files;


      //if(!$scope.$$childTail.$$childTail.upLoadFile.files.length > 0) return;
      angular.forEach(myPhotoFile, function(file) {
        formData.append('myPhoto', file);
      });
      $scope.submiting = true;
      formDataHttp({
          path: defConfig.path + '/auth/upMyPhoto',
          method: 'post',
          formData: formData,
          loading: true
        })
        .then(function(data) {
          $window.location.reload(true);
          $rootScope.upLoadImages = null;
        }, function() {});
    };

    function toAccountInfo(cb) {
      getHttp({
          path: defConfig.path + '/auth/memberInfo',
          method: 'get'
        })
        .then(function(data) {
          if (data.result) {

            $scope.user = data.result;
            if (typeof cb === 'function') cb();
            //          var alertPopup = $ionicPopup.alert({
            //            title: '非常感谢!',
            //            template: '感谢您对大智力的支持！<br/>稍后返回首页'
            //          });
            //          
            //          alertPopup.then(function(res) {
            //            $location.path('/');
            //          });

          };
        });
    };



    $scope.editUserInfo = function() {
      //编辑信息
      $ionicModal.fromTemplateUrl('templates/editUserInfoModal.html', {
        scope: $scope
      }).then(function(modal) {
        $scope.editUserInfoModal = modal;
        $scope.userInfo = {
          nickname: $scope.currentUser.nickname
        };
        $scope.editUserInfoModal.show();
      });

      $scope.closeEditUserInfoModal = function() {
        $scope.editUserInfoModal.hide();
      };

      $scope.openEditUserInfoModal = function($event) {
        $scope.editUserInfoModal.show();
      };



      $scope.submitEditUserInfo = function() {



        getHttp({
            path: defConfig.path + '/auth/checkNkName',
            method: 'post',
            params: {
              nickName: $scope.userInfo.nickname
            },
            loading: true
          })
          .then(function() {
            getHttp({
                path: defConfig.path + '/auth/memberEdit',
                method: 'post',
                params: {
                  'member.nickname': $scope.userInfo.nickname
                }
              })
              .then(function(data) {
                if (data.result) {
                  $ionicPopup.alert({
                    title: '提示',
                    template: '您的昵称保存成功！',
                    okText: '确定'
                  }).then(function() {
                    $scope.closeEditUserInfoModal();
                    $scope.currentUser.nickname = $scope.userInfo.nickname;
                    $scope.user.nickname = $scope.userInfo.nickname;
                  });

                };
              });
          }, function(err) {});
      };


    };


    //退出
    $scope.logout = function() {
      Auth.logout();
    };

	})
  }
])


//账户安全
.controller('safeInfoCtrl', ['$scope', '$stateParams', 'Auth', 'defConfig', 'getHttp', '$timeout', '$location', '$ionicPopup', 'formDataHttp', '$window', '$ionicModal',
  function($scope, $stateParams, Auth, defConfig, getHttp, $timeout, $location, $ionicPopup, formDataHttp, $window, $ionicModal) {


    getHttp({
        path: defConfig.path + '/auth/accountSecurity',
        method: 'get',
      })
      .then(function(data) {
        $scope.accountSecurity = data.result;
      });

  }
])


//修改密码
.controller('rePasswordCtrl', ['$scope', '$stateParams', 'Auth', 'defConfig', 'getHttp', '$timeout', '$location', '$ionicPopup', 'formDataHttp', '$window', '$ionicModal',
  function($scope, $stateParams, Auth, defConfig, getHttp, $timeout, $location, $ionicPopup, formDataHttp, $window, $ionicModal) {


    $scope.passwordChange = {};

    function errTips(msg) {
      $ionicPopup.alert({
        title: '提示',
        template: msg,
        okText: '确定'
      });
    };

    $scope.changePassword = function() {


      if ($scope.passwordChange.newPass != $scope.passwordChange.rePass) {
        return errTips('新密码和重复密码不一致！');
      }
      getHttp({
          path: defConfig.path + '/auth/memberPasswordChange',
          method: 'post',
          params: $scope.passwordChange
        })
        .then(function(data) {
          if (data.result) {
            $ionicPopup.alert({
              title: '提示',
              template: '恭喜，修改成功！',
              okText: '确定'
            }).then(function() {
              $location.path('/question/account/main');
            });

          }

        }, function(err) {
          $scope.errorTips = true;
          $scope.errorTipsLayerHtml = err.error[0].error;
        });
    };

  }
])

//忘记密码
.controller('forgetPasswordCtrl', ['$scope', '$stateParams', 'Auth', 'defConfig', 'getHttp', '$timeout', '$location', '$ionicPopup', 'formDataHttp', '$window', '$ionicModal',
  function($scope, $stateParams, Auth, defConfig, getHttp, $timeout, $location, $ionicPopup, formDataHttp, $window, $ionicModal) {
    $scope.passReset = {};



    $scope.changePhone = function() {
      $scope.passReset.userName = $scope.passReset.phone;
    };
    $scope.passResetSubmit = function() {

      $scope.passReset.phone = null;

      getHttp({
          path: defConfig.path + '/passReset',
          method: 'post',
          params: $scope.passReset
        })
        .then(function(data) {

          if (data.result) {
            $ionicPopup.alert({
              title: '提示',
              template: '恭喜，修改成功请重新登录！',
              okText: '确定'
            }).then(function() {
              //$location.path('/question/lists');
              $scope.login(function() {
                $location.path('/question/lists');
                $timeout(function() {
                  $window.location.reload(true);
                }, 100)

              });
            });
          }

        });


    };



    $scope.changePassword = function() {


      if ($scope.passwordChange.newPass != $scope.passwordChange.rePass) {
        return errTips('新密码和重复密码不一致！');
      }
      getHttp({
          path: defConfig.path + '/auth/memberPasswordChange',
          method: 'post',
          params: $scope.passwordChange
        })
        .then(function(data) {
          if (data.result) {
            $ionicPopup.alert({
              title: '提示',
              template: '恭喜，修改成功！',
              okText: '确定'
            }).then(function() {
              $location.path('/question/account/main');
            });

          }

        }, function(err) {
          $scope.errorTips = true;
          $scope.errorTipsLayerHtml = err.error[0].error;
        });
    };

  }
])

//钱包
.controller('walletCtrl', ['$scope', '$stateParams', 'Auth', 'defConfig', 'getHttp', '$timeout', '$location', '$ionicPopup', 'formDataHttp', '$window', '$ionicModal', '$interval', '$ionicActionSheet', '$sce',
  function($scope, $stateParams, Auth, defConfig, getHttp, $timeout, $location, $ionicPopup, formDataHttp, $window, $ionicModal, $interval, $ionicActionSheet, $sce) {



    function errTips(msg) {
      $ionicPopup.alert({
        title: '提示!',
        template: msg,
        okText: '确定'
      });
    };



    function getVirAccount(cb) {
      //余额
      getHttp({
          path: defConfig.path + '/auth/virAccount',
          method: 'get'
        })
        .then(function(data) {
          if (data.result) {
            $scope.myMoney = data.result;
            if (typeof cb === 'function') cb();
          };
        });
    }

    getVirAccount();

    $scope.doRefresh = function() {
      getVirAccount(function() {
        $scope.$broadcast('scroll.refreshComplete');
      });
    };

    $scope.getAddMoneyModal = function() {
      //充值层
      $ionicModal.fromTemplateUrl('templates/addMoneyModal.html', {
        scope: $scope
      }).then(function(modal) {
        $scope.addMoneyModal = modal;
        $scope.addMoneyModal.show();
      });

      $scope.closeAddMoneyModal = function() {
        $scope.addMoneyModal.hide();
      };

      $scope.openAddMoneyModal = function($event) {
        $scope.addMoneyModal.show();
      };


      $scope.addMoney = function() {
        if (!$scope.myMoney.dt) {
          return $ionicPopup.alert({
            title: '提示',
            template: '请填写充值金额',
            okText: '确定'
          }).then(function() {});
        }
        $scope.showAddMoney = false;
        $scope.closeAddMoneyModal();
        getHttp({
            path: defConfig.path + '/auth/recharge',
            method: 'post',
            params: {
              money: $scope.myMoney.dt
            }
          })
          .then(function(data) {
            if (data.result) {

              var url = defConfig.url + "/dzlStage/goPay?no=" + data.result;
//              var url = defConfig.url +"#/question/account/wallet/payResult/"+data.result;
              
//            

    	      
              
              
              
              if ($scope.isPlatform) {
//                window.open(encodeURI(url), '_blank', 'location=yes');
                
//            	  iframeModal.open($scope,url);
//            	收银台
        	      $ionicModal.fromTemplateUrl('templates/goPayModal.html', {
        	        scope: $scope
        	      }).then(function(modal) {
        	        $scope.goPayModal = modal;
        	        $scope.goPayModal.show();
        	        $scope.closeGoPayModal = function() {
        	        	$scope.paySrc =  $sce.trustAsResourceUrl(url+"&change=1");
    	    	        $scope.goPayModal.hide();
    	    	    	
    	    	    };

    	    	    $scope.openGoPayModal = function($event) {
    	    	    	$scope.goPayModal.show();
    	    	    };
	    	      
    	    	    $scope.paySrc =  $sce.trustAsResourceUrl(url);
    	    	    
    	    	    
    	    	    var reciever = function(e) {

//    	    	    	 debugger;

    	    	    	      var data = e.data;
    	    	    	      if (data === "success") {
    	    	    	    	  
    	    	    	    	  $scope.closeGoPayModal();
    	    	    	    	  getVirAccount();
    	    	    	      }

    	    	    	 };

    	    	    	 if (window.addEventListener){//兼容监听绑定事件---addEventListener：不带on

    	    	    	     window.addEventListener('message', reciever, false);

    	    	    	 }else if (window.attachEvent){

    	    	    	     window.attachEvent('onmessage', reciever);

    	    	    	 }
    	    	    
        	      });
                
              } else {
                window.location.href = url;
              }

            };

          });
      };
    };
    $scope.getForMoneyModal = function() {
      //提现层
      $ionicModal.fromTemplateUrl('templates/getMoneyModal.html', {
        scope: $scope
      }).then(function(modal) {
        $scope.getMoneyModal = modal;
        $scope.getMoneyModal.show();
      });

      $scope.closeGetMoneyModal = function() {
        $scope.getMoneyModal.hide();
      };

      $scope.openGetMoneyModal = function($event) {
        $scope.getMoneyModal.show();
      };


      $scope.getMoneyShow = {};
      $scope.getMoney = {};

      function sendSms() {
        reShowSms();
        getHttp({
            path: defConfig.path + '/auth/sendWdCheckCode',
            method: 'get'
          })
          .then(function(data) {});
      };

      function reShowSms() {
        $scope.resendSmsCode = true;
        var timeDate = 60;
        $scope.resendSmsSec = timeDate + '秒后重新获取';
        var promise = $interval(function() {
          timeDate--;
          $scope.resendSmsSec = timeDate + '秒后重新获取';
          if (timeDate == 0) {
            return cancelPrime();
          }
        }, 1000);

        function cancelPrime() {
          $scope.resendSmsCode = false;
          $interval.cancel(promise);
        }

      };


      $scope.getMoneyPhoneCode = function() {
        sendSms();
      };


      getHttp({
          path: defConfig.path + '/auth/getPayTypes',
          method: 'get'
        })
        .then(function(data) {
          if (data.result) {
            $scope.dzlPayType = data.result;

            $scope.sheetButtons = [];
            angular.forEach($scope.dzlPayType, function(item) {
              $scope.sheetButtons.push({
                text: item.name
              });
            });
          };
        });


      //      $scope.valiTips = function () {
      //        
      //        
      //        if ($scope.getMoney['wds.money'] > $scope.myMoney.balance) {
      //          
      //          $scope.errorTips = true;
      //          $scope.errorTipsLayerHtml = '<strong>提现错误：</strong>申请提现金额，超过账户余额！';
      //          $timeout(function () {
      //            $scope.errorTips = false;
      //          },3000);
      //          
      //          
      //        }
      //      };

      $scope.showPaymentPlatform = function() {
        var hideSheet = $ionicActionSheet.show({
          buttons: $scope.sheetButtons,
          //destructiveText: 'Delete',
          //destructiveButtonClicked: function
          titleText: '选择平台',
          cancelText: '取消',
          cancel: function() {
            // add cancel code..
          },
          buttonClicked: function(index) {


            $scope.getMoneyShow.dzlPayType = $scope.dzlPayType[index];

            $scope.getMoney['wds.dzlPayType.no'] = $scope.dzlPayType[index].no;



            return true;
          }
        });

        // For example's sake, hide the sheet after two seconds
        //       $timeout(function() {
        //         hideSheet();
        //       }, 2000);

      };



      $scope.submitGetMoney = function() {
        if (!$scope.getMoney['wds.money']) {

          return $ionicPopup.alert({
            title: '提示',
            template: '请填写充值金额',
            okText: '确定'
          }).then(function() {});
        }
        if ($scope.getMoney['wds.money'] < 10) {

            return $ionicPopup.alert({
              title: '提示',
              template: '最低提现金额为10元!',
              okText: '确定'
            }).then(function() {});
          }
        if (!$scope.getMoney['wds.account']) {
          return $ionicPopup.alert({
            title: '错误!',
            template: '请填写平台账户',
            okText: '确定'
          }).then(function() {});
        }

        if (!$scope.getMoney['wds.dzlPayType.no']) {
          $scope.getMoney['wds.dzlPayType.no'] = 1;
        }
        getHttp({
            path: defConfig.path + '/auth/applyWithdrawals',
            method: 'post',
            params: $scope.getMoney
          })
          .then(function(data) {
            if (data.result) {

              $ionicPopup.alert({
                title: '提示',
                template: '提现成功',
                okText: '确定'
              }).then(function() {
                $scope.closeGetMoneyModal();

                $timeout(function() {
                  $window.location.reload(true);
                });
              });


            };
          });
      };


    };



  }
])


//充值记录
.controller('rechargeRecordCtrl', ['$scope', '$stateParams', 'Auth', 'defConfig', 'getHttp', '$timeout', '$location', '$ionicPopup', 'formDataHttp', '$window', '$ionicModal', '$sce',
  function($scope, $stateParams, Auth, defConfig, getHttp, $timeout, $location, $ionicPopup, formDataHttp, $window, $ionicModal, $sce) {



    function errTips(msg) {
      $ionicPopup.alert({
        title: '提示!',
        template: msg,
        okText: '确定'
      });
    };


    //充值历史
    function getEechargeRecord(cb) {
      getHttp({
          path: defConfig.path + '/auth/rechargeList',
          method: 'get'
        })
        .then(function(data) {
          if (data.result) {
            $scope.rechargeHistory = data.result;
            if (typeof cb === 'function') cb();
          };
        }, function() {
          if (typeof cb === 'function') cb();
        });
    };
    getEechargeRecord();

    $scope.doRefresh = function() {
      getEechargeRecord(function() {
        $scope.$broadcast('scroll.refreshComplete');
      });
    };

    $scope.goPayPlatform = function (num) {
    	 var url = defConfig.url + "/dzlStage/goPay?no=" + num;
    	
    	if ($scope.isPlatform) {
//      	收银台
  	      $ionicModal.fromTemplateUrl('templates/goPayModal.html', {
  	        scope: $scope
  	      }).then(function(modal) {
  	        $scope.goPayModal = modal;
  	        $scope.goPayModal.show();
  	        	$scope.closeGoPayModal = function() {
  	        		$scope.paySrc =  $sce.trustAsResourceUrl(url+"&change=1");
	    	        $scope.goPayModal.hide();
	    	    	
	    	    };

	    	    $scope.openGoPayModal = function($event) {
	    	    	$scope.goPayModal.show();
	    	    };
  	      
	    	    $scope.paySrc =  $sce.trustAsResourceUrl(url);
	    	    
	    	    
	    	    var reciever = function(e) {

//	    	    	 debugger;

	    	    	      var data = e.data;
	    	    	      if (data === "success") {
	    	    	    	  
	    	    	    	  $scope.closeGoPayModal();
	    	    	    	  getVirAccount();
	    	    	      }

	    	    	 };

	    	    	 if (window.addEventListener){//兼容监听绑定事件---addEventListener：不带on

	    	    	     window.addEventListener('message', reciever, false);

	    	    	 }else if (window.attachEvent){

	    	    	     window.attachEvent('onmessage', reciever);

	    	    	 }
	    	    
  	      });
          
        };
    };

  }
])

//充值结果
.controller('payResultCtrl', ['$scope', '$state', '$stateParams', '$location', function($scope, $state, $stateParams, $location) {

  $scope.payMoney = $stateParams.id;

  if ($location.search().type == 1) {
    $scope.payType = "支付宝";
  } else if ($location.search().type == 2) {
    $scope.payType = "微信支付";
  } else {

  }



  $scope.payDone = function() {
	  
	  
	  if(self!=top) {
		  if (typeof window.postMessage != 'undefined') {// 检查浏览器是否支持postMessage

			  var message="success";
			  window.parent.postMessage(message, '*');;//注意向父窗口发送消息，如果往本页面的iframe发消息，需要指明哪个iframe.contentWindow.postMessage

		}
	  }else {
		  $location.path('/');
	  }
	  
//    if ((ionic.Platform.platform() == 'ios' || ionic.Platform.platform() == 'android' || ionic.Platform.platform() == 'Android') && ionic.Platform.platforms[0] != 'browser') {
//      window.opener = '';
//      window.close();
//    } else {
//      $location.path('/');
//    }
  };
}])

//提现记录
.controller('withdrawalsRecordCtrl', ['$scope', '$stateParams', 'Auth', 'defConfig', 'getHttp', '$timeout', '$location', '$ionicPopup', 'formDataHttp', '$window', '$ionicModal',
  function($scope, $stateParams, Auth, defConfig, getHttp, $timeout, $location, $ionicPopup, formDataHttp, $window, $ionicModal) {



    function errTips(msg) {
      $ionicPopup.alert({
        title: '提示!',
        template: msg,
        okText: '确定'
      });
    };

    //充值历史
    function getwithdrawalsList(cb) {
      getHttp({
          path: defConfig.path + '/auth/withdrawalsList',
          method: 'get'
        })
        .then(function(data) {
          if (data.result) {
            $scope.cashRecords = data.result;
            if (typeof cb === 'function') cb();
          };
        }, function() {
          if (typeof cb === 'function') cb();
        });
    };
    getwithdrawalsList();

    $scope.doRefresh = function() {
      getwithdrawalsList(function() {
        $scope.$broadcast('scroll.refreshComplete');
      });
    };



  }
])


//收支明细
.controller('rechargeOutlayDetailsCtrl', ['$scope', '$stateParams', 'Auth', 'defConfig', 'getHttp', '$timeout', '$location', '$ionicPopup', 'formDataHttp', '$window', '$ionicModal',
  function($scope, $stateParams, Auth, defConfig, getHttp, $timeout, $location, $ionicPopup, formDataHttp, $window, $ionicModal) {



    function errTips(msg) {
      $ionicPopup.alert({
        title: '提示!',
        template: msg,
        okText: '确定'
      });
    };

    function getaccountChangeList(cb) {
      getHttp({
          path: defConfig.path + '/auth/accountChangeList',
          method: 'get'
        })
        .then(function(data) {
          if (data.result) {
            $scope.accountChange = data.result;
            if (typeof cb === 'function') cb();
          };
        }, function() {
          if (typeof cb === 'function') cb();
        });
    };
    getaccountChangeList();

    $scope.doRefresh = function() {
      getaccountChangeList(function() {
        $scope.$broadcast('scroll.refreshComplete');
      });
    };



  }
])



//消息
.controller('myMessageCtrl', ['$scope', '$rootScope', '$stateParams', 'Auth', 'defConfig', 'getHttp', '$timeout', '$location', '$ionicPopup', 'formDataHttp', '$window', '$ionicModal', 'loadMore', '$ionicTabsDelegate',
  function($scope, $rootScope, $stateParams, Auth, defConfig, getHttp, $timeout, $location, $ionicPopup, formDataHttp, $window, $ionicModal, loadMore, $ionicTabsDelegate) {

    $scope.shouldShowDelete = false;
    $scope.shouldShowReorder = false;
    $scope.listCanSwipe = true;

    function errTips(msg) {
      $ionicPopup.alert({
        title: '提示!',
        template: msg,
        okText: '确定'
      });
    };


    //    getHttp({
    //      path:defConfig.path + '/auth/getNotifys',
    //      method:'post'
    //    })
    //    .then(function (data) {
    //      if (data.result) {
    //        $scope.totalCount = data.result.totalCount;
    //        $scope.notifys = data.result;
    //      };
    //    });
    $scope.sortFieldParams = {
      sortType: 'hot',
      sequence: 1,
      path: '/auth/getNotifys'
    };

    function getMyMessage(cb) {

      loadMore($scope, 'notifys', $scope.sortFieldParams, cb);
    };
    getMyMessage();

    $scope.doRefresh = function() {
      getMyMessage(function() {
        $scope.$broadcast('scroll.refreshComplete');
      });
    };



    $scope.setMessageType = function(type, index) {
      $scope.sortFieldParams.type = type;
      loadMore($scope, 'notifys', $scope.sortFieldParams);
      //$ionicTabsDelegate.select(index);
    };
    //删除
    $scope.deleteNotify = function(notice, e) {

      ///auth/notifyRemove?nfIds
      getHttp({
          path: defConfig.path + '/auth/notifyRemove',
          method: 'post',
          params: {
            nfIds: notice.id
          }
        })
        .then(function(data) {
          if (data.result) {
            var index = $scope.notifys.datas.indexOf(notice);
            if (index > -1) {
              $scope.notifys.datas.splice(index, 1);
              if (notice.flag == 0) {
                $scope.$emit('commonFig.notify', 1);



              }
            }
          };
        });
    };


    //标记已读
    $scope.markFlag = function(item, i) {
      if (item.flag == 1) {
        return;
      }
      getHttp({
          path: defConfig.path + '/auth/setFlagNotify',
          method: 'post',
          params: {
            id: item.id
          }
        })
        .then(function(data) {
          if (data.result) {
            $scope.notifys.datas[i].flag = 1;
            if ($rootScope.hasNotify.nCount > 0) {
              $rootScope.hasNotify.nCount -= 1;
            };
          };
        });
    };


    //    $scope.settings = {
    //      path:'/auth/getNotifys',
    //      item:'notifys'
    //    };
    //    //加载更多 
    //    $scope.loadMore = function () {
    //    };



  }
])


//我的问题争议
.controller('myArguesCtrl', ['$scope', '$stateParams', 'Auth', 'defConfig', 'getHttp', '$timeout', '$location', '$ionicPopup', 'formDataHttp', '$window', '$ionicModal', 'loadMore', '$ionicTabsDelegate',
  function($scope, $stateParams, Auth, defConfig, getHttp, $timeout, $location, $ionicPopup, formDataHttp, $window, $ionicModal, loadMore, $ionicTabsDelegate) {

    $scope.shouldShowDelete = false;
    $scope.shouldShowReorder = false;
    $scope.listCanSwipe = true;

    function errTips(msg) {
      $ionicPopup.alert({
        title: '提示!',
        template: msg,
        okText: '确定'
      });
    };

    $scope.active = 1;

    function myApplyArgues(cb) {
      //问题争议（我发出的）
      getHttp({
          path: defConfig.path + '/auth/myApplyArgues',
          method: 'get'
        })
        .then(function(data) {
          if (data.result) {
            $scope.applyArgues = data.result;
            if (typeof cb === 'function') cb();
          };
        });
    };
    myApplyArgues();

    $scope.doRefresh = function() {
      myApplyArgues(function() {
        $scope.$broadcast('scroll.refreshComplete');
      });
    };


    $scope.cfmFinal = {};

    $scope.cfmFinalArg = function(qid) {
      getHttp({
          path: defConfig.path + '/auth/finalArg',
          method: 'post',
          params: {
            queId: qid,
            argueText: $scope.cfmFinal.argueText
          }
        })
        .then(function(data) {
          if (data.result) {
            $ionicPopup.alert({
              title: '提示',
              template: '提交成功，请耐心等待大智力客服处理。',
              okText: '确定'
            }).then(function() {
              myApplyArgues();
            });

          }
        });
    };
    //cfmFinal.finalArg

  }
])


//争议我的回答争议
.controller('arguesToMeCtrl', ['$scope', '$stateParams', 'Auth', 'defConfig', 'getHttp', '$timeout', '$location', '$ionicPopup', 'formDataHttp', '$window', '$ionicModal', 'loadMore', '$ionicTabsDelegate',
  function($scope, $stateParams, Auth, defConfig, getHttp, $timeout, $location, $ionicPopup, formDataHttp, $window, $ionicModal, loadMore, $ionicTabsDelegate) {

    $scope.active = 2;

    function arguesToMe(cb) {
      getHttp({
          path: defConfig.path + '/auth/getAnswerArgues',
          method: 'get'
        })
        .then(function(data) {
          if (data.result) {
            $scope.answerArgues = data.result;
            if (typeof cb === 'function') cb();
          };
        });
    };
    arguesToMe();

    $scope.doRefresh = function() {
      arguesToMe(function() {
        $scope.$broadcast('scroll.refreshComplete');
      });
    };

    $scope.cfmArgue = {};
    //处理争议
    $scope.cfmArgueBackInfo = function(state, parent, i, answerId) {
      getHttp({
          path: defConfig.path + '/auth/cfmArgueBackInfo',
          method: 'post',
          params: {
            cfmState: state,
            ansId: answerId,
            cfmReason: $scope.cfmArgue.reason
          }
        })
        .then(function(data) {
          if (data.result) {
            //          if(state === "Y"){
            //            $scope.answerArgues[parent].argueBackInfos[i].state = 2;
            //          }else {
            //            $scope.answerArgues[parent].argueBackInfos[i].state = 1;
            //          }
            arguesToMe();
          };
        });
    };



  }
])


//名片
.controller('businessCardCtrl', ['$scope', '$stateParams', 'Auth', 'defConfig', 'getHttp', '$timeout', '$location', '$ionicPopup', 'formDataHttp', '$window', '$ionicModal', 'loadMore', '$ionicTabsDelegate', 'appShare', 'wxConfig', '$rootScope', '$filter',
  function($scope, $stateParams, Auth, defConfig, getHttp, $timeout, $location, $ionicPopup, formDataHttp, $window, $ionicModal, loadMore, $ionicTabsDelegate, appShare, wxConfig, $rootScope, $filter) {

    var userId = $stateParams.id;

    $scope.userId = userId;

    if ($stateParams.state == 1) {
      $scope.pageName = '他被采纳的回答';
    };
    $scope.sortFieldParams = {
      path: '/fetchUserAnswer',
      iq: userId,
      state: $stateParams.state
    };

    function getUserAnswer(cb) {

      loadMore($scope, 'questionItems', $scope.sortFieldParams, cb);
    };


    $scope.sortFieldParamsQuestion = {
      path: '/fetchUserQuestion',
      iq: userId
    };

    function getUserQuestion(cb) {

      loadMore($scope, 'questionItemsNor', $scope.sortFieldParamsQuestion, cb);
    };


    
    

    
    
    
    $scope.hideAuthFlag = false;
    function getBusinessCard(cb) {
      getHttp({
          path: defConfig.path + '/userProfile',
          method: 'post',
          params: {
            iq: userId
          }
        })
        .then(function(data) {
          if (data.result) {
            $scope.businessCard = data.result;
            if ($scope.businessCard.memberSet && $scope.businessCard.memberSet.hideAuthFlag  == 1) {
              $scope.hideAuthFlag = true;
            }else {
              $scope.hideAuthFlag = false;
            }
            $scope.bgStyle = $scope.businessCard.member.bgImg? defConfig.url + $scope.businessCard.member.bgImg : './img/bg/default-card-bg.jpg';
            var shareMsgTitle =  '我是' + $scope.businessCard.member.nickname + '，我在大智力，有难题找我';
            var shareMsgDescription =  '提问的问题被购买，还有分成，还不快来？';
            $scope.authApplysState = false;


            if ($scope.businessCard.member.authApplys && $scope.businessCard.member.authApplys.length) {
              $scope.authApplysState = true;
              $scope.authApplys = $scope.businessCard.member.authApplys[$scope.businessCard.member.authApplys.length - 1];
              if ($scope.authApplys.state == 2) {
                shareMsgTitle = '我是' + $scope.businessCard.member.nickname + ',已通过大智力认证，有难题找我'
                shareMsgDescription =  '我擅长：' + $scope.authApplys.remark ;
              }
            }
            

            $scope.shareMsg = {
              url: defConfig.url + '' + $location.path() ,
              title: shareMsgTitle,
              description: shareMsgDescription,
              img: $filter('imgPath')($scope.businessCard.member.headImg, 256) || 'http://www.dazhili.com/img/wx-share-def.jpg',
            }

            $scope.wxShare = {
              title: $scope.shareMsg.title,
              link: $scope.shareMsg.url,
              imgUrl: $scope.shareMsg.img,
              desc: $scope.shareMsg.description,
              success: function(res) {
              },
              canel: function() {}
            }
            // getUserAnswer();
            // getUserQuestion();

            var ua = navigator.userAgent.toLowerCase();
            if (ua.match(/MicroMessenger/i) == "micromessenger") {
              wxConfig($scope.wxShare);
            }


            $scope.isSelf = $scope.businessCard.isMySelf;
            
            // if ($scope.currentUser && $scope.currentUser.showId == $scope.businessCard.member.showId ) {
            //   $scope.isSelf = true;
            // }else {
            //   $scope.isSelf = false;
            // }
            
            if (typeof cb === "function") cb();
          }
        }, function(err) {
          if (typeof cb === "function") cb();
        });
        
    };
    getBusinessCard();

    $scope.doRefresh = function() {
      getBusinessCard(function() {
        $scope.$broadcast('scroll.refreshComplete');
      });
    };


    $scope.changeAuthFlag = function () {
      var i = 0;
      $scope.hideAuthFlag = !$scope.hideAuthFlag;
      if ($scope.hideAuthFlag ) {
        i = 1;
      }else {
        i = 0;
      }
      
      getHttp({
        path: defConfig.path + '/auth/addMemSetInfo',
        method: 'post',
        params: {
          hideAuthFlag: i
        }
      })
      .then(function(data) {
        getBusinessCard();
        // console.log(data)
      })
    }




    // 更换背景
    $scope.changeBgImg = function() {


      var formData = new FormData();

      var myPhotoFile = $rootScope.upLoadImages.files;


      //if(!$scope.$$childTail.$$childTail.upLoadFile.files.length > 0) return;
      angular.forEach(myPhotoFile, function(file) {
        formData.append('bgImg', file);
      });
      $scope.submiting = true;
      formDataHttp({
          path: defConfig.path + '/auth/uploadBgImg',
          method: 'post',
          formData: formData,
          loading: true
        })
        .then(function(data) {
          getBusinessCard();
          // console.log(data)
          // $window.location.reload(true);
          $rootScope.upLoadImages = null;
        }, function() {});
    };

    //更换头像
    $scope.submitUserImg = function() {


      var formData = new FormData();

      var myPhotoFile = $rootScope.upLoadImages.files;


      //if(!$scope.$$childTail.$$childTail.upLoadFile.files.length > 0) return;
      angular.forEach(myPhotoFile, function(file) {
        formData.append('myPhoto', file);
      });
      $scope.submiting = true;
      formDataHttp({
          path: defConfig.path + '/auth/upMyPhoto',
          method: 'post',
          formData: formData,
          loading: true
        })
        .then(function(data) {
          getBusinessCard();
          $rootScope.upLoadImages = null;
        }, function() {});
    };


    //更换背景
    // $scope.changeBgImg = function () {
    //   console.log(1,$scope.currentUser.showId,  $scope.businessCard.member.showId)
    // };
         

    //分享
    $scope.appShare = function () {
      appShare ($scope, $scope.shareMsg);
    }

    //关注
    $scope.toFollw = function() {

      if ($scope.businessCard.isFollow) {
        getHttp({
          path: defConfig.path + '/auth/memberFollowDel',
          method: 'post',
          params: {
            followUserName: userId
          }
        }).then(function(data) {
          if (data.result) {
            $scope.businessCard.isFollow = false;
            $scope.businessCard.followCount -= 1;
            if ($scope.businessCard.followCount < 0) {
              $scope.businessCard.followCount = 0;
            }
          };
        });
      } else {
        getHttp({
          path: defConfig.path + '/auth/memberFollow',
          method: 'post',
          params: {
            followUserName: userId
          }
        }).then(function(data) {
          if (data.result) {
            $scope.businessCard.isFollow = true;
            $scope.businessCard.followCount += 1;
          };
        });
      }
    };

  }
])

//关注列表
.controller('followbyCtrl', ['$scope', '$stateParams', 'Auth', 'defConfig', 'getHttp', '$timeout', '$location', '$ionicPopup', 'formDataHttp', '$window', '$ionicModal', 'loadMore', '$ionicTabsDelegate',
  function($scope, $stateParams, Auth, defConfig, getHttp, $timeout, $location, $ionicPopup, formDataHttp, $window, $ionicModal, loadMore, $ionicTabsDelegate) {

    var userId = $stateParams.id;

    $scope.userId = userId;


    function getfollow(cb) {
      getHttp({
          path: defConfig.path + '/getFollowByIq',
          method: 'post',
          params: {
            followId: userId
          }
        })
        .then(function(data) {
          if (data.result) {
            $scope.followLists = data.result;
            if (typeof cb === "function") cb();
          }
        }, function(err) {
          if (typeof cb === "function") cb();
        });
    };
    getfollow();

    $scope.doRefresh = function() {
      getfollow(function() {
        $scope.$broadcast('scroll.refreshComplete');
      });
    };


  }
])

//他的提问
.controller('userQuestionCtrl', ['$scope', '$stateParams', 'Auth', 'defConfig', 'getHttp', '$timeout', '$location', '$ionicPopup', 'formDataHttp', '$window', '$ionicModal', 'loadMore', '$ionicTabsDelegate',
  function($scope, $stateParams, Auth, defConfig, getHttp, $timeout, $location, $ionicPopup, formDataHttp, $window, $ionicModal, loadMore, $ionicTabsDelegate) {

    var userId = $stateParams.id;

    $scope.userId = userId;
    $scope.pageName = '他的提问';
    $scope.sortFieldParams = {
      path: '/fetchUserQuestion',
      iq: userId
    };

    function getUserQuestion(cb) {

      loadMore($scope, 'questionItems', $scope.sortFieldParams, cb);
    };


    getUserQuestion();

    $scope.doRefresh = function() {
      getUserQuestion(function() {
        $scope.$broadcast('scroll.refreshComplete');
      });
    };


  }
])

//他的回答
.controller('userAnswerCtrl', ['$scope', '$stateParams', 'Auth', 'defConfig', 'getHttp', '$timeout', '$location', '$ionicPopup', 'formDataHttp', '$window', '$ionicModal', 'loadMore', '$ionicTabsDelegate',
  function($scope, $stateParams, Auth, defConfig, getHttp, $timeout, $location, $ionicPopup, formDataHttp, $window, $ionicModal, loadMore, $ionicTabsDelegate) {

    var userId = $stateParams.id;

    $scope.userId = userId;
    $scope.pageName = '他的回答';

    if ($stateParams.state == 1) {
      $scope.pageName = '他被采纳的回答';
    };
    $scope.sortFieldParams = {
      path: '/fetchUserAnswer',
      iq: userId,
      state: $stateParams.state
    };

    function getUserAnswer(cb) {

      loadMore($scope, 'questionItems', $scope.sortFieldParams, cb);
    };


    getUserAnswer();

    $scope.doRefresh = function() {
      getUserAnswer(function() {
        $scope.$broadcast('scroll.refreshComplete');
      });
    };


  }
])


//验证邮箱
.controller('checkEmailCtrl', ['$scope', '$stateParams', 'Auth', 'defConfig', 'getHttp', '$timeout', '$location', '$ionicPopup', 'formDataHttp', '$window', '$ionicModal',
  function($scope, $stateParams, Auth, defConfig, getHttp, $timeout, $location, $ionicPopup, formDataHttp, $window, $ionicModal) {


    //    getHttp({
    //      path:defConfig.path + '/auth/accountSecurity',
    //      method:'get',
    //    })
    //    .then(function (data) {
    //      $scope.accountSecurity = data.result;
    //    });

    $scope.checkEmail = {};
    getHttp({
        path: defConfig.path + '/auth/accountSecurity',
        method: 'get',
      })
      .then(function(data) {
        $scope.accountSecurity = data.result;


        //accountSecurity.isCheckEmail

        if ($scope.accountSecurity.isCheckEmail) {

        } else {
          var mailCode = $location.search().mailCode;

          if (mailCode) {
            $scope.checkEmail.checking = true;
            getHttp({
                path: defConfig.path + '/checkMail',
                method: 'post',
                params: {
                  mailCode: mailCode
                }
              })
              .then(function(data) {
                if (data.result) {
                  $scope.checkEmail.checkResult = true;
                  $scope.checkEmail.tips = "恭喜，邮箱验证通过，安全防护更上一层楼。";
                  $ionicPopup.alert({
                    title: '提示',
                    template: '恭喜，邮箱验证通过，安全防护更上一层楼。',
                    okText: '确定'
                  }).then(function() {
                    $location.path('/question/account/safeInfo');
                  });
                }
              }, function(err) {
                $scope.checkEmail.checkResult = false;
                $scope.checkEmail.tips = err.error[0].error + "，请重新发送";

                $timeout(function() {
                  $scope.checkEmail.checking = false;
                }, 1000);
              });
          }
        }
      });

    function errTips(msg) {
      $ionicPopup.alert({
        title: '提示!',
        template: msg,
        okText: '确定'
      });
    };



    $scope.checkEmailSubmit = function() {

      if ($scope.checkEmail.bindMail) {
        getHttp({
            path: defConfig.path + '/auth/sendCheckMail',
            method: 'post',
            params: {
              bindMail: $scope.checkEmail.bindMail
            }
          })
          .then(function(data) {
            if (data.result) {

              $ionicPopup.alert({
                title: '提示',
                template: '恭喜，邮件发送成功,请注意查收邮件！',
                okText: '确定'
              }).then(function() {
                $location.path('/question/account/safeInfo');
              });
            }
          });
      }
    };

  }
])


//认证
.controller('vipCtrl', ['$scope', '$stateParams', 'Auth', 'defConfig', 'getHttp', '$timeout', '$location', '$ionicPopup', 'formDataHttp', '$window', '$ionicModal',
  function($scope, $stateParams, Auth, defConfig, getHttp, $timeout, $location, $ionicPopup, formDataHttp, $window, $ionicModal) {


    $scope.setVipInfo = {};


    $scope.findMyApply = function (cb) {


      getHttp({
        path: defConfig.path + '/auth/findMyApply',
        method: 'get'
      })
      .then(function(data) {
        if (data.result && data.result.length > 0) {
          $scope.hasApply = true;
          $scope.setVipInfo = data.result[data.result.length - 1];
        }
        $scope.findIndustry();
        if (typeof cb === "function") cb();
      },function () {
        if (typeof cb === "function") cb();
      });

      
    };

    $scope.findMyApply ();
    $scope.doRefresh = function() {
      $scope.findMyApply(function() {
        $scope.$broadcast('scroll.refreshComplete');
      });
    };

    $scope.findIndustry = function () {
      getHttp({
        path: defConfig.path + '/auth/findIndustry',
        method: 'get'
      })
      .then(function(data) {
        if (data.result) {
          var rst = data.result;
          //$scope.industry = data.result;
          if (rst) {
            var data_ = {};
            var data_f = [];
            for (var i = 0; i < rst.length; i++) {
              if (rst[i].pid == '') {
                data_[rst[i].id] = rst[i].name;
              }
            };
            for (var i = 0; i < rst.length; i++) {
              if (rst[i].pid != '') {
                rst[i].pid = data_[rst[i].pid];
                data_f.push(rst[i]);
              }
            }
          }
          $scope.industry = data_f;
          $scope.industry.unshift({
            name: '请选择行业',
            id: -1
          });
          $scope.setVipInfo.selectIndustry = $scope.industry[0];
        };
      }, function() {


      });
    };

    

    $scope.reApplyVip = function() {
      $scope.hasApply = false;
    };

    $scope.selectIndustryObj = function(item) {
      getHttp({
          path: defConfig.path + '/auth/findAInfoByIndustry',
          method: 'post',
          params: {
            ityCode: $scope.setVipInfo.selectIndustry.code
          }
        })
        .then(function(data) {
          if (data.result) {
            $scope.aInfoByIndustry = data.result;
            $scope.aInfoByIndustry.unshift({
              name: '请选择职称',
              id: -1
            });
            $scope.setVipInfo.aInfo = $scope.aInfoByIndustry[0];
          }
        }, function() {

        });


      //      $scope.selectIndustry = $scope.$$childHead.selectIndustry;
    };


    $scope.selectAInfo = function() {
      //$scope.aInfo = $scope.$$childHead.aInfo;
    };


    $scope.isSubmitAuthApply = false;
    $scope.submitAuthApply = function() {

      function errTips(msg) {
        $ionicPopup.alert({
          title: '提示',
          template: msg + '不能为空',
          okText: '确定'
        });
      };

      if (!$scope.setVipInfo.shortDetail) {
        return errTips('认证名称');
      }
      // if (!$scope.setVipInfo.name) {
      //   return errTips('真实姓名');
      // }
      // if (!$scope.setVipInfo.idcard) {
      //   return errTips('身份证号码');
      // }


      if ($scope.setVipInfo.selectIndustry.id === -1) {
        return errTips('请选择行业');
      }
      // if (!$scope.setVipInfo.aInfo || $scope.setVipInfo.aInfo.id === -1) {
      //   return errTips('请选择行业职称');
      // }

      var formData = new FormData();
      if (!$scope.setVipInfo.list) {
        return errTips('证明材料照片');
      };

      $scope.isSubmitAuthApply = true;
      // return console.log($scope.setVipInfo.list)
      angular.forEach($scope.setVipInfo.list.files, function(file) {
        formData.append('applyFiles', file);
      });

      formData.append('authApply.dzlIndustry.id', $scope.setVipInfo.selectIndustry.id);
      // formData.append('authApply.dzlCode.id.code', $scope.setVipInfo.aInfo.id.code);
      // formData.append('authApply.dzlCode.id.typeCode', $scope.setVipInfo.aInfo.id.typeCode);
      formData.append('authApply.detail', $scope.setVipInfo.detail);
      formData.append('authApply.shortDetail', $scope.setVipInfo.shortDetail);
      // formData.append('authApply.name', $scope.setVipInfo.name);
      // formData.append('authApply.idcard', $scope.setVipInfo.idcard);

      formDataHttp({
          path: defConfig.path + '/auth/authApply',
          method: 'post',
          formData: formData
        })
        .then(function(data) {
          if (data.result) {
            $ionicPopup.alert({
                title: '提示',
                template: '提交成功，请耐心等待审核！',
                okText: '确定'
              })
              .then(function() {

                $location.path('/question/account/main');
                $timeout(function() {
                  $window.location.reload(true);
                });
              });
          };
          $scope.isSubmitAuthApply = false;
        }, function() {
          $scope.isSubmitAuthApply = false;
        });
    };


  }
])


//实名认证
.controller('verifiedCtrl', ['$scope', '$stateParams', 'Auth', 'defConfig', 'getHttp', '$timeout', '$location', '$ionicPopup', 'formDataHttp',
  function($scope, $stateParams, Auth, defConfig, getHttp, $timeout, $location, $ionicPopup, formDataHttp) {



    //获取实名信息
    //个人认证参数-->>dzlVeriflddIdv.idNumbe=身份证号&dzlVeriflddIdv.name=真实姓名&idPhotoF=身份证正面照&idPhotoB=身份证反面照
    
    $scope.verifiedInfo = {};

    // $scope.choice = {}

    $scope.verifiedType = 1;
    var typeId = $location.search().id;
    if (typeId) {
      $scope.verifiedType = typeId;
    }
    $scope.changeType = function (i) {
      $scope.verifiedType = i;
      $location.search('id', i);
    };

    $scope.getVerifiddApplyInfo = function (cb) {

      getHttp({
        path: defConfig.path + '/auth/getVerifiddApplyInfo',
        method: 'get'
      })
      .then(function(data) {
        if (data.result) {
          $scope.verifiddApplyInfo = data.result;
          // $scope.hasApply = true;
          // $scope.setVipInfo = data.result[0];
        }else {
          $scope.verifiddApplyInfo = {
            realState: 0
          }
        }
        if (typeof cb === "function") cb();
      },function () {
        // $scope.verifiddApplyInfo = {
        //     realState: 0
        //   }
        if (typeof cb === "function") cb();
      });
      
    };

    $scope.getVerifiddApplyInfo ();

    $scope.doRefresh = function() {
      $scope.getVerifiddApplyInfo(function() {
        $scope.$broadcast('scroll.refreshComplete');
      });
    };


    $scope.findIndustry = function () {
      getHttp({
        path: defConfig.path + '/auth/findIndustry',
        method: 'get'
      })
      .then(function(data) {
        if (data.result) {
          var rst = data.result;
          //$scope.industry = data.result;
          if (rst) {
            var data_ = {};
            var data_f = [];
            for (var i = 0; i < rst.length; i++) {
              if (rst[i].pid == '') {
                data_[rst[i].id] = rst[i].name;
              }
            };
            for (var i = 0; i < rst.length; i++) {
              if (rst[i].pid != '') {
                rst[i].pid = data_[rst[i].pid];
                data_f.push(rst[i]);
              }
            }
          }
          $scope.industry = data_f;
          $scope.industry.unshift({
            name: '请选择行业',
            id: -1
          });
          $scope.verifiddEnt.ityId = $scope.industry[0];
        };
      }, function() {


      });
    }
    $scope.findIndustry();

    //提交个人认证
    $scope.submitVerified = function () {

      function errTips(msg) {
        $ionicPopup.alert({
          title: '提示',
          template: msg + '不能为空',
          okText: '确定'
        });
      };


      
      if (!$scope.verifiedInfo.name) {
        return errTips('真实姓名');
      }
      if (!$scope.verifiedInfo.idNumber) {
        return errTips('身份证号码');
      }
      if (!$scope.verifiedInfo.idPhotoF) {
        return errTips('身份证正面照');
      }
      if (!$scope.verifiedInfo.idPhotoB) {
        return errTips('身份证反面照');
      }
      // formData
      var formData = new FormData(); 
      formData.append('dzlVeriflddIdv.name', $scope.verifiedInfo.name);
      formData.append('dzlVeriflddIdv.idNumber', $scope.verifiedInfo.idNumber);
      formData.append('idPhotoF', $scope.verifiedInfo.idPhotoF.files[0]);
      formData.append('idPhotoB', $scope.verifiedInfo.idPhotoB.files[0]);
      $scope.isSubmiting = true;
      formDataHttp({
          path: defConfig.path + '/auth/verifiddApply',
          method: 'post',
          formData: formData
        })
        .then(function(data) {
          if (data.result) {
            $ionicPopup.alert({
                title: '提示',
                template: '提交成功，请耐心等待审核！',
                okText: '确定'
              })
              .then(function() {
                $scope.getVerifiddApplyInfo();
                // $location.path('/question/account/main');
                // $timeout(function() {
                //   $window.location.reload(true);
                // });
              });
          };
          $scope.isSubmiting = false;
        }, function() {
          $scope.isSubmiting = false;
        });

    };


    //企业认证参数--》dzlVerifiddEnt.regNo=工商执照注册号/统一社会信用代码不能为空&dzlVerifiddEnt.entName&businessLicence=企业执照&orgCert=组织机构证&taxCert=税务登记&veText=企业擅长&ityId=行业
    //提交企业认证
    $scope.verifiddEnt = {};
    $scope.submitVerifiddEnt = function () {

      function errTips(msg) {
        $ionicPopup.alert({
          title: '提示',
          template: msg + '不能为空',
          okText: '确定'
        });
      };


      if (!$scope.verifiddEnt.entName) {
        return errTips('企业名称');
      }
      if (!$scope.verifiddEnt.regNo) {
        return errTips('工商执照注册号/统一社会信用代码');
      }
      if (!$scope.verifiddEnt.businessLicence) {
        return errTips('企业执照');
      }
      if (!$scope.verifiddEnt.orgCert) {
        return errTips('组织机构证');
      }
      if (!$scope.verifiddEnt.taxCert) {
        return errTips('税务登记');
      }
      if (!$scope.verifiddEnt.ityId || $scope.verifiddEnt.ityId.id == -1) {
        return errTips('所属行业');
      }
      if (!$scope.verifiddEnt.veText) {
        return errTips('擅长领域');
      }
      // formData
      var formData = new FormData(); 
      formData.append('dzlVerifiddEnt.entName', $scope.verifiddEnt.entName);
      formData.append('dzlVerifiddEnt.regNo', $scope.verifiddEnt.regNo);
      formData.append('businessLicence', $scope.verifiddEnt.businessLicence.files[0]);
      formData.append('orgCert', $scope.verifiddEnt.orgCert.files[0]);
      formData.append('taxCert', $scope.verifiddEnt.taxCert.files[0]);
      formData.append('dzlVerifiddEnt.veText', $scope.verifiddEnt.veText);
      formData.append('dzlVerifiddEnt.ityId', $scope.verifiddEnt.ityId.id);
      $scope.isSubmiting = true;
      formDataHttp({
          path: defConfig.path + '/auth/verifiddApply',
          method: 'post',
          formData: formData
        })
        .then(function(data) {
          if (data.result) {
            $ionicPopup.alert({
                title: '提示',
                template: '提交成功，请耐心等待审核！',
                okText: '确定'
              })
              .then(function() {
                $scope.getVerifiddApplyInfo();
                // $location.path('/question/account/main');
                // $timeout(function() {
                //   $window.location.reload(true);
                // });
              });
          };
          $scope.isSubmiting = false;
        }, function() {
          $scope.isSubmiting = false;
        });

    };



  }
])
//帮助
.controller('helpCtrl', ['$scope', '$stateParams', 'Auth', 'defConfig', 'getHttp', '$timeout', '$location', '$ionicPopup', 'loadMore',
  function($scope, $stateParams, Auth, defConfig, getHttp, $timeout, $location, $ionicPopup, loadMore) {

    $scope.sortFieldParams = {
      path: '/getHelpList'
    };

    function getHelpList(cb) {

      loadMore($scope, 'helpQAlist', $scope.sortFieldParams, cb);
    };
    getHelpList();

    $scope.doRefresh = function() {
      getHelpList(function() {
        $scope.$broadcast('scroll.refreshComplete');
      });
    };


  }
])

//帮助分类
.controller('helpListCtrl', ['$scope', '$stateParams', 'Auth', 'defConfig', 'getHttp', '$timeout', '$location', '$ionicPopup', 'loadMore',
  function($scope, $stateParams, Auth, defConfig, getHttp, $timeout, $location, $ionicPopup, loadMore) {


    var helpId = $stateParams.id;
    $scope.pageName = $location.search().title;

    $scope.sortFieldParams = {
      path: '/getHelpList',
      cateNo: helpId
    };

    function getHelpList(cb) {

      loadMore($scope, 'helpQAlist', $scope.sortFieldParams, cb);
    };
    getHelpList();

    $scope.doRefresh = function() {
      getHelpList(function() {
        $scope.$broadcast('scroll.refreshComplete');
      });
    };


    $scope.seleCurrentTab = function(i) {
      $scope.currentTab = i;
    };



  }
])



//评价
.controller('assessCtrl', ['$scope', '$stateParams', 'Auth', 'defConfig', 'getHttp', '$timeout', '$location', '$ionicPopup', 'loadMore', '$ionicModal', '$window', '$state',
  function($scope, $stateParams, Auth, defConfig, getHttp, $timeout, $location, $ionicPopup, loadMore, $ionicModal, $window, $state) {



    var aid = $stateParams.id;

    $scope.assess = {};
    $scope.assess.ansId = aid;

    $scope.assessSubmit = function() {

      if (!$scope.assess.assessText) {
        //        $ionicPopup.alert({
        //          title: '提示',
        //          template: '请填写评价内容！',
        //          okText: '确定'
        //        })

        $scope.assess.assessText = "此人走的很匆匆，什么都没留下！";
      };

      if (!$scope.assess.score) {
        $scope.assess.score = 5;
      }
      getHttp({
          path: defConfig.path + '/auth/ansIdAssess',
          method: "post",
          params: $scope.assess
        })
        .then(function(data) {
          if (data.result) {
        	  $state.transitionTo('question.answerDetailId',{id:aid},{
        		  	reload: true,
        		    inherit: false,
        		    notify: true
        	  });
//            $location.path('/question/answerDetail/' + aid);
          }
        }, function () {
        	$state.transitionTo('question.answerDetailId',{id:aid},{
        		reload: true,
        	    inherit: false,
        	    notify: true
    	    });
        });

    };



    //$ionicGoBack()
    $scope.goBack = function() {
      $location.path('/question/answerDetail/' + aid);
    };

  }
])



//评价列表
.controller('assessListsCtrl', ['$scope', '$stateParams', 'Auth', 'defConfig', 'getHttp', '$timeout', '$location', '$ionicPopup', 'loadMore',
  function($scope, $stateParams, Auth, defConfig, getHttp, $timeout, $location, $ionicPopup, loadMore) {

    $scope.answerId = $stateParams.id;
    //    $scope.doAnswerRefresh = function () {
    //      $scope.answerId = null;
    //      $timeout(function () {
    //        $scope.answerId = $stateParams.id;
    //        $scope.$broadcast('scroll.refreshComplete');
    //      },500);
    //      
    //      
    //    };
  }
])

//退款申请
.controller('applyRefundCtrl', ['$scope', '$stateParams', 'Auth', 'defConfig', 'getHttp', '$timeout', '$location', '$ionicPopup', 'loadMore', '$ionicModal', '$window', '$ionicHistory', 'formDataHttp',
  function($scope, $stateParams, Auth, defConfig, getHttp, $timeout, $location, $ionicPopup, loadMore, $ionicModal, $window, $ionicHistory, formDataHttp) {
    var aid = $stateParams.id;

    $scope.refund = {
      rfdAnsId: aid
    };

    $scope.applyRefund = function() {
      var formData = new FormData();
      if ($scope.$$childTail && $scope.$$childTail.$$childTail && $scope.$$childTail.$$childTail.upLoadFile.files.length > 0) {
        angular.forEach($scope.$$childTail.$$childTail.upLoadFile.files, function(file) {
          formData.append('affixs', file);
        });

        formData.append('rfdAnsId', aid);
        formData.append('rfdApplyCause', $scope.refund.rfdApplyCause);
        formDataHttp({
            path: defConfig.path + '/auth/applyRefund',
            method: 'post',
            formData: formData,
            loading: true
          })
          .then(function(data) {
            if (data.result) {
              $scope.goToPayBacks();
            };
            $scope.refund = {};
          }, function() {
            $scope.goToPayBacks();
          });
      } else {
        getHttp({
            path: defConfig.path + '/auth/applyRefund',
            method: 'post',
            params: $scope.refund,
            loading: true
          })
          .then(function(data) {
            if (data.result) {
              $scope.goToPayBacks();
            }
            $scope.refund = {};
          }, function(err) {

            $scope.goToPayBacks();
          });
      }
    }

    $scope.goToPayBacks = function() {
      $location.path('/question/account/payBacks').search('curPath', '1');
    }

    $scope.goBack = function() {
      $location.path('/question/answerDetail/' + aid);
    };



  }
])



//退款申请列表
.controller('payBacksCtrl', ['$scope', '$stateParams', 'Auth', 'defConfig', 'getHttp', '$timeout', '$location', '$ionicPopup', 'loadMore', '$ionicModal', '$window', '$ionicHistory', 'formDataHttp', '$ionicTabsDelegate',
  function($scope, $stateParams, Auth, defConfig, getHttp, $timeout, $location, $ionicPopup, loadMore, $ionicModal, $window, $ionicHistory, formDataHttp, $ionicTabsDelegate) {
    $scope.shouldShowDelete = false;
    $scope.shouldShowReorder = false;
    $scope.listCanSwipe = true;

    $scope.curPath = $location.search().curPath;

    function getPayBacks(cb) {
      $scope.payBacks = {};

      if ($scope.curPath == "1") {
        $scope.httpPath = "findBuyAnswerPayBacks";
        //        $ionicTabsDelegate.select(0);
      } else {
        $scope.httpPath = "findBuyAnswerPayBacksToMe";
        //        $timeout(function () {
        //          $ionicTabsDelegate.select(1);
        //        })
      }

      getHttp({
          path: defConfig.path + '/auth/' + $scope.httpPath,
          method: 'get'
        })
        .then(function(data) {
          $scope.payBacks = data.result;

          if (typeof cb === "function") cb();

        }, function() {
          if (typeof cb === "function") cb();
        });
    }

    getPayBacks();

    $scope.doRefresh = function() {
      getPayBacks(function() {
        $scope.$broadcast('scroll.refreshComplete');
      });
    };

    $scope.setTab = function(type, index) {
      if (type == "0") {
        $location.search('curPath', 1);
        $scope.curPath = 1;
        getPayBacks()
      } else {
        $location.search('curPath', 2);
        $scope.curPath = 2;
        getPayBacks()
      }
    }

    $scope.openPayBackResult = function($event, id) {
      //搜索层
      $ionicModal.fromTemplateUrl('templates/payBackResultModal.html', {
        scope: $scope
      }).then(function(modal) {
        $scope.payBackResultModal = modal;
        $scope.payBackResultModal.show();
        $scope.modalResult = {
          bkId: id
        };
        modalConten();
      });
      $scope.closePayBackResultModal = function() {
        $scope.payBackResultModal.hide();
      };
    };

    function modalConten() {

      if ($scope.curPath == 1) {
        $scope.modalName = "申请仲裁";
        $scope.postPath = '/auth/applyBuyAnswerPayBackToFinal';
      } else {
        $scope.modalName = "退款处理";
        $scope.postPath = '/auth/confimBuyAnswerPayBack';
      }

    }

    $scope.confimBuyAnswerPayBack = function(state, id) {

      if ($scope.curPath == 1) {
        $scope.postParams = {
          bkId: id,
          rfdApplyFinalDetail: $scope.modalResult.rfdAskCause
        }
      } else {
        $scope.postParams = {
          bkId: id,
          rfdState: state,
          rfdAskCause: "同意"
        }
      }

      getHttp({
          path: defConfig.path + $scope.postPath,
          method: "post",
          params: $scope.postParams
        })
        .then(function(data) {
          $scope.closePayBackResultModal();
          getPayBacks();
        }, function() {
          $scope.closePayBackResultModal();
          getPayBacks();
        })
    }
    
    
    $scope.confimAgreePayBack = function(state, id) {

        
          $scope.postParams = {
            bkId: id,
            rfdState: state,
            rfdAskCause: "同意"
          }
          
          
          
          var upApp = $ionicPopup.confirm({
              title: '提示',
              template: '确定同意退款？！',
              cancelText: '取消',
              okText: '确定'
            });
            upApp.then(function(res) {
              if (res) {
            	  getHttp({
                      path: defConfig.path + '/auth/confimBuyAnswerPayBack',
                      method: "post",
                      params: $scope.postParams
                    })
                    .then(function(data) {
//                      $scope.closePayBackResultModal();
                      getPayBacks();
                    }, function() {
//                      $scope.closePayBackResultModal();
                      getPayBacks();
                    })
              }
            })

       
      }

  }
])

//下载App
.controller('downloadAppCtrl', ['$scope', '$stateParams', 'Auth', 'defConfig', 'getHttp', '$timeout', '$location', '$ionicPopup', 'loadMore',
  function($scope, $stateParams, Auth, defConfig, getHttp, $timeout, $location, $ionicPopup, loadMore) {

    var ua = navigator.userAgent.toLowerCase();
    if (ua.match(/MicroMessenger/i) == "micromessenger") {

      $scope.androidDownUrl = 'http://a.app.qq.com/o/simple.jsp?pkgname=com.dazhili.dzl';
    }

  }
])

//关于
.controller('aboutCtrl', ['$scope', '$stateParams', 'Auth', 'defConfig', 'getHttp', '$timeout', '$location', '$ionicPopup', 'loadMore', '$cordovaAppVersion',
  function($scope, $stateParams, Auth, defConfig, getHttp, $timeout, $location, $ionicPopup, loadMore, $cordovaAppVersion) {

    $timeout(function() {
      if (window.cordova) {
        $cordovaAppVersion.getVersionNumber().then(function(version) {
          $scope.currentVersion = version;
        });
      }
    }, 2000)


    $scope.currDate = new Date().getFullYear();

    $scope.appVersionUpdate = function() {
      $cordovaAppVersion.getVersionNumber().then(function(version) {
        //如果本地与服务端的APP版本不符合

        getHttp({
            path: '/appUpdate/app/version?time' + new Date().getTime(),
            method: 'get'
          })
          .then(function(data) {
            var iosVersion = data.result.ios.version;
            var androidVersion = data.result.android.version,
              androidVersionFile = data.result.android.fileName;

            $scope.appVersion = data.result;


            //安卓版本
            if ($scope.isAndroid) {
              if (androidVersion > version) {
                var upApp = $ionicPopup.confirm({
                  title: '提示',
                  template: '有新版本需要更新，建议您使用新版本！',
                  cancelText: '取消',
                  okText: '立即更新'
                });
                upApp.then(function(res) {
                  if (res) {
                    window.open(encodeURI($scope.domain + '/appUpdate/app/' + androidVersionFile), '_system');
                  }
                })
              } else {
                $ionicPopup.alert({
                  title: '提示',
                  template: '恭喜，已是最新版本！',
                  okText: '确定'
                });
              }
            }

          });



      });
    };

  }
])

//协议
.controller('pactCtrl', ['$scope', '$stateParams', 'Auth', 'defConfig', 'getHttp', '$timeout', '$location', '$ionicPopup', 'loadMore', '$cordovaAppVersion', 'getHttp',
  function($scope, $stateParams, Auth, defConfig, getHttp, $timeout, $location, $ionicPopup, loadMore, $cordovaAppVersion, getHttp) {

    $scope.pageName = "大智力协议";

    getHttp({
        path: '/templates/pactContent.html',
        method: "get"
      })
      .then(function(data) {
        $scope.pactContent = data;
      })

  }
])

//关于大智力
.controller('aboutUstCtrl', ['$scope', '$stateParams', 'Auth', 'defConfig', 'getHttp', '$timeout', '$location', '$ionicPopup', 'loadMore', '$cordovaAppVersion', 'getHttp',
  function($scope, $stateParams, Auth, defConfig, getHttp, $timeout, $location, $ionicPopup, loadMore, $cordovaAppVersion, getHttp) {

    $scope.pageName = "关于大智力";

    getHttp({
        path: '/templates/aboutUsContent.html',
        method: "get"
      })
      .then(function(data) {
        $scope.pactContent = data;
      })

  }
])

//注册
.controller('signCtrl', ['$scope', '$stateParams', 'Auth', 'defConfig', 'getHttp', '$ionicPopup',
  function($scope, $stateParams, Auth, defConfig, getHttp, $ionicPopup) {
    $scope.user = {};
    $scope.dosign = function() {
      if ($scope.isPhoneUsed) {
        return $ionicPopup.alert({
          title: '提示',
          template: '手机号已经存在，请重新填写！',
          okText: '确定'
        });
      }
      Auth.sign($scope.user, $scope);
    };

    $scope.checkUserName = function() {
      if (!$scope.user) {
        return;
      }

      getHttp({
        path: defConfig.path + '/checkUserName',
        method: "post",
        params: {
          userName: $scope.user.phone
        }
      }).then(function(data) {
        if (data.result) {
          $scope.isPhoneUsed = true;
          $scope.resultTips = {
            open: true,
            msg: '手机号已经存在，请重新填写！',
            isSuccessTips: false
          };
          //$scope.user.phone = null;
        } else {
          $scope.isPhoneUsed = false;
          $scope.resultTips = null;
        };
      });


    };

  }
])

.controller('ChatsCtrl', function($scope, Chats) {
  // With the new view caching in Ionic, Controllers are only called
  // when they are recreated or on app start, instead of every page change.
  // To listen for when this page is active (for example, to refresh data),
  // listen for the $ionicView.enter event:
  //
  //$scope.$on('$ionicView.enter', function(e) {
  //});

  $scope.chats = Chats.all();
  $scope.remove = function(chat) {
    Chats.remove(chat);
  };
  // Chats.getAjax();
})

.controller('ChatDetailCtrl', function($scope, $stateParams, Chats) {
    $scope.chat = Chats.get($stateParams.chatId);
  })
  .filter('reverse', function() {
    return function(input, uppercase) {
      input = input || '';
      var out = "";
      for (var i = 0; i < input.length; i++) {
        out = input.charAt(i) + out;
      }
      // conditional based on optional argument
      if (uppercase) {
        out = out.toUpperCase();
      }
      return out;
    };
  })
  .controller('AccountCtrl', function($scope) {
    $scope.settings = {
      enableFriends: true
    };
  });