angular.module('starter.filter', [])

.directive('foucsIn',[function () {
	return {
		 link: function(scope, element, attrs) {
			 element[0].focus();
		 }
	};
}])
.filter('toTrusted', ['$sce', function ($sce) {
	return function (text) {
	    return $sce.trustAsHtml(text);
	};
}])
.filter('reHref', ['$sce', 'defConfig', function ($sce, defConfig) {
	return function (text) {
		var res = text;
		if (!defConfig.html5Path) {
			return res.replace('<a href="/','<a href="#/');
		}
		return res;
	};
}])
.filter('qsState', [function () {
	return function  (input) {
		switch (input) {
			case 0: 
				return '未解决';
				break;
			case 10: return '草稿';
				break;
			case 11:return '已解决';
				break;
			case 12:return '过期';
				break;
			default:'未解决';
		};
	};
}])
.filter('drawalsState', [function () {
	return function  (input) {
		switch (input) {
			case 0: 
				return '待审核';
				break;
			case 11: return '审核不通过';
				break;
			case 12:return '审核通过';
				break;
			case 2:return '提现完成';
				break;
			default:'待审核';
		};
	};
}])
.filter('payBackState', [function () {
	return function  (input) {
		switch (input) {
		case 0: 
			return '申请退款';
			break;
		case 11: 
			return '不同意';
			break;
		case 12:
			return '同意，已退款';
			break;
		case 13:
			return '您处理超时，未退款';
			break;
		case 20:
			return '已申请仲裁';
			break;
		case 21:
			return '仲裁完成不退款';
			break;
		case 22:
			return '仲裁完成退款';
			break;
		case 23:
			return '申请过期不退款';
			break;
		default: return '';
		};
	};
}])
.filter('argueState', [function () {
	return function (input) {
//		if (input === 0) {
//			return "进行中";
//		} else if (input === 1) {
//			return "驳回";
//		} else if (input === 2) {
//			return "同意";
//		} else {
//			return "过期默认同意";
//		}
		
		switch (input) {
		case 0: 
			return '进行中';
			break;
		case 1: 
			return '驳回';
			break;
		case 2:
			return '同意';
			break;
		case 3:
			return '已申请仲裁';
			break;
		case 4:
			return '仲裁完成';
			break;
		case 41:
			return '仲裁完成，不同意';
			break;
		case 42:
			return '仲裁完成，已确认最终答案';
			break;
		default: return '';
		};
		
	};
}])
.filter('endTime',[function () {
	return function (date) {
		var currTime = new Date().getTime(),
		    endTime = new Date(date).getTime();
		var time = parseFloat((endTime-currTime)) / 1000;
		if (endTime - currTime < 0) {
			return '已过期，默认同意';
		}
	    if (null != time && "" != time) {
	        if (time > 60 && time < 60 * 60) {
	            time = parseInt(time / 60.0) + "分钟" + parseInt((parseFloat(time / 60.0) -
	                parseInt(time / 60.0)) * 60) + "秒";
	        }
	        else if (time >= 60 * 60 && time < 60 * 60 * 24) {
	            time = parseInt(time / 3600.0) + "小时" + parseInt((parseFloat(time / 3600.0) -
	                parseInt(time / 3600.0)) * 60) + "分钟";
	            
//	            +
//                parseInt((parseFloat((parseFloat(time / 3600.0) - parseInt(time / 3600.0)) * 60) -
//                parseInt((parseFloat(time / 3600.0) - parseInt(time / 3600.0)) * 60)) * 60) + "秒"
	        }else if (time > 60 * 60 * 24) {
	        	time = parseInt(time / 3600.0/24) + "天" 
	        		+ parseInt(
	        				(parseFloat(time / 3600.0/24) - parseInt(time / 3600.0/24)) * 24) + '小时';
	        	
	        	
	        	
	        };
	        return time;
	    }
	    
	};
}])
.filter('changeMoney', [ function () {
	return function (input) {
		var type = "-";
		if (input == 22) {
			type = "+";
		}else if (input == 21) {
			type = "-";
		} else if (input == 23){
			type = "+";
		}else if (input == 11) {
			type = "+";
		}


	    return type;
	};
}])
.filter('noHtmlTag', [function () {
	return function (input) {
		if(!input){
			return;
		}
		return input.replace(/<[^>]+>/g,"").replace(/&nbsp;/ig, "");
	}
}])
.filter('imgPath', ['$filter', 'defConfig', function ($filter, defConfig) {
	return function (input,param) {
		if (!input) return;
//		var args = Array.prototype.slice.call(arguments);
		var src=input,
			w = param,
			l = src.lastIndexOf('.'),
			p = src.substring(0,l),
			t = src.substring(l),
			s = p +'_'+w +t;
	    return defConfig.url+s;
	};
}]);
