angular.module('starter.services', [])

.factory('$$localstorage', ['$window', function($window) {
  return {
    set: function(key, value) {
      $window.localStorage[key] = value;
    },
    get: function(key, defaultValue) {
      return $window.localStorage[key] || defaultValue;
    },
    setObject: function(key, value) {
      $window.localStorage[key] = JSON.stringify(value);
    },
    getObject: function(key) {
      return JSON.parse($window.localStorage[key] || '{}');
    },
    remove: function (key) {
      $window.localStorage.removeItem(key);
    }
  };
}])


  .factory('errorInfo', ['$location', '$rootScope', '$ionicPopup', '$$localstorage', function($location, $rootScope, $ionicPopup, $$localstorage) {
    return {
      errMsg: function(data) {
       ionic.Platform.ready(function() {
        if (data.error) {
          if (data.error[0].type == 1) {
            $rootScope.currentUser = '';
            $rootScope.isLogin = false;
            $rootScope.authState = false;
            return $rootScope.inLogin();
          }else if (data.error[0].type == 404) {
            return  $ionicPopup.alert({
          title: '提示',
          template: data.error[0].error,
          okText: '确定'
        }).then(function () {
          $location.path('/');
        });
          }else {
            switch (data.error[0].type) {
		        case '101':
		          $$localstorage.remove('token');
		          break;
		        default:
		          return  $ionicPopup.alert({
		            title: '提示',
		            template: data.error[0].error,
		            okText: '确定'
		          });
		          break;
		      }
          }
        }
      })
      }
    };
  }])
  .service('showCode', ['$http', 'getHttp', '$q', 'defConfig', function($http, getHttp, $q, defConfig) {

    return function(path, $scope) {
      var deferred = $q.defer();
      vCode = {
        'isShowCodeByLogin': 'verifyCoded',
        'isShowCodeByReg': 'verifyCodez',
        'isShowCodeBySms': 'verifyCodes'
      };
      var verifyCodeimg = defConfig.url + defConfig.path + '/' + vCode[path] + '?key=' + (Math.round(Math.random() * 100000 + 1));
      $http.get(defConfig.url + defConfig.path + '/' + path)
        .success(function(d) {
          if (d.result) {
            $scope.verifyCodeimg = verifyCodeimg;
            $scope.isShowCode = true;
            deferred.resolve(d);
          } else {
            deferred.reject(d);
          };
        });
      return deferred.promise;
    };
  }])
  .directive('verifyImg', [function() {
    return {
      replace: true,
      template: '<img ng-click="changeVerCodeUrl()" class="" ng-src="{{verifyCodeimg}}">',
      link: function($scope, iElement, iAttrs) {
        $scope.changeVerCodeUrl = function() {
          var src = iElement.attr('src'),
            last = src.lastIndexOf('='),
            key = src.substring(last + 1),
            url = src.replace(key, '') + (Math.round(Math.random() * 100000 + 1));
          iElement.attr('src', url);
        };
      }
    };
  }])
  .factory('getHttp', ['$http', '$q', '$rootScope', 'errorInfo', 'defConfig', '$ionicLoading', function($http, $q, $rootScope, errorInfo, defConfig, $ionicLoading) {
    return function(parm) {

      //promise
      var deferred = $q.defer();
      
      
      if (parm.loading) {
        $ionicLoading.show({
              template: '<ion-spinner icon="ripple" class="spinner spinner-ripple"></ion-spinner>',
              hideOnStateChange: true
          }); 
      }
      
      
      
      var httpData = {
          method: parm.method,
          url: defConfig.url + parm.path,
          data: parm.params
            //      params: parm.params
      }
      
      if (parm.method === "jsonp") {
        parm.params.callback = "JSON_CALLBACK";
        httpData.params = parm.params;
      }
      
      $http(httpData)
        .then(function(res) {
          if (res.data.result) {

            $rootScope.loading = false;
            deferred.resolve(res.data);
          } else if (res.data.error) {

            $rootScope.loading = false;
            errorInfo.errMsg(res.data);
            deferred.reject(res.data);
          } else {
            deferred.resolve(res.data);
          }
          $ionicLoading.hide();
        }, function(err) {
          $rootScope.loading = false;
          deferred.reject(err);
          $ionicLoading.hide();
        });

      return deferred.promise;
      
      
    };
  }])
  .service('formDataHttp', ['$http', '$q', 'defConfig', 'errorInfo', '$rootScope', '$ionicLoading', function($http, $q, defConfig, errorInfo, $rootScope, $ionicLoading) {

    return function(parm, sate) {
      //    if(sate && sate.loadCtrl == true) {
      //      //$rootScope.loading = false;
      //    }else {
      //      $rootScope.loading = true;
      //    }
      
      
      if (parm.loading) {
          $ionicLoading.show({
                template: '<ion-spinner icon="ripple" class="spinner spinner-ripple"></ion-spinner>',
                hideOnStateChange: true
            }); 
        }

      var deferred = $q.defer();
      $http({
          method: parm.method,
          url: defConfig.url + parm.path,
          headers: {
            'Content-Type': undefined
          },
          data: parm.formData,
          transformRequest: function(data) {
            return data;
          }
        })
        .then(function(res) {
          if (res.data.result) {

            deferred.resolve(res.data);
            $ionicLoading.hide();
          } else {
            errorInfo.errMsg(res.data);
            deferred.reject(res.data);
            $ionicLoading.hide();
          }
        }, function(err) {
          deferred.reject(err);
          $ionicLoading.hide();
        });
      return deferred.promise;
    };
  }])
  .directive('upLoadFile', ['$sce', '$parse', '$cordovaImagePicker', '$cordovaCamera', '$ionicActionSheet', '$rootScope', function($sce, $parse, $cordovaImagePicker, $cordovaCamera, $ionicActionSheet, $rootScope) {
    return {
//      replace: true,
      template: '<span class="" ng-if="!deviceready" ng-repeat="item in upLoadFile.files" ng-click="upLoadFile.fileRemove(item)">\
                    <img alt="" ng-src="{{item.src}}" height="32">\
              <i class="icon ion-android-close"></i>\
                </span>\
          <span class="" ng-if="deviceready" ng-repeat="item in images_list" ng-click="images_listRemove(item)">\
              <img alt="" ng-src="{{item}}" height="32">\
          <i class="icon ion-android-close"></i>\
            </span>\
            <i class="icon ion-camera balanced" ng-if="deviceready" ng-click="addAttachment()"></i>\
                <div class="file-input-style" ng-if="!deviceready">\
                <input type="file" ng-if="isMultiple" multiple="multiple" accept="image/*" />\
                <input type="file" ng-if="!isMultiple" accept="image/*" />\
                <i class="icon ion-camera balanced"></i>\
                </div>',
      link: function($scope, ele, attr, controller) {
 // ngModel.$setViewValue("");require: 'ngModel',
 //            ngModel.$render();
        if (attr.multiple) {
          $scope.isMultiple = true;
        } else {
          $scope.isMultiple = false;
        }

        //上传附件
        $scope.deviceready = false;
        document.addEventListener("deviceready", function() {
          //$scope.deviceready = true;
        }, false);
        $scope.images_list = [];

        $scope.images_listRemove = function (item) {
          var index = $scope.images_list.indexOf(item);
            if (index > -1) {
              $scope.images_list.splice(index, 1);
            }
        };
        $scope.addAttachment = function() {
          var ionicActionSheetButtons = [];
          ionicActionSheetButtons.push({
            text: '相机'
          });
          ionicActionSheetButtons.push({
            text: '图库'
          });
          $ionicActionSheet.show({
            buttons: ionicActionSheetButtons,
            cancelText: '关闭',
            cancel: function() {
              return true;
            },
            buttonClicked: function(index) {

              switch (index) {

                case 0:
                  appendByCamera();
                  break;
                case 1:

                  pickImage();
                  break;
                default:
                  break;
              }
              return true;
            }
          });
        };

        function appendByCamera() {
          document.addEventListener("deviceready", function() {

            var options = {
              quality: 100,
              destinationType: Camera.DestinationType.DATA_URL,
              sourceType: Camera.PictureSourceType.CAMERA,
              allowEdit: true,
              encodingType: Camera.EncodingType.JPEG,
              targetWidth: 100,
              targetHeight: 100,
              popoverOptions: CameraPopoverOptions,
              saveToPhotoAlbum: false
            };

            $cordovaCamera.getPicture(options).then(function(imageData) {
//              var image = document.getElementById('myImage');
//              image.src = "data:image/jpeg;base64," + imageData;
              
              $scope.images_list.push(imageData);
            }, function(err) {
              // error
            });

          }, false);
        }

        //image picker  
        var pickImage = function() {
          document.addEventListener("deviceready", function() {
            var options = {
              maximumImagesCount: 5,
              //                  width: 800,  
              //                  height: 800,  
              quality: 100
            };

            $cordovaImagePicker.getPictures(options)
              .then(function(results) {
                $scope.images_list = $scope.images_list.concat(results);
              }, function(error) {
                // error getting photos  
              });
          }, false);
        };



        $scope.upLoadFile = {
          files: [],
          fileRemove: function(item) {
            var index = $scope.upLoadFile.files.indexOf(item);
            if (index > -1) {
              $scope.upLoadFile.files.splice(index, 1);
            }
          }
        };
        angular.element(ele).on('change', function(e) {
          var files = e.target.files;

          angular.forEach(files, function(file) {
            file.src = window.URL.createObjectURL(file);
            if (attr.multiple) {

              if (!$scope.upLoadFile.files.length) {
                $scope.upLoadFile.files.push(file);
              } else {
                var hasFile = false;
                angular.forEach($scope.upLoadFile.files, function(old) {
                  if (old.name === file.name && old.lastModified === file.lastModified && old.size === file.size) {
                    return hasFile = true;
                  }

                });
                if (!hasFile) {
                  $scope.upLoadFile.files.push(file);
                }
              }


            } else {
              $scope.upLoadFile.files[0] = file;
            }
          });
          $scope.$apply(function() {
            $scope.upLoadFile = $scope.upLoadFile;
            $rootScope.upLoadImages = $scope.upLoadFile;
            if (attr.upFileSubmit) {
              $parse(attr.upFileSubmit)($scope);
            };
          });


        });
      }
    };
  }])
.directive('fileLoadInput', ['$sce', '$parse', '$cordovaImagePicker', '$cordovaCamera', '$ionicActionSheet', '$rootScope', 
  function($sce, $parse, $cordovaImagePicker, $cordovaCamera, $ionicActionSheet, $rootScope) {
    return {
//      replace: true,
      require: 'ngModel',
      scope: {},
      template: '<span class="" ng-if="!deviceready" ng-repeat="item in upLoadFile.files" ng-click="upLoadFile.fileRemove(item)">\
                    <img alt="" ng-src="{{item.src}}" height="32">\
              <i class="icon ion-android-close"></i>\
                </span>\
          <span class="" ng-if="deviceready" ng-repeat="item in images_list" ng-click="images_listRemove(item)">\
              <img alt="" ng-src="{{item}}" height="32">\
          <i class="icon ion-android-close"></i>\
            </span>\
            <i class="icon ion-camera balanced" ng-if="deviceready" ng-click="addAttachment()"></i>\
                <div class="file-input-style" ng-if="!deviceready">\
                <input type="file" multiple="multiple" accept="image/*" />\
                <input type="file" ng-if="!isMultiple" accept="image/*" />\
                <i class="icon ion-camera balanced"></i>\
                </div>',
      link: function($scope, ele, attr, ngModel) {
    

        if (attr.multiple) {
          $scope.isMultiple = true;
        } else {
          $scope.isMultiple = false;
        }


        //上传附件
        $scope.deviceready = false;
        document.addEventListener("deviceready", function() {
          //$scope.deviceready = true;
        }, false);
        $scope.images_list = [];

        $scope.images_listRemove = function (item) {
          var index = $scope.images_list.indexOf(item);
            if (index > -1) {
              $scope.images_list.splice(index, 1);
            }
        };
        $scope.addAttachment = function() {
          var ionicActionSheetButtons = [];
          ionicActionSheetButtons.push({
            text: '相机'
          });
          ionicActionSheetButtons.push({
            text: '图库'
          });
          $ionicActionSheet.show({
            buttons: ionicActionSheetButtons,
            cancelText: '关闭',
            cancel: function() {
              return true;
            },
            buttonClicked: function(index) {

              switch (index) {

                case 0:
                  appendByCamera();
                  break;
                case 1:

                  pickImage();
                  break;
                default:
                  break;
              }
              return true;
            }
          });
        };

        function appendByCamera() {
          document.addEventListener("deviceready", function() {

            var options = {
              quality: 100,
              destinationType: Camera.DestinationType.DATA_URL,
              sourceType: Camera.PictureSourceType.CAMERA,
              allowEdit: true,
              encodingType: Camera.EncodingType.JPEG,
              targetWidth: 100,
              targetHeight: 100,
              popoverOptions: CameraPopoverOptions,
              saveToPhotoAlbum: false
            };

            $cordovaCamera.getPicture(options).then(function(imageData) {
//              var image = document.getElementById('myImage');
//              image.src = "data:image/jpeg;base64," + imageData;
              
              $scope.images_list.push(imageData);
            }, function(err) {
              // error
            });

          }, false);
        }

        //image picker  
        var pickImage = function() {
          document.addEventListener("deviceready", function() {
            var options = {
              maximumImagesCount: 5,
              //                  width: 800,  
              //                  height: 800,  
              quality: 100
            };

            $cordovaImagePicker.getPictures(options)
              .then(function(results) {
                $scope.images_list = $scope.images_list.concat(results);
              }, function(error) {
                // error getting photos  
              });
          }, false);
        };



        $scope.upLoadFile = {
          files: [],
          fileRemove: function(item) {
            var index = $scope.upLoadFile.files.indexOf(item);
            if (index > -1) {
              $scope.upLoadFile.files.splice(index, 1);
            }
          }
        };
        angular.element(ele).on('change', function(e) {
          var files = e.target.files;

          angular.forEach(files, function(file) {
            file.src = window.URL.createObjectURL(file);
            if (attr.multiple) {

              if (!$scope.upLoadFile.files.length) {
                $scope.upLoadFile.files.push(file);
              } else {
                var hasFile = false;
                angular.forEach($scope.upLoadFile.files, function(old) {
                  if (old.name === file.name && old.lastModified === file.lastModified && old.size === file.size) {
                    return hasFile = true;
                  }

                });
                if (!hasFile) {
                  $scope.upLoadFile.files.push(file);
                }
              }


            } else {
              $scope.upLoadFile.files[0] = file;
            }
          });
          $scope.$apply(function() {
            // $scope.upLoadFile = $scope.upLoadFile;
            // $rootScope.upLoadImages = $scope.upLoadFile;
            
            ngModel.$setViewValue($scope.upLoadFile);
            ngModel.$render();
            // if (attr.upFileSubmit) {
            //   $parse(attr.upFileSubmit)($scope);
            // };
            
          });


        });
      }
    };
  }])
  //.directive('upLoadFile',[function () {
  //  return function ($scope, ele, attr) {
  //    
  //    $scope.upLoadFile = {
  //        files: [],
  //        fileRemove: function (item) {
  //          var index = $scope.upLoadFile.files.indexOf(item);
  //            if (index > -1) {
  //              $scope.upLoadFile.files.splice(index, 1);
  //            }
  //        }
  //    };
  //    angular.element(ele).on('change',function (e) {
  //      var files = e.target.files;
  //        
  //        angular.forEach(files,function (file) {
  //          file.src = window.URL.createObjectURL(file);
  //          if (attr.multiple) {
  //            
  //            if (!$scope.upLoadFile.files.length) {
  //              $scope.upLoadFile.files.push(file);
  //            }else {
  //              var hasFile = false;
  //              angular.forEach($scope.upLoadFile.files, function (old) {
  //                if (old.name === file.name && old.lastModified === file.lastModified && old.size === file.size) {
  //                  return hasFile = true;
  //                }
  //                
  //              });
  //              if (!hasFile) {
  //                $scope.upLoadFile.files.push(file);
  //              }
  //            }
  //            
  //            
  //          }else {
  //            $scope.upLoadFile.files[0] = file;
  //          }
  //        });
  //        $scope.$apply(function () {
  //          $scope.upLoadFile;
  //        });
  //        
  //      
  //    });
  //  };
  //}])
  .factory('resultTips', [function() {
    return function(d, scope) {
      scope.resultTips = {
        open: d.open,
        msg: d.msg,
        isSuccessTips: false
      };
      if (d.success) {
        scope.resultTips.isSuccessTips = true;
      }
    };
  }])
  .factory('appShare', ['$ionicModal', '$ionicActionCustomSheet', 'defConfig', '$location', '$rootScope', '$ionicPopup', 
    function($ionicModal, $ionicActionCustomSheet, defConfig, $location, $rootScope, $ionicPopup) {
    return function($scope, shareMsg, options) {
      //微信内分享直接提示右上角更多
      $scope.inwxBrowMore = function () {
        $ionicModal.fromTemplateUrl('templates/wxShareModal.html', {
              scope: $scope
            }).then(function(modal) {
              $scope.wxShareModal = modal;
              $scope.wxShareModal.show();
            });

            $scope.closeWxShareModal = function() {
              $scope.wxShareModal.hide();
            };

            $scope.openWxShareModal = function($event) {
              $scope.wxShareModal.show();
            };
      }
      

      //分享及更多
      $scope.showMoreActionSheet = function() {

        var showDeleteQsBtn = 'hide';

        // if ($scope.questionItems.answerCount === 0 && $scope.questionItems.state != 10 && $scope.questionItems.curUserType == 2) {
        //   showDeleteQsBtn = 'show';
        // }

        var rebateProgram = false;
//         if ($scope.promotionConfig && $scope.promotionConfig.isShare){
//           rebateProgram = $scope.promotionConfig.shareDesc.title+$scope.promotionConfig.shareDesc.common;
// //            if ($scope.questionItems.curUserType == 2) {
// //              rebateProgram += $scope.promotionConfig.shareDesc.q;
// //            }else if ($scope.questionItems.curUserType == 3) {
// //              rebateProgram += $scope.promotionConfig.shareDesc.a;
// //            }else {
// //              rebateProgram += $scope.promotionConfig.shareDesc.common;
// //            }
//         }
        
       

        var showButtons = {
          buttons: [{
            text: '微信好友',
            class: 'iconfont icon-weixin  balanced'
          }, {
            text: '朋友圈',
            class: 'iconfont icon-pengyouquan  balanced'
          }, {
            text: 'QQ好友',
            class: 'iconfont icon-qq calm'
          }, {
            text: '微博好友',
            class: 'iconfont icon-weibo assertive'
          }],
          
          //destructiveText: 'Delete',
          //destructiveButtonClicked: function
          titleText: '分享',
          customDescSheet: rebateProgram,
          customStyle:{'margin-bottom':'-8px'},
          cancelText: '取消',
          cancel: function() {
            // add cancel code..
          },
          buttonClicked: function(index) {

            switch (index) {
              case 0:
                //                $scope.shareViaWechat(WeChat.Scene.timeline);
                $scope.shareViaWechat(0);
                break;
              case 1:
                $scope.shareViaWechat(1);
                break;
              case 2:
                //                $scope.shareViaWechat(WeChat.Scene.session, title, desc, url, thumb);
                $scope.shareWebQQ();
                break;
              case 3:
                $scope.shareWeibo();
                break;
              case 4:
                $scope.atFriend();
                break;
              default:
                // $scope.shareViaWechat(WeChat.Scene.session, title, desc, url, thumb);
                break;
            }
            return true;
          },
          buttonGroupClicked: function(index) {

            switch (index) {
              //              case 0:
              //                $scope.deleQs();
              //                break;
              case 0:
                $scope.hideSheet();
                // $scope.showReportSheet($scope.questionItems.id, 1);
                break;
              default:
                '';
                break;
            }
            return true;
          }
        };

        var at = {
            text: '指定好友',
            class: 'iconfont ion-at energized'
          };

        if (options && options.at) {
          showButtons.buttons.push(at);
        }
        if (options && options.buttonsGroup) {
          showButtons.buttonsGroup = [{
            text: '举报',
            class: 'iconfont icon-laheijubao assertive'
          }];
        }

        var hideSheet = $ionicActionCustomSheet.show(showButtons);



        $scope.hideSheet = function() {
          hideSheet();
        };
        //     // For example's sake, hide the sheet after two seconds
        //     $timeout(function() {
        //       hideSheet();
        //     }, 2000);

        
        var shareCommonUrl = shareMsg.url || defConfig.url + '' + $location.path() +( $rootScope.currentUser ? '?share='+ $rootScope.currentUser.showId : '');
        var shareTitle = shareMsg.title;
        var shareDescription = shareMsg.description;
        
        // if ($scope.promotionConfig && $scope.promotionConfig.isShare) {
        //   shareTitle = "#" + $scope.promotionConfig.shareDesc.common + "# " + "悬赏" + $scope.questionItems.bonus + "元：" + $scope.questionItems.title +  shareCommonUrl;
        //   shareDescription = shareTitle;
        // }
        //微博web分享
        $scope.shareWeibo = function() {
          
          var url = "http://v.t.sina.com.cn/share/share.php?title=" + encodeURIComponent(shareTitle) + "&url=" + shareCommonUrl;

          if (ionic.Platform.platforms[0] === 'browser') {
            window.location.href = url;
          } else {
            window.open(url, '_blank', 'location=yes');
          }
        };

        //QQweb分享
        $scope.shareWebQQ = function() {
//          var shareTitle = $scope.questionItems.state === 11 ? "难题:" + $scope.questionItems.title + "解决了，大智力V5，感谢党，感谢人民，感谢……" : "悬赏" + $scope.questionItems.bonus + "人民币，请人帮解决难题：" + $scope.questionItems.title + "非常着急，快来帮忙解决啊！，地址：" + shareCommonUrl;
          var url = "http://connect.qq.com/widget/shareqq/index.html?title=" + encodeURIComponent(shareTitle) + "?url=" + shareCommonUrl + "&desc=&summary=&site=大智力";

          if (ionic.Platform.platforms[0] === 'browser') {
            window.location.href = url;
          } else {
            window.open(url, '_blank', 'location=yes');
          }
        };



        //微信分享
        $scope.shareViaWechat = function(scene, title, desc, url, thumb) {
          // Wechat.isInstalled(function (installed) {
          //     alert("Wechat installed: " + (installed ? "Yes" : "No"));
          // }, function (reason) {
          //     alert("Failed: " + reason);
          // });
//          var shareTitle = $scope.questionItems.state === 11 ? "难题:" + $scope.questionItems.title + "解决了，大智力V5，感谢党，感谢人民，感谢……" : "悬赏" + $scope.questionItems.bonus + "人民币，请人帮解决难题：" + $scope.questionItems.title + "非常着急，快来帮忙解决啊！";

          var shareUrl = shareCommonUrl,
            shareImgUrl = shareMsg.img || 'www/img/wx-share-def.jpg';


          // if ($scope.questionItems.affixs && $scope.questionItems.affixs.length) {
          //   shareImgUrl = defConfig.url + $scope.questionItems.affixs[0].filePath.replace($scope.questionItems.affixs[0].suffix, "_256" + $scope.questionItems.affixs[0].suffix);
          // }
          // 
          

          if (typeof Wechat === "undefined") {
            if ($rootScope.isWeixin) {
              
              $scope.inwxBrowMore();
              return;
            } else {
              return $ionicPopup.confirm({
                title: '提示',
                template: '微信暂不支持非APP分享，建议使用大智力客户端',
                okText: '下载APP',
                cancelText: '取消',
              }).then(function(res) {
                if (res) {
                  $location.path('/question/downloadApp');
                }
              }, function() {


              });
            }
          };



          var message = {
            title: shareTitle,
            description: shareDescription,
            thumb: shareImgUrl,
            //                  mediaTagName: "TEST-TAG-001",
            //                  messageExt: "这是第三方带的测试字段",
            //                  messageAction: "<action>dotalist</action>",
            media: {
              type: Wechat.Type.LINK,
              webpageUrl: shareUrl
            }
          };
          if (scene == 0) {
            Wechat.share({
              message: message,
              scene: Wechat.Scene.SESSION // share to Timeline
            }, function() {
              // alert("Success");
            }, function(reason) {
              // alert("Failed: " + reason);
            });
          } else {
            Wechat.share({
              message: message,
              scene: Wechat.Scene.TIMELINE //Wechat.Scene.TIMELINE   // share to Timeline
            }, function() {
              // alert("Success");
            }, function(reason) {
              // alert("Failed: " + reason);
            });
          }



        };

      };
      $scope.showMoreActionSheet ();
    };
  }])
  .factory('wxConfig', ['$rootScope', 'getHttp', 'defConfig', function($rootScope, getHttp, defConfig) {
    return function(wxShare) {
      var ua = navigator.userAgent.toLowerCase();
    if(ua.match(/MicroMessenger/i)=="micromessenger") {
        
        wx.ready(function(){
          
          wx.onMenuShareTimeline({
              title: wxShare.title, // 分享标题
              link: wxShare.link, // 分享链接
              imgUrl: wxShare.imgUrl, // 分享图标
              success: function (res) { 
                  // 用户确认分享后执行的回调函数
            	  wxShare.success(res);
              },
              cancel: function () { 
                  // 用户取消分享后执行的回调函数
              }
          });
          
          wx.onMenuShareAppMessage({
              title: wxShare.title, // 分享标题
              desc: wxShare.desc, // 分享描述
              link: wxShare.link, // 分享链接
              imgUrl: wxShare.imgUrl, // 分享图标
              type: 'link', // 分享类型,music、video或link，不填默认为link
              dataUrl: '', // 如果type是music或video，则要提供数据链接，默认为空
              success: function (res) { 
                  // 用户确认分享后执行的回调函数
            	  wxShare.success(res)
              },
              cancel: function () { 
                  // 用户取消分享后执行的回调函数
              }
          });
          
          wx.onMenuShareQQ({
              title: wxShare.title, // 分享标题
              desc: wxShare.desc, // 分享描述
              link: wxShare.link, // 分享链接
              imgUrl: wxShare.imgUrl, // 分享图标
              success: function (res) { 
                 // 用户确认分享后执行的回调函数
            	  wxShare.success(res)
              },
              cancel: function () { 
                 // 用户取消分享后执行的回调函数
              }
          });
          
          wx.onMenuShareWeibo({
              title: wxShare.title, // 分享标题
              desc: wxShare.desc, // 分享描述
              link: wxShare.link, // 分享链接
              imgUrl: wxShare.imgUrl, // 分享图标
              success: function (res) { 
                 // 用户确认分享后执行的回调函数
            	  wxShare.success(res)
              },
              cancel: function () { 
                  // 用户取消分享后执行的回调函数
              }
          });
          
          wx.onMenuShareQZone({
              title: wxShare.title, // 分享标题
              desc: wxShare.desc, // 分享描述
              link: wxShare.link, // 分享链接
              imgUrl: wxShare.imgUrl, // 分享图标
              success: function () { 
                 // 用户确认分享后执行的回调函数
            	  wxShare.success(res)
              },
              cancel: function () { 
                  // 用户取消分享后执行的回调函数
              }
          });
          
        
        });
    }
    
    };
  }])
  .factory('wxConfigInit', ['$rootScope', 'getHttp', 'defConfig', function($rootScope, getHttp, defConfig) {
    return function(url) {
      var ua = navigator.userAgent.toLowerCase();
	    if(ua.match(/MicroMessenger/i) =="micromessenger") {
	    	
	      getHttp({
	        method: 'post',
	        path: defConfig.path + '/getSdkConfig',
	        params: {
	        	link: url
	        }
	      })
	      .then(function (data){
	        $rootScope.isWeixin = true;
	        var wxSign = data.result;
	        wx.config({
	          // debug: true, // 开启调试模式,调用的所有api的返回值会在客户端alert出来，若要查看传入的参数，可以在pc端打开，参数信息会通过log打出，仅在pc端时才会打印。
	            appId: 'wx92e9547335926a10', // 必填，公众号的唯一标识
	            timestamp: wxSign.timestamp, // 必填，生成签名的时间戳
	            nonceStr: wxSign.noncestr, // 必填，生成签名的随机串
	            signature: wxSign.signature,// 必填，签名，见附录1
	            jsApiList: [
	            'checkJsApi',
	            'onMenuShareTimeline',    
	            'onMenuShareAppMessage',    
	            'onMenuShareQQ',    
	            'onMenuShareWeibo',
	            'onMenuShareQZone',
	            'chooseImage',
	            'startRecord',
	            'stopRecord',
	            'onVoiceRecordEnd',
	            'playVoice',
	            'pauseVoice',
	            'stopVoice',
	            'onVoicePlayEnd',
	            'uploadVoice',
	            'downloadVoice'
	           ] // 必填，需要使用的JS接口列表，所有JS接口列表见附录2
	        });
	        
	      })
	    }
    
    };
  }])

  .factory('verification', ['$q', '$sce', '$parse', '$ionicPopup', function($q, $sce, $parse, $ionicPopup) {
    return {
      isEmpty: function(data) {
        for (value in data) {
          if (!value) {
             return $ionicPopup.alert({
        title: '错误!',
        template: "不能为空",
        okText: '确定'
      });
          }
        }
      },
      validation: function(eles, $scope) {
        var deferred = $q.defer();
        var breakEach = true;

        function promiseErr(input, msg) {
          $scope.errorTipsLayerHtml = $sce.trustAsHtml(msg);
          $scope.errorTips = true;
          breakEach = false;
          input.addClass('cus-invalid-error');
          return deferred.reject('error');
        }

        angular.forEach(eles, function(ele, i, arr) {
          
          if (breakEach) {
            var input = angular.element(ele);
            if (input.attr('type') === 'checkbox' || input.attr('type') === 'radio' || input.hasClass("ng-hide")) {
              return;
            };
            input.removeClass('cus-invalid-error');
            if (input.attr("required") || input.attr("irequired")) {
              var errHtml = input.attr("placeholder"),
                cusError = input.attr("cus-error") | null,
                cusPattern = input.attr("cus-pattern") ? input.attr("cus-pattern").split('|') : null;
              if (cusPattern) {
                errHtml = cusPattern[0];
              }
              if (input.val() == "") {
                return promiseErr(input, '<strong>警告!</strong> ' + errHtml + '不能为空或不符合规则！');
              }
              //                $parse(input.attr['ngModel'])($scope);
              if (!$parse(input.attr('ng-model'))($scope)) {

                return promiseErr(input, '<strong>警告!</strong> ' + errHtml + '不符合规则！');
              }
              if (input.attr('type') === 'tel') {
                var reg = new RegExp("^[0-9]*$");
                if (!reg.test(input.val())) {
                  return promiseErr(input, '<strong>警告!</strong> ' + input.attr("placeholder") + '不符合规则');
                }
              }
              if (cusPattern && cusPattern[1] == 'false') {
                cusError = input.attr("cus-error");
                return promiseErr(input, '<strong>警告!</strong> ' + cusError);
              }

              if (i == arr.length - 1) {
                $scope.errorTips = false;
                input.removeClass('cus-invalid-error');
                return deferred.resolve('success');

              }
            }

          }
        });

        return deferred.promise;
      }
    };
  }])
  .directive('dngValidator', ['$sce', '$parse', function($sce, $parse) {
    return {
      // name: '',
      // priority: 1,
      // terminal: true,
      // scope: {}, // {} = isolate, true = child, false/undefined = no change
      //         controller: function($scope, $element, $attrs, $transclude) {
      //           
      //         },
      // require: 'ngModel', // Array = multiple requires, ? = optional, ^ = check parent elements
      // restrict: 'A', // E = Element, A = Attribute, C = Class, M = Comment
      // template: '',
      // templateUrl: '',
      // replace: true,
      // transclude: true,
      // compile: function(tElement, tAttrs, function transclude(function(scope, cloneLinkingFn){ return function linking(scope, elm, attrs){}})),
      link: function($scope, iElm, iAttrs, controller) {
        $scope.eles = [];
        var eles = angular.element(iElm).find("input");

        function promiseErr(input, msg) {
          $scope.errorTipsLayerHtml = $sce.trustAsHtml(msg);
          $scope.errorTips = true;
          breakEach = false;
          input.addClass('cus-invalid-error');
        }
        angular.forEach(eles, function(ele, i, arr) {
          var input = angular.element(ele);
          if (input['type'] == 'checkbox' || input['type'] == 'radio') {
            return;
          };
          
          if (input.attr("required") || input.attr("irequired")) {
            $scope.eles.push(input);
            var errHtml = input.attr("placeholder"),
              cusError = input.attr("cus-error") | null,
              cusPattern = input.attr("cus-pattern") ? input.attr("cus-pattern").split('|') : null;
            if (cusPattern) {
              errHtml = cusPattern[0];
            }


          }
          input.on('focus', function() {
            input.removeClass('cus-invalid-error');
            $scope.errorTips = false;
          });
          input.on('blur', function() {
            var self = angular.element(this);
            if (self.attr("required") || self.attr("irequired")) {

              if (self.val() == "") {
                //self.addClass('ng-invalid');
                input.addClass('cus-invalid-error');
                $scope.errorTipsLayerHtml = $sce.trustAsHtml('<strong>警告!</strong> ' + self.attr("placeholder") + '不能为空');
                $scope.errorTips = true;
              } else {
                input.removeClass('cus-invalid-error');
                $scope.errorTips = false;
              }
            }
          });
        });
      }
    };
  }])
  .directive('validatorSubmit', ['$timeout', 'verification', '$parse', '$rootScope',
    function($timeout, verification, $parse, $rootScope) {
      return {
        priority: 1, // execute before ng-click (0)
        require: '?ngClick',
        link: function postLink($scope, element, attrs, controllers) {
          $timeout(function() {
            element.off('click');
            element.on('click', function(e) {
              verification.validation($scope.eles, $scope)
                .then(function(data) {
                  $parse(attrs.ngClick)($scope);
                  if (attrs['uiTurnOff']) {
                    $parse($scope.Ui.setOne(attrs['uiTurnOff'], false))($scope);
                  }

                });
            });

          });
        }
      };
    }
  ])
  .directive('reClick', [function () {
    return {
      link: function postLink($scope, element, attrs, controllers) {
        
        element.on('click', function (e) {
          if (e.target.nodeName == 'A') {
            alert(angular.element(e.target).attr("href"))
            return false;
          }
        })
      }
    }
  }])
  .factory('Auth', ['getHttp', 'resultTips', '$q', '$rootScope', 'defConfig', '$ionicHistory', 'showCode', '$state', '$window', '$location', '$timeout', '$ionicPopup', '$$localstorage', '$stateParams',
                    function(getHttp, resultTips, $q, $rootScope, defConfig, $ionicHistory, showCode, $state, $window, $location, $timeout, $ionicPopup, $$localstorage, $stateParams) {
    return {
      login: function(user, $scope, cb) {
      
        
        if (!$scope.loginData.userName) {
          return resultTips({
            open: true,
            msg: '请填写登录手机号！'
          }, $scope);
        }
        if (!$scope.loginData.password) {
          return resultTips({
            open: true,
            msg: '请填写密码！'
          }, $scope);
        }
        if ($scope.isShowCode && !$scope.loginData.vCode) {
          return resultTips({
            open: true,
            msg: '请填写验证码！'
          }, $scope);
        }
//        if (window.cordova) { 
//          window.plugins.jPushPlugin.getRegistrationID(function(data) {
//                $scope.registrationID = data;
//                $scope.loginData.registrationID = $scope.registrationID;
//          });  
//        }
        
        getHttp({
            method: 'post',
            path: defConfig.path + '/login',
            params: $scope.loginData
          })
          .then(function(data) {
            
            $rootScope.currentUser = data.result;
            $scope.closeLogin();
            $$localstorage.set('token', data.result.token);
            if ( data && data.result && data.result.returnUrl ){
              window.location.href = data.result.returnUrl;
              return;
            }
            if (typeof cb === 'function') {
                cb();
            }else {
            	if ($state.current.name === "question.sign") {
            		$ionicHistory.goBack();
            		$timeout(function () {
            			$window.location.reload(true);
            		})
            	}else {
            		$window.location.reload(true);
            	}
              
            }
            
//            $ionicHistory.clearCache().then(function(){
//              
//                
//            });
            
            
          }, function(err) {
            showCode('isShowCodeByLogin', $scope);
          });
      },
      isMe: function () {
        
      },
      //$$localstorage.token
      isLoggedIn: function(cb) {
        var deferred = $q.defer(),
          _this = this;
        
        if (!$rootScope.currentUser) {
          if ($$localstorage.get('token')) {
             getHttp({
                  method: 'post',
                  path: defConfig.path + '/loginTk',
                  params: {
                    token: $$localstorage.get('token')
                  }
                })
                .then(function(data) {
                  if (data.result) {
                    $rootScope.currentUser = data.result;
                    deferred.resolve(data);
                  } else {
                    deferred.reject(data);
                  };
                });
          }else {
            getHttp({
                method: 'get',
                path: defConfig.path + '/isLogin'
              })
              .then(function(data) {
                if (data.result.isLogin) {
                  deferred.resolve(data);
                  _this.loginStyle(data);
                } else {
                  _this.loginStyle(data);
                  deferred.reject(data);
                };
              });
          }
        } else {
          deferred.resolve($rootScope.currentUser);
        }
        return deferred.promise;
      },
      sign: function(user, $scope) {
        var _this = this;
        if (!user || !user.phone) {
          return $ionicPopup.alert({
        title: '错误!',
        template: "请填写手机号！",
        okText: '确定'
      });
        }

        if (!user.password) {
          return $ionicPopup.alert({
        title: '错误!',
        template: "请填写密码",
        okText: '确定'
      });
        }
        if (!user.rPassword) {
          return $ionicPopup.alert({
        title: '错误!',
        template: "请填写重复密码！",
        okText: '确定'
      });
        }

        if (user.password != user.rPassword) {
          return $ionicPopup.alert({
        title: '错误!',
        template: "两次密码输入不一致，请确认！",
        okText: '确定'
      });
        }
        if (!user.vCode) {
          return $ionicPopup.alert({
        title: '错误!',
        template: "请填写手机验证码！",
        okText: '确定'
      });
        }
        getHttp({
            method: 'post',
            path: defConfig.path + '/regSubmit',
            params: user
          })
          .then(function(data) {
            if (data.result) {
              _this.loginStyle(data);
              $$localstorage.set('token', data.result.token);
              $state.reload();
              $ionicHistory.goBack();
            };
          }, function() {});
      },
      logout: function() {
        var _this = this;
        getHttp({
            method: 'get',
            path: defConfig.path + '/auth/logout'
          })
          .then(function(data) {
            //_this.loginStyle(data);
            $$localstorage.remove('token');
            $location.path('/');
            $timeout(function () {
              $window.location.reload(true);
            },100);
            
            
          });
      },
      loginStyle: function(data) {
        if (data.result && data.result.isLogin) {
          $rootScope.currentUser = data.result.member;
        } else {
          $rootScope.currentUser = null;
        }
      }
    };

  }])
  .factory('$ionicActionCustomSheet', [
  '$rootScope',
  '$compile',
  '$animate',
  '$timeout',
  '$ionicTemplateLoader',
  '$ionicPlatform',
  '$ionicBody',
  'IONIC_BACK_PRIORITY',
function($rootScope, $compile, $animate, $timeout, $ionicTemplateLoader, $ionicPlatform, $ionicBody, IONIC_BACK_PRIORITY) {

  return {
    show: actionSheet
  };
  
  
  /**
   * @ngdoc method
   * @name $ionicActionSheet#show
   * @description
   * Load and return a new action sheet.
   *
   * A new isolated scope will be created for the
   * action sheet and the new element will be appended into the body.
   *
   * @param {object} options The options for this ActionSheet. Properties:
   *
   *  - `[Object]` `buttons` Which buttons to show.  Each button is an object with a `text` field.
   *  - `{string}` `titleText` The title to show on the action sheet.
   *  - `{string=}` `cancelText` the text for a 'cancel' button on the action sheet.
   *  - `{string=}` `destructiveText` The text for a 'danger' on the action sheet.
   *  - `{function=}` `cancel` Called if the cancel button is pressed, the backdrop is tapped or
   *     the hardware back button is pressed.
   *  - `{function=}` `buttonClicked` Called when one of the non-destructive buttons is clicked,
   *     with the index of the button that was clicked and the button object. Return true to close
   *     the action sheet, or false to keep it opened.
   *  - `{function=}` `destructiveButtonClicked` Called when the destructive button is clicked.
   *     Return true to close the action sheet, or false to keep it opened.
   *  -  `{boolean=}` `cancelOnStateChange` Whether to cancel the actionSheet when navigating
   *     to a new state.  Default true.
   *  - `{string}` `cssClass` The custom CSS class name.
   *
   * @returns {function} `hideSheet` A function which, when called, hides & cancels the action sheet.
   */
  function actionSheet(opts) {
    var noop = function(){};
    var scope = $rootScope.$new(true);

    angular.extend(scope, {
      cancel: noop,
      destructiveButtonClicked: noop,
      buttonClicked: noop,
      $deregisterBackButton: noop,
      buttons: [],
      buttonsGroup: [],
      cancelOnStateChange: true
    }, opts || {});

    function textForIcon(text) {
      if (text && /icon/.test(text)) {
        scope.$actionSheetHasIcon = true;
      }
    }

    for (var x = 0; x < scope.buttons.length; x++) {
      textForIcon(scope.buttons[x].text);
    }
    textForIcon(scope.cancelText);
    textForIcon(scope.destructiveText);

    // Compile the template
    var element = scope.element = $compile('<ion-action-custom-sheet ng-class="cssClass" buttons="buttons"></ion-action-custom-sheet>')(scope);

    // Grab the sheet element for animation
    var sheetEl = angular.element(element[0].querySelector('.action-sheet-wrapper'));

    var stateChangeListenDone = scope.cancelOnStateChange ?
      $rootScope.$on('$stateChangeSuccess', function() { scope.cancel(); }) :
      noop;

    // removes the actionSheet from the screen
    scope.removeSheet = function(done) {
      if (scope.removed) return;

      scope.removed = true;
      sheetEl.removeClass('action-sheet-up');
      $timeout(function() {
        // wait to remove this due to a 300ms delay native
        // click which would trigging whatever was underneath this
        $ionicBody.removeClass('action-sheet-open');
      }, 400);
      scope.$deregisterBackButton();
      stateChangeListenDone();

      $animate.removeClass(element, 'active').then(function() {
        scope.$destroy();
        element.remove();
        // scope.cancel.$scope is defined near the bottom
        scope.cancel.$scope = sheetEl = null;
        (done || noop)();
      });
    };

    scope.showSheet = function(done) {
      if (scope.removed) return;

      $ionicBody.append(element)
                .addClass('action-sheet-open');

      $animate.addClass(element, 'active').then(function() {
        if (scope.removed) return;
        (done || noop)();
      });
      $timeout(function() {
        if (scope.removed) return;
        sheetEl.addClass('action-sheet-up');
      }, 20, false);
    };

    // registerBackButtonAction returns a callback to deregister the action
    scope.$deregisterBackButton = $ionicPlatform.registerBackButtonAction(
      function() {
        $timeout(scope.cancel);
      },
      IONIC_BACK_PRIORITY.actionSheet
    );

    // called when the user presses the cancel button
    scope.cancel = function() {
      // after the animation is out, call the cancel callback
      scope.removeSheet(opts.cancel);
    };

    scope.buttonClicked = function(index) {
      // Check if the button click event returned true, which means
      // we can close the action sheet
      if (opts.buttonClicked(index, opts.buttons[index]) === true) {
        scope.removeSheet();
      }
    };
    scope.buttonGroupClicked = function(index) {
      // Check if the button click event returned true, which means
      // we can close the action sheet
      if (opts.buttonGroupClicked(index, opts.buttonsGroup[index]) === true) {
        scope.removeSheet();
      }
    };

    scope.destructiveButtonClicked = function() {
      // Check if the destructive button click event returned true, which means
      // we can close the action sheet
      if (opts.destructiveButtonClicked() === true) {
        scope.removeSheet();
      }
    };

    scope.showSheet();

    // Expose the scope on $ionicActionSheet's return value for the sake
    // of testing it.
    scope.cancel.$scope = scope;

    return scope.cancel;
  }
}])
.factory('replyAssessFac', ['$ionicModal', 'defConfig', 'getHttp', '$ionicPopup', '$window', 
                            function ($ionicModal, defConfig, getHttp, $ionicPopup, $window) {
  return function ($scope) {
  $scope.openReplyAssessModal = function(id) {
        
      $ionicModal.fromTemplateUrl('templates/replyAssess.html', {
        scope: $scope
      }).then(function(loginModal) {
        $scope.replyAssessModal = loginModal;
        $scope.replyAssessModal.show();
        $scope.closeReplyAssessModal = function() {
          $scope.replyAssessModal.hide();
        };
        $scope.replyAssess = {};
        $scope.replyAssess.assessId = id;
        
        
        $scope.replyAssessSubmit = function () {
          getHttp({
            path: defConfig.path + '/auth/authReplyText',
            method:"post",
            params: $scope.replyAssess
          })
          .then(function (data) {
            if (data.result) {
              
              $ionicPopup.alert({
                title: '提示',
                template: "回复成功!",
                okText: '确定'
              }).then(function () {
                $scope.closeReplyAssessModal();
                //$scope.getAnswerContent();
                $window.location.reload(true);
              });
              
            }
            
          });
        };
        
      });
      

    };
  };
}])
.factory('jpushService',['$http','$window','$document',function($http,$window,$document){
  var jpushServiceFactory={};

  //var jpushapi=$window.plugins.jPushPlugin;

  //启动极光推送
  var _init=function(config){
    $window.plugins.jPushPlugin.init();
    //设置tag和Alias触发事件处理
    document.addEventListener('jpush.setTagsWithAlias',config.stac,false);
    //打开推送消息事件处理
    $window.plugins.jPushPlugin.openNotificationInAndroidCallback=config.oniac;
    
    
    
    var onOpenNotification = function(event){
      
            try{
              
              $window.plugins.jPushPlugin.setApplicationIconBadgeNumber(0);
//                var alertContent;
//                if(device.platform == "Android"){
//                    alertContent=window.plugins.jPushPlugin.openNotification.alert;
//                }else{
//                    alertContent   = event.aps.alert;
//                }
//                alert("open Notificaiton:"+alertContent);
                
            }
            catch(exception){
                //console.log("JPushPlugin:onOpenNotification"+exception);
            }
        };
    document.addEventListener("jpush.openNotification", onOpenNotification, false);
    
    
    
    $window.plugins.jPushPlugin.setApplicationIconBadgeNumber(0);
    //$window.plugins.jPushPlugin.setDebugMode(true);
  };
  //获取状态
  var _isPushStopped=function(fun){
    $window.plugins.jPushPlugin.isPushStopped(fun);
  };
  //停止极光推送
  var _stopPush=function(){
    $window.plugins.jPushPlugin.stopPush();
  };

  //重启极光推送
  var _resumePush=function(){
    $window.plugins.jPushPlugin.resumePush();
  };

  //设置标签和别名
  var _setTagsWithAlias=function(tags,alias){
    $window.plugins.jPushPlugin.setTagsWithAlias(tags,alias);
  };

  //设置标签
  var _setTags=function(tags){
    $window.plugins.jPushPlugin.setTags(tags);
  };

  //设置别名
  var _setAlias=function(alias){
    $window.plugins.jPushPlugin.setAlias(alias);
  };



  jpushServiceFactory.init=_init;
  jpushServiceFactory.isPushStopped=_isPushStopped;
  jpushServiceFactory.stopPush=_stopPush;
  jpushServiceFactory.resumePush=_resumePush;

  jpushServiceFactory.setTagsWithAlias=_setTagsWithAlias;
  jpushServiceFactory.setTags=_setTags;
  jpushServiceFactory.setAlias=_setAlias;

  return jpushServiceFactory;
}]);
