/*
 * angular-markdown-directive v0.3.1
 * (c) 2013-2014 Brian Ford http://briantford.com
 * License: MIT
 */

'use strict';

angular.module('btford.markdown', ['ngSanitize']).
  provider('markdownConverter', function () {
    var opts = {};
    return {
      config: function (newOpts) {
        opts = newOpts;
      },
      $get: function () {
        return new Showdown.converter(opts);
      }
    };
  })
  .factory('truncate', function () {
    return function strip_tags(input, allowed) {
      allowed = (((allowed || '') + '')
        .toLowerCase()
        .match(/<[a-z][a-z0-9]*>/g) || [])
        .join(''); // making sure the allowed arg is a string containing only tags in lowercase (<a><b><c>)
      var tags = /<\/?([a-z][a-z0-9]*)\b[^>]*>/gi,
        commentsAndPhpTags = /<!--[\s\S]*?-->|<\?(?:php)?[\s\S]*?\?>/gi;
      return input.replace(commentsAndPhpTags, '')
        .replace(tags, function($0, $1) {
          return allowed.indexOf('<' + $1.toLowerCase() + '>') > -1 ? $0 : '';
        });
    }
}).
  directive('btfMarkdown', ['$sanitize', 'markdownConverter', 'truncate', '$sce', function ($sanitize, markdownConverter, truncate, $sce) {
    return {
      restrict: 'AE',
      link: function (scope, element, attrs) {
        if (attrs.btfMarkdown) {
          scope.$watch(attrs.btfMarkdown, function (newVal) {
        	  try {
        		  var html = newVal ? $sanitize(markdownConverter.makeHtml(newVal.replace(/\n/g,'<br/>').replace('<widget id="','widget id="'))) : '';
//        		  var html = newVal ? $sanitize(markdownConverter.makeHtml(newVal.replace(/\n/g,'<br/>'))) : '';
                  element.html(html);
        	  }catch(exception){
        		  var html =$sce.trustAsHtml(newVal.replace(/\n/g,'<br/>'));
                  element.html(html);
        	  }
           
          });
        } else {
          var html = $sanitize(markdownConverter.makeHtml(element.text()));
          element.html(html);
        }
      }
    };
  }]);
